
#include "CommonDef.h"

extern unsigned long old_lan_ip;
extern int aiPort[3];

char *log_type_str[] = 
{
	"mgmt",
	"acl",
	"ddns"
};

char *log_id_str[] = 
{
	"Login ok",
	"Login fail",
	"Configuration corrupted, use system default!",
	"Factory reset by user!",
	"Logout ok",
	"Domain name resolve fail!",
	"No valid IP for registration!",
	"Update ok",	//DDNS_UPDATE_OK,
	"Invalid host name!",	//DDNS_INVALID_HOST,
	"Not FQDN!",	//DDNS_NOT_FQDN,
	"Not your domain name!",	//DDNS_NOT_YOURS,
	"Authentication failed!",		//DDNS_AUTH_FAIL,	
	"This domain has been blocked for abuse!",	//DDNS_ABUSE,
	"This useragent has been blocked!"	//DDNS_BAD_AGENT
};

void log(int type, int log_id, const char *msg)
{
	char buf[255];
	snprintf(buf,sizeof(buf),"%s: %s %c%s%c",
		log_type_str[type], log_id_str[log_id], 
		msg!=NULL ? '(' : ' ', msg!=NULL ? msg : ' ' , msg!=NULL ? ')' : ' ' );
	syslog(LOG_DAEMON, buf);
}

static BOOL WRChangePassword(const char *pcNewPassword)
{
	char acHttpPassword[64];	//here 24 should same as in the WR_CONFIG_PARAM_T

	MyStrncpy(acHttpPassword, pcNewPassword, sizeof(acHttpPassword));
	if (AuthSetUser("admin", acHttpPassword, AUTH_USER) == 0)
		return TRUE;
	else
		return FALSE;
}

#ifndef EMBED
int Add_Port(struct Alt_Port *wport)
{
	fprintf(stderr, "Add_Port: %s\n", wport->mport);
	return 0;
}

int Del_Port(struct Alt_Port *wport)
{
	fprintf(stderr, "Del_Port: %s\n", wport->mport);
	return 0;
}

int Reject_HTTP_Server()
{
	fprintf(stderr, "Reject_HTTP_Server\n");
	return 0;
}
#endif

BOOL ToggleAdminWan( int enable )
{
	char cmd[132];
	char action='I';
	
	action = enable ? 'I':'D';

	snprintf(cmd,sizeof(cmd),"ipt -%c SERVICE -i eth1 -p tcp -m tcp -d 0.255.0.255 --dport %u -j ACCEPT", action, aiPort[1] );
	iptables(cmd);
	snprintf(cmd,sizeof(cmd),"ipt -%c SERVICE -i ppp0 -p tcp -m tcp -d 0.255.0.255 --dport %u -j ACCEPT", action, aiPort[1] );
	iptables(cmd);
	snprintf(cmd,sizeof(cmd),"ipt -%c SERVICE -i ppp1 -p tcp -m tcp -d 0.255.0.255 --dport %u -j ACCEPT", action, aiPort[1] );
	iptables(cmd);
	snprintf(cmd,sizeof(cmd),"ipt -%c SERVICE -i ppp2 -p tcp -m tcp -d 0.255.0.255 --dport %u -j ACCEPT", action, aiPort[1] );
	iptables(cmd);

	return TRUE;
}

BOOL ToggleAdminLan( int enable )
{
	char cmd[132];
	char action='I';
	
	action = enable ? 'I':'D';

	snprintf(cmd,sizeof(cmd),"ipt -%c SERVICE -i eth0 -p tcp -m tcp -d 0.255.0.255 --dport %u -j ACCEPT", action, aiPort[0] );
	iptables(cmd);

	return TRUE;
}

BOOL ToggleDnsProxy(void)
{
	char cmd[132];
	char action='I';
	
	action = g_ConfigParam.bEnableDnsProxy ? 'I':'D';

	snprintf(cmd,sizeof(cmd),"ipt -%c SERVICE -i eth0 -p udp -m udp -d 0.255.0.255 --dport %u -j ACCEPT", action, 53 );
	iptables(cmd);

	dnsProxyInstall();

	return 0;
}

BOOL dnsProxyInstall(void)
{
	if( g_ConfigParam.bEnableDnsProxy)
	{
		service_install(1,"dns","-i","eth0",NULL);
	}
	else
		KillAllProc("dns");
	
	return 0;
}

BOOL ToggleUpnpLan( int enable )
{
	char cmd[132];
	char action='I';
	
	action = enable ? 'I' : 'D'; 

	/* may not use 0.255.0.255 as dest because SSDP packet will use 239.255.255.250 as dest,
	 * it may safe enough because we bundle this upnp rule with eth0 interface
	 */

	snprintf(cmd,sizeof(cmd),"ipt -%c SERVICE -i eth0 -p udp -m udp --dport %u  -j ACCEPT",action,1900);
	iptables(cmd);
	snprintf(cmd,sizeof(cmd),"ipt -%c SERVICE -i eth0 -p tcp -m tcp --dport %u -j ACCEPT",action, 55555 );
	iptables(cmd);
	
	/* turn on/off msn alg, because it conflict with UPNP */

	/* may not need again because msn_alg only handle winmsg ftp protocol only now */
	
	/*
	 * sysctl_write2( "/proc/sys/net/ipv4/msn_alg", enable ? 0 : 1 );
	 */
	return TRUE;
}

BOOL TogglePingLan( int enable )
{
	char cmd[132];
	char action='I';
	
	action = enable ? 'I' : 'D'; 

	snprintf(cmd,sizeof(cmd),"ipt -%c SERVICE -i eth0 -p icmp -m icmp -d 0.255.0.255 --icmp-type 8 -j ACCEPT",action );
	iptables(cmd);
	
	return TRUE;
}


BOOL TogglePingWan( int enable )
{
	char cmd[132];
	char action='I';
	
	action = enable ? 'I' : 'D';
		
	snprintf(cmd,sizeof(cmd),"ipt -%c SERVICE -i eth1 -p icmp -m icmp -d 0.255.0.255 --icmp-type 8 -j ACCEPT",action );
	iptables(cmd);
	snprintf(cmd,sizeof(cmd),"ipt -%c SERVICE -i ppp0 -p icmp -m icmp -d 0.255.0.255 --icmp-type 8 -j ACCEPT",action );
	iptables(cmd);
	snprintf(cmd,sizeof(cmd),"ipt -%c SERVICE -i ppp1 -p icmp -m icmp -d 0.255.0.255 --icmp-type 8 -j ACCEPT",action );
	iptables(cmd);
	snprintf(cmd,sizeof(cmd),"ipt -%c SERVICE -i ppp2 -p icmp -m icmp -d 0.255.0.255 --icmp-type 8 -j ACCEPT",action );
	iptables(cmd);

	return TRUE;
}


void WRSigUPNPError(int iSignal)
{
	WRConfigUPNP(FALSE,1);
	WRConfigUPNP(TRUE,1);
}

BOOL WRConfigUPNP(BOOL bIsEnable, BOOL force)
{
	BOOL bNow;
	int ret=0;
	
	SynProcess(&g_pidUpnp);
	bNow = (g_pidUpnp?TRUE:FALSE);

	if (bNow)
	{
		//SafeLimitKill(g_pidUpnp, SIGINT, 5000);
		if( force )
			KillAllProc("upnpd");
		else if( bIsEnable == bNow )
		{
			ToggleUpnpLan( bIsEnable );
			return g_pidUpnp;
		}
	}

	if (bIsEnable)
	{
		sleep(1);
	
		ret = RunProgram(&g_pidUpnp, "/bin/upnpd", "eth1" /* WRGetOuterNetworkInterface() */ , "eth0", NULL);
		//acl_rule_install(CHAIN_ME);
		ToggleUpnpLan( bIsEnable );
		
		return ret;
	}
	else
	{
		KillServicePID("upnpd");
		//KillAllProc("upnpd");  //cause system halt!!
		//ret = SafeLimitKill(g_pidUpnp, SIGINT, 5000);
		//acl_rule_install(CHAIN_ME);
		ToggleUpnpLan(bIsEnable);

		return ret;
	}
	return 0;
}

int Http_Admin(HTTPCONNECTION hConnection, void *pParam)
{
	char *pcFile;
	int i;
	char ac[8];
	char accFactoryWanMac[6][4];
	char aacLanMac[6][4];
	char aacWanMac[6][4];

	if (WRExternalAdmin(hConnection) == 0) return 0;
	if ((pcFile = GetRequestFilePath(hConnection)) == NULL) return 0;

	if (GetMacAddress(G_PC_ETH0, ac))
		for (i=0; i<6; i++)
			Char2Hex(ac[i], aacLanMac[i]);
	else
		for (i=0; i<6; i++)
			strcpy(aacLanMac[i], "??");

	if (GetMacAddress(G_PC_ETH1, ac))
	{
		for (i=0; i<6; i++)
			Char2Hex(ac[i], aacWanMac[i]);
	}
	else
	{
		for (i=0; i<6; i++)
			strcpy(aacWanMac[i], "??");
	}
	if(!g_ConfigParam.bWanMacReconfig)
	{	for (i=0; i<6; i++)
			Char2Hex( g_ConfigParam.acWanMacAddress[i] , aacWanMac[i]);	
	}
	// pass Factory Mac Address to ac[i]
	for(i=0; i<6; i++)
	{	
		Char2Hex(g_ConfigParam.acFactoryWanMacAddress[i] , accFactoryWanMac[i]);
	}

	SendHtmlWithParam(hConnection, pcFile,
		g_ConfigParam.acHttpPassword,
		aacLanMac[0],
		aacLanMac[1],
		aacLanMac[2],
		aacLanMac[3],
		aacLanMac[4],
		aacLanMac[5],
		accFactoryWanMac[0],
		accFactoryWanMac[1],
		accFactoryWanMac[2],
		accFactoryWanMac[3],
		accFactoryWanMac[4],
		accFactoryWanMac[5],
		aacWanMac[0],
		aacWanMac[1],
		aacWanMac[2],
		aacWanMac[3],
		aacWanMac[4],
		aacWanMac[5],
		(int)g_ConfigParam.bEnableUPNP,
		(int)g_ConfigParam.bEnableAdminLan,
		(int)g_ConfigParam.bEnableAdminWan,
		(int)g_ConfigParam.usExternalAdminPort,
		(int)g_ConfigParam.bEnableLogoutIdle,
		(int)g_ConfigParam.usLogoutIdle,
		(int)g_ConfigParam.bEnablePingLan,
		(int)g_ConfigParam.bEnablePingWan,
		(int)g_ConfigParam.bEnableDnsProxy,
		(int)g_ConfigParam.bWanMacReconfig,
		(int)g_ConfigParam.ulWanDuplex
		);

	return 0;
}



static int WRToBeReboot(HTTPCONNECTION hConnection, time_t *tLastFill, void *pParam)
{
	int fd = (*(int *)hConnection);

	fd_set rfd;
	struct timeval to;
	char buf[32];
	
	to.tv_sec = 0;
	to.tv_usec = 100;
	FD_ZERO(&rfd);
	FD_SET(fd, &rfd);
	if ((select(fd+1, &rfd, NULL, NULL, &to)) > 0 && FD_ISSET(fd, &rfd))
		read(fd, buf, sizeof buf);
	close(fd);

	WRReSetRouter();
	//halt;
	
	return 0;
}

int Http_Config_Factory_Reset(HTTPCONNECTION hConnection, void *pParam)
{
	unsigned long ulPrivateIP = 0L;
//	char acUrl[128];
	struct in_addr addr;
		
	/*
	WR_CONFIG_PARAM_T *pConfig = malloc(sizeof(WR_CONFIG_PARAM_T));
	if (pConfig != NULL)
	{
		if (ReadFactoryDefault(pConfig))
		ulPrivateIP = pConfig->ulPrivateIPAddress;
		free(pConfig);
	}
	*/
	if (ulPrivateIP == 0L) ulPrivateIP = String2IP("192.168.1.1");

	addr.s_addr = ulPrivateIP;
#ifdef NORTON_REDIRECT_PAGE2
	sprintf(acUrl,"Rebooting...<p>Please reconnect to %s after 1 minutes",
		inet_ntoa(addr));
	SetKeepAliveMode(hConnection, FALSE);
	SendReDirectPage2(hConnection, NULL, 60000, acUrl );
#endif

	WRSetFactoryDefault();
	sleep(1);
	SetSendDataOverFun(hConnection, WRToBeReboot, NULL);
	Http_Config_Reset(hConnection, pParam);
	
	return 0;
}

int Http_Config_Logout(HTTPCONNECTION hConnection, void *pParam)
{
	char buf[255];
	
	SetKeepAliveMode(hConnection, FALSE);
	
	snprintf(buf,sizeof(buf),"from %s", inet_ntoa( GetClientAddr(hConnection) ));
	log(LOG_MGMT, MGMT_LOGOUT_OK, buf );
	
	SendReDirectHtml(hConnection, "message.htm", "system_login.htm", TRUE, 1000, "logout...", "00000001" );
	
	return 0;
}


int Http_Config_Login(HTTPCONNECTION hConnection, void *pParam)
{
	LIST *pList;
	const char *user;
	const char *pass;
	char buf[255];

	snprintf(buf,sizeof(buf),"from %s", inet_ntoa(GetClientAddr(hConnection)));

	pList = (LIST *)pParam;
	user = GetString(pList, "user");
	pass = GetString(pList, "pass");
	
	if( user && pass && strcmp(user,"admin")==0 )
	{
		if( auth_check( hConnection, user, pass ) )
		{
			log( LOG_MGMT, MGMT_LOGIN_OK, buf );
			SendReDirectMain(hConnection);
			return 0;
		}
	}
	log( LOG_MGMT, MGMT_LOGIN_FAIL, buf );

//#define LOGIN_FAIL_MSG	"<center>Incorrect username or password, please try again!</center>"
		
	SendReDirectHtml(hConnection, "message.htm", "system_login.htm", 1, 3000, "LOGIN_FAIL_MSG", "00000000" );
	
	return 0;
}

int Http_Config_Admin(HTTPCONNECTION hConnection, void *pParam)
{
	LIST *pList;
	BOOL bIsChange;
	int i;
	char ac[30];

	/* Config params */
	const char *pcHttpPassword;
#ifdef ADMIN_LAN
	BOOL bEnableAdminLan;
#endif
	BOOL bEnableAdminWan;
	BOOL bEnableUPNP;
	BOOL bEnableDnsProxy;
	BOOL bEnableLogoutIdle;
	unsigned short usLogoutIdle;
	BOOL bEnablePingLan;
	BOOL bEnablePingWan;
	int	ulWanDuplex = 0;
	
#ifdef WINBOND_EXTERN_PORT
	unsigned short usExternalAdminPort;
#endif
	char acLanMacAddress[6];
	char acWanMacAddress[6];

	pList = (LIST *)pParam;

	/* Read page parameters. */
	pcHttpPassword = GetString(pList, "Txt_AdminPasswd");
#ifdef ADMIN_LAN
	bEnableAdminLan = GetBool(pList, "WR_EnableAdminLan");
#endif
	bEnableAdminWan = GetBool(pList, "WR_EnableAdminWan");
	bEnablePingLan = GetBool(pList, "WR_EnablePingLan");
	bEnablePingWan = GetBool(pList, "WR_EnablePingWan");
	bEnableUPNP = GetBool(pList, "WR_EnableUPNP");
	bEnableDnsProxy = GetBool(pList, "WR_EnableDnsProxy");
	bEnableLogoutIdle = GetBool(pList, "WR_EnableLogoutIdle");
	usLogoutIdle = GetLong(pList, "Num_LogoutIdle");
	ulWanDuplex = GetLong(pList, "wanDuplex");
	
	//usExternalAdminPort = (unsigned short)GetLong(pList, "Num_ExternalAdminPort");
	for (i = 0; i < sizeof(acLanMacAddress) / sizeof(char); i++)
	{
		sprintf(ac, "Txt_PrivateMACAddress%d", i);
		acLanMacAddress[i] = Hex2Char(GetString(pList, ac));
	}
	for (i = 0; i < sizeof(acWanMacAddress) / sizeof(char); i++)
	{
		sprintf(ac, "Txt_ClonePublicMACAddress%d", i);
		acWanMacAddress[i] = Hex2Char(GetString(pList, ac));
	}

	/* Config */
	bIsChange = FALSE;

		if( ulWanDuplex != g_ConfigParam.ulWanDuplex )
		{
			SetWanDuplex( ulWanDuplex );
			g_ConfigParam.ulWanDuplex = ulWanDuplex;
			bIsChange = TRUE;
		}

		if (pcHttpPassword[0] != '\0' && strcmp(pcHttpPassword, g_ConfigParam.acHttpPassword) != 0)
		{
			if (WRChangePassword(pcHttpPassword))
			{
				MyStrncpy(g_ConfigParam.acHttpPassword, pcHttpPassword, sizeof(g_ConfigParam.acHttpPassword));
				//WebLog(CL_PRIVILEGE_ADMIN, CL_SET_USER, NULL, hConnection);
				bIsChange = TRUE;
			}
		}

		if (!GetMacAddress(G_PC_ETH0, ac)
			|| memcmp(ac, acLanMacAddress, sizeof(acLanMacAddress) / sizeof(char)) != 0)
		{
			if (SetMacAddress(G_PC_ETH0, acLanMacAddress))
			{
				g_ConfigParam.bLanMacReconfig = TRUE;
				memcpy(g_ConfigParam.acLanMacAddress, acLanMacAddress, sizeof(acLanMacAddress) / sizeof(char));
				//WebLog(CL_PRIVILEGE_ADMIN, CL_SET_MAC, NULL, hConnection);
				bIsChange = TRUE;
			}
		}
		BOOL bWanMacReconfig  = GetBool(pList, "WR_WanMacReconfig");

		if( !bWanMacReconfig  )
		{
			memcpy(acWanMacAddress, g_ConfigParam.acFactoryWanMacAddress, sizeof(acWanMacAddress) / sizeof(char));
		}
		if ( (!GetMacAddress(G_PC_ETH1, ac) || 
			memcmp(ac, acWanMacAddress, sizeof(acWanMacAddress) / sizeof(char)) )!= 0 ||
			bWanMacReconfig != g_ConfigParam.bWanMacReconfig )
		{
			int iPPPoEState = WRGetPPPoEState();
#ifdef WINBOND_MODEM
			int iModemState = WRGetModemState();
			PTI;
#endif
			SendPPPoECommand(ALL_ID,PPPOE_CMD_RESET);
			//PTI;
#ifdef WINBOND_MODEM
			SendModemCommand(MODEM_CMD_RESET);
			PTI;
#endif

			if (g_ConfigParam.ulHowToGetIp == GETIP_DHCP)
				WRStopDHCPClient();

			if (SetMacAddress(G_PC_ETH1, acWanMacAddress))
			{
				//PTI;
				if(bWanMacReconfig)
				{
				g_ConfigParam.bWanMacReconfig = TRUE;
				memcpy(g_ConfigParam.acWanMacAddress, acWanMacAddress, sizeof(acWanMacAddress) / sizeof(char));
				}	
				else
					g_ConfigParam.bWanMacReconfig = FALSE;
				//WebLog(CL_PRIVILEGE_ADMIN, CL_SET_MAC, NULL, hConnection);
				bIsChange = TRUE;
			}

			if (g_ConfigParam.ulHowToGetIp == GETIP_DHCP)
				WRRunDHCPClient();

			//PTI;
#ifdef WINBOND_MODEM
			switch (iModemState)
			{
			case MODEM_COMM_ON:
			case MODEM_COMM_TRYING:
				PTI;
				SendModemCommand(MODEM_CMD_CONNECT);
				PTI;
				break;
			case MODEM_DOD_ON:
			case MODEM_DOD_TRYING:
			case MODEM_DOD_OFF:
				PTI;
				SendModemCommand(MODEM_CMD_DOD);
				PTI;
				break;
			default:;
			}

			PTI;
#endif
			switch (iPPPoEState)
			{
			case PPPOE_COMM_ON:
			case PPPOE_COMM_TRYING:
				//PTI;
				SendPPPoECommand(ALL_ID,PPPOE_CMD_CONNECT);
				//PTI;
				break;
			case PPPOE_DOD_ON:
			case PPPOE_DOD_TRYING:
			case PPPOE_DOD_OFF:
			case PPPOE_DOD_WAITING:
				//PTI;
				SendPPPoECommand(ALL_ID,PPPOE_CMD_DOD);
				//PTI;
				break;
			default:;
			}
		}

#ifdef WINBOND_EXTERN_PORT
		if (usExternalAdminPort != g_ConfigParam.usExternalAdminPort)
		{
			g_ConfigParam.usExternalAdminPort = usExternalAdminPort;
			bIsChange = TRUE;
		}
#endif

		if (usLogoutIdle != g_ConfigParam.usLogoutIdle)
		{
			g_ConfigParam.usLogoutIdle = usLogoutIdle;
			bIsChange = TRUE;
		}

		if (bEnableLogoutIdle != g_ConfigParam.bEnableLogoutIdle)
		{
			g_ConfigParam.bEnableLogoutIdle = bEnableLogoutIdle;
			bIsChange = TRUE;
		}

		if (bEnableAdminWan != g_ConfigParam.bEnableAdminWan)
		{

			ToggleAdminWan(bEnableAdminWan);
			g_ConfigParam.bEnableAdminWan = bEnableAdminWan;
			bIsChange = TRUE;
		}
#ifdef ADMIN_LAN
		if (bEnableAdminLan != g_ConfigParam.bEnableAdminLan)
		{

			ToggleAdminLan(bEnableAdminLan);
			g_ConfigParam.bEnableAdminLan = bEnableAdminLan;
			bIsChange = TRUE;
		}
#endif

		if (g_ConfigParam.bEnablePingLan != bEnablePingLan )
		{
			TogglePingLan( bEnablePingLan );
			g_ConfigParam.bEnablePingLan = bEnablePingLan;
			bIsChange = TRUE;
		}

		if (g_ConfigParam.bEnablePingWan != bEnablePingWan )
		{
			TogglePingWan( bEnablePingWan );
			g_ConfigParam.bEnablePingWan = bEnablePingWan;
			bIsChange = TRUE;
		}

		if (g_ConfigParam.bEnableDnsProxy != bEnableDnsProxy )
		{
			g_ConfigParam.bEnableDnsProxy = bEnableDnsProxy;
			ToggleDnsProxy();
			bIsChange = TRUE;
		}
		
		if (bEnableUPNP != g_ConfigParam.bEnableUPNP)
		{
			WRConfigUPNP(bEnableUPNP, 0);
			g_ConfigParam.bEnableUPNP = bEnableUPNP;
			bIsChange = TRUE;
		}

	set_logout_idle( g_ConfigParam.bEnableLogoutIdle , g_ConfigParam.usLogoutIdle );
	if (bIsChange) WriteFlashMemory(&g_ConfigParam);

	SetKeepAliveMode(hConnection, FALSE);
	SendReDirectPage(hConnection);

	return 0;
}

int Http_Config_Reset(HTTPCONNECTION hConnection, void *pParam)
{
	LIST *pList = (LIST *)pParam;
	const char *pcUrl;
	BOOL bShowTime;
	int iTime_InMSec;
	const char *pcInfo;
	int iFactoryReset = 0;
	
	/* Read page parameters. */
	pcUrl = GetString(pList, "RedirectUrl");
	bShowTime = GetBool(pList, "ShowTime");
	iTime_InMSec = GetLong(pList, "Time_InMSec");
	pcInfo = GetString(pList, "Info");

	iFactoryReset = GetLong(pList, "FactoryReset");
	if ( iFactoryReset == 1 )
	{
		pcInfo = "MSG_FACTORY_RESET";	/* system_reboot.htm could not get bFactoryReset. Therefore, this codition should be false*/
	}
	SetKeepAliveMode(hConnection, FALSE);
#ifdef NORTON
	SendReDirectPage2(hConnection, pcUrl, bShowTime, iTime_InMSec, pcInfo );
#else
	SendReDirectHtml(hConnection, "Redirect.htm", pcUrl, bShowTime, iTime_InMSec, pcInfo, NULL );
#endif
	usleep(30 * 1000);//for lesser than 20000, usleep do not really sleep.
	SetSendDataOverFun(hConnection, WRToBeReboot, NULL);
	
	return 0;
}

static int Http_Show_Cmd_Buffer(HTTPCONNECTION hConnection, char *pcBuf)
{
	FILE *fp = NULL;
	int iCount;
	int j=0, x=0;

	iCount = 0;
	iCount += sprintf(pcBuf+iCount, "var va_result = new Array(\n");

	if( (fp=fopen("/swap/cmd.txt","rt")) !=NULL )
	{
		while( (fgets(pcBuf+iCount+1,300,fp)) )
		{
			*(pcBuf+iCount) = '\'';
			j = strlen(pcBuf+iCount);
			for(x=0; x<3; x++)
			{
				if( *(pcBuf+iCount+j-x) == '\r' || *(pcBuf+iCount+j-x) == '\n' )
					j--;
			}
			if( j > 256 )
			{
				*(pcBuf+iCount+256) = 0;
				j = 127;
			}
			iCount += j;
			iCount += sprintf(pcBuf+iCount,"',\r\n");
		}
		fclose(fp);
	}

	iCount += sprintf(pcBuf+iCount,"\n'0');");

	return iCount;
}

int Http_Show_Cmd(HTTPCONNECTION hConnection, void *pParam)
{
	char *pcFile;

	if (WRExternalAdmin(hConnection) == 0) return 0;
	if ((pcFile = GetRequestFilePath(hConnection)) == NULL) return 0;

	SendHtmlWithParam(hConnection, pcFile, Http_Show_Cmd_Buffer );

	return 0;
}


int Http_Config_Cmd(HTTPCONNECTION hConnection, void *pParam)
{
	LIST *pList = (LIST *)pParam;
	const char *cmd;
        char buf[255];
        FILE *fr, *fw;

	/* Read page parameters. */
	cmd = GetString(pList, "cmd");

        fr = popen(cmd, "r");
        fw = fopen("/swap/cmd.txt", "w");
        while(!feof(fr))
        {
                fgets(buf, sizeof(buf), fr);
                fwrite(buf, 1, strlen(buf), fw);
        }
        fclose(fr);
        fclose(fw);

	SetKeepAliveMode(hConnection, FALSE);
	SendReDirectPage(hConnection);
	
	return 0;
}

