#ifndef COMMONDEF_H
#define COMMONDEF_H


#ifndef BOOL
#define BOOL int	//same as in C_String.h
#define TRUE 1
#define FALSE 0
#endif

#define MIN_VALID_MTU	536

#define CONFIG_FLASH_OFFSET	0x7F1F0000
#define RTF_USR1	0x8000	/* refer to  linux/route.h */

#define MAX_DNS_SERVER 		3
#define MAX_URL_FILTER_ITEM 	20
#define MAX_IP_PORT_FILTER_ITEM 51	/* 1 entry for rule move */
#define MAX_POLICY_DOMAIN	30

#define MAX_VIRTUAL_HOST_ITEM 	10
#define MAX_STATIC_ROUTING_ITEM 20
#define MAX_SPECIAL_APP_ITEM 	10
#define MAX_PPPOE_AND_UNNUM	3
#define MAX_PPPOE_NAME_LEN	64	/* brl04gp require 64 bytes */
#define MAX_HOSTNAME_LEN		32
#define MAX_DOMAIN_NAME_LEN	20
#define MAX_PASSWD_LEN	64		/* brl04gp require 64 bytes */
#define MAX_SERVICE_LEN	32
#define MAX_AC_LEN			32

#define UNNUM_ID		0
#define PPPOE_ID		0x0f
#define ALL_ID			0xff

#define PROTOCOL_ALL 		((char)0)
#define PROTOCOL_TCP 		((char)1)
#define PROTOCOL_UDP 		((char)2)
#define PROTOCOL_TCP_AND_UDP 	((char)3)
#define PROTOCOL_ICMP		((char)4)
#define PROTOCOL_IGMP		((char)5)
#define PROTOCOL_AH		((char)6)
#define PROTOCOL_ESP		((char)7)

#define ROUTING_DISABLE 	((char)0)
#define ROUTING_RIP1 		((char)1)
#define ROUTING_RIP2 		((char)2)
#define ROUTING_RIP1_COMPATIBLE ((char)3)

#define NET_WAN ((char)0)
#define NET_LAN ((char)1)
#define NET_ERR ((char)-1)

#define GETIP_MAN 0
#define GETIP_DHCP 1
#define GETIP_PPP 2
#define GETIP_UNNUM 3

#define PROG_PPPOE	"pppoecd"	//pppd
#define PROG_UPNP	"upnpd"
#define PROG_DNS	"dns"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <stdarg.h>
#include <signal.h>
#include <sys/types.h>
#include <dirent.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <net/if.h>
#include <net/if_arp.h>
#include <net/if_ppp.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <net/route.h>
#include <unistd.h>
#include <asm/unistd.h>
#include <pthread.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <ctype.h>
#include <syslog.h>
	   
#include "HttpServer.h"
#include "aos_fw.h"
#include "dos_conf.h"

enum log_type_t { 
	LOG_MGMT=0, 
	LOG_ACL = 1,
	LOG_DDNS=2
};

enum log_id_t { 
	MGMT_LOGIN_OK=0, 
	MGMT_LOGIN_FAIL= 1,
	MGMT_CONFIG_ERROR=2,
	MGMT_FACTORY_RESET=3,
	MGMT_LOGOUT_OK=4,
	DDNS_RESOLV_FAIL=5,
	DDNS_NO_IP=6,
	DDNS_UPDATE_OK=7,
	DDNS_INVALID_HOST=8,
	DDNS_NOT_FQDN=9,
	DDNS_NOT_YOURS=10,
	DDNS_AUTH_FAIL=11,
	DDNS_ABUSE,
	DDNS_BAD_AGENT
};


typedef struct
{
	unsigned long ulIP;
	unsigned long ulNetmask;
	unsigned int  updateDhcp;
} FOR_CHANGE_IP_T;

#ifdef WINBOND_IPFW

typedef struct
{
	unsigned long ulIPAddressFrom;
	unsigned long ulIPAddressTo;
	unsigned short usPortFrom;
	unsigned short usPortTo;
	unsigned short ausPortOther[4];
	char cProtocolType;	/* PROTOCOL_TCP, PROTOCOL_UDP or PROTOCOL_TCP_AND_UDP */

} LANIPFILTERITEM_T; 

#endif

typedef struct
{
	unsigned char chain;	/* CHAIN_IN=0,CHAIN_OUT=1,CHAIN_ME=3 */
	unsigned char op;	/* OP_ADD=0,OP_INS=1,OP_DEL=2,OP_EDIT=3 */
	unsigned short id;	/* rule num */
	unsigned char srctype;	/* ANY, IP,SUBNET,RANGE */
	unsigned long src;
	unsigned long smsk;
	unsigned char dsttype;	/* ANY, IP,SUBNET,RANGE */
	unsigned long dst;
	unsigned long dmsk;
	unsigned char sporttype; /* ANY, PORT, RANGE */
	unsigned int  sport[2];  /* range */
	unsigned char dporttype; /* ANY, PORT, RANGE */
	unsigned int  dport[2];  /* range */
	unsigned char proto;
	unsigned char action;
	unsigned char icmptype;
	unsigned char log;
	unsigned char route[IFNAMSIZ+1];
#ifdef XX
	unsigned char srcdomain[64];
#endif
	unsigned char dstdomain[64];

}  fw_acl; 


typedef struct 
{
	char va_gmt[16];
	int va_enable;
	int va_mday;
	int va_mon;
	int va_year;
	int va_hour;
	int va_min;
	int va_sec;
	char va_sntp0[16];
	char va_sntp1[16];
	char va_sntp2[16];
	
}  fw_timezone; 

#define VS_ACTIVE(x)		(x.bActive_Log_BypassAcl & 0x001)
#define VS_LOG(x)		(x.bActive_Log_BypassAcl & 0x002)
#define VS_BYPASSACL(x)	(x.bActive_Log_BypassAcl & 0x004)

#define VS_SET_ACTIVE(x)		(x ? 0x001 : 0)
#define VS_SET_LOG(x)			(x ? 0x002 : 0)
#define VS_SET_BYPASSACL(x)		(x ? 0x004 : 0)

typedef struct
{
	unsigned long ulIPAddress;
	unsigned short usPortFrom;
	unsigned short usPortTo;
	char cProtocolType;
	unsigned short bActive_Log_BypassAcl;
	/* enum { VS_ACTIVE=0x0001, VS_LOG=0x0002, VS_BYPASSACL=0x0004 } */

}  VIRTUALHOSTITEM_T; 

typedef struct
{
	unsigned long ulDestLanIPAddress;
	unsigned long ulSubnetMask;
	unsigned long ulDefaultGateway;
	long lMetric;
	char cNetInterface[8];	/* NET_WAN or NET_LAN */

}  ROUTINGTABLE_T; 

typedef struct
{
	char acAppName[20];
	unsigned short usInPortFrom;
	unsigned short usInPortTo;
	unsigned short usOutPortFrom;
	unsigned short usOutPortTo;
	BOOL bIsActivated;

}  SPECIALAPPLICATION_T; 

typedef struct
{
	int	      enable;
	unsigned long startip;
	unsigned long endip;
	unsigned long subnet;
	unsigned long leasetime;
	unsigned long wins;
	unsigned long wins1;
	unsigned long dns;
	unsigned long dns1;
	unsigned long defgw;
	
}  DHCP_T; 

typedef struct	/* changing this struct have to have the struct used by pppd together */
{
	BOOL enable;
	BOOL demand;
	char user[MAX_PPPOE_NAME_LEN];
	char pass[MAX_PASSWD_LEN];
	char acname[MAX_AC_LEN];
	char srvname[MAX_SERVICE_LEN];
	unsigned long idle;
	unsigned long network;	/* unnumber */
	unsigned long loc_addr;	/* unnumber */
	unsigned long netmask; 	/* unnumber */
	unsigned long dnsaddr[2];
	char pad[12];
	
}  PPPOE_T; 


typedef struct
{
	/* BasicSetup.htm */
	char acHostName[MAX_HOSTNAME_LEN];
	char acDomainName[MAX_DOMAIN_NAME_LEN];
	
	unsigned long synflood_threshold;
	unsigned long udpflood_threshold;
	unsigned long icmpflood_threshold;

	unsigned long ulPrivateIPAddress;
	unsigned long ulPrivateSubnetMask;
	unsigned long ulHowToGetIp;	/* 0 - static, 1 - ppp, 2 - dhcp */
	unsigned long ulPublicIpAddress;
	unsigned long ulPublicSubnetMask;
	unsigned long ulDefaultGateway;
	unsigned long aulDNSServer[MAX_DNS_SERVER];
	
	fw_timezone tz;
	
	/* Dhcp.htm */
	DHCP_T dhcp;
	
	unsigned short fw_dos[DOS_LAST];
	unsigned short fw_nat;  /* enable/disable */
	unsigned short fw_rule; /* enable/disable */
	
	fw_acl fw_acl_cur;
	fw_acl fw_acl_pool[MAX_IP_PORT_FILTER_ITEM];
	int fw_acl_in[MAX_IP_PORT_FILTER_ITEM];
	int fw_acl_out[MAX_IP_PORT_FILTER_ITEM];
	int fw_acl_me[MAX_IP_PORT_FILTER_ITEM];
	
	/* Vserver.htm */
	VIRTUALHOSTITEM_T avVirtualHostItem[MAX_VIRTUAL_HOST_ITEM];

	/* Admin.htm */
	char acHttpPassword[64];
	char acLanMacAddress[6];
	char acWanMacAddress[6];	/* clone wan mac */
	BOOL bLanMacReconfig;
	BOOL bWanMacReconfig;
	
	unsigned short usLogoutIdle;
	unsigned short usExternalAdminPort;
	
	BOOL bEnableDnsProxy;
	BOOL bEnableAdminLan;
	BOOL bEnableAdminWan;
	BOOL bEnableUPNP;
	BOOL bEnableLogoutIdle;
	BOOL bEnablePingLan;
	BOOL bEnablePingWan;
	
	char acFactoryWanMacAddress[6]; /* original factory wan mac */
	unsigned char bEnableNaptUnnum;
	unsigned short usMtu;	/* share with pppoe/dhcp/static, otherwise no space for them to make consistent with old version  */
	unsigned char ulWanDuplex;
	char pad2[11];

	/* SRouter.htm */
	ROUTINGTABLE_T arRoutingTableItem[MAX_STATIC_ROUTING_ITEM];

	/* PPPoE.htm */
	PPPOE_T	pppoeConf[MAX_PPPOE_AND_UNNUM];
	
#ifdef WINBOND_MODEM
	/* Modem.htm */
	BOOL bEnableModem;
	BOOL bEnableModemAutoConnect;
	char acModemUserName[64];
	char acModemUserPass[64];
	char acModemPhone[64];
	unsigned long ulModemDisConnectTime_InSec;
#endif

#ifdef WINBOND_PPTP
	/* VPN.htm */
	BOOL bEnableVPN;
	BOOL bEnableVPNAutoConnect;
	char acVPNUserName[64];
	char acVPNUserPass[64];
	char acVPNHostName[64];
	unsigned long ulVPNDisConnectTime_InSec;
#endif
	/* SpecialApp.htm */
	SPECIALAPPLICATION_T asSpecialAppItem[MAX_SPECIAL_APP_ITEM];

#ifdef WINBOND_DDNS
	BOOL bEnableDDNS;
	char acDDNSUserName[64];
	char acDDNSUserPass[64];
	char acDDNSDomainName[64];
	char acProxyUser[12];
	char acProxyPass[12];
	char acProxy[24];
#endif
	unsigned long ulCheckSum;

}  WR_CONFIG_PARAM_T; 

typedef struct
{
#define FIRMWARE_STOP 0
#define FIRMWARE_UPLOADING 1
#define FIRMWARE_FLASHING 2
	int iFlashUpdateState;
	int iFlashWriteSize;
	int iFlashWriteTotalSize;

#define DO_DDNS_NO_UPDATE 0
#define DO_DDNS_UPDATING 1
#define DO_DDNS_UPDATE_OK 2
#define DO_DDNS_UPDATE_FAIL 3

	int iDDNSState;

	int iPort[2];
}  WR_RUNTIME_STATE; 


struct d_config{
	char start[48];
	char end[48];
	char dns[48];
	char subnet[48];
	char router[48];
	char wins[48];
	char lease[48];
}; 


#define CA_CONFIG 0
#define CA_AUTH 1

#define MSG_NONE 			-1
#define MSG_CUSTOM_PROC 		0L
#define MSG_QUIT 			6L
#define MSG_FLASH_CONFIG_WRITE 		15L
#define MSG_FLASH_FIRMWARE_UPDATE 	16L
#define MSG_ADD_FD 			18L


#define MAX_POST_LENGTH 		(10*1024)
#define MAX_CONFIG_POST_LENGTH 		2048
#define PROC_ROUTE_FILE 		"/proc/net/route"
#define DHCP_LEASE_FILE 		"/swap/udhcpd.leases"
#define MAX_LOG_ITEM 			200

#ifdef EMBED
#define FILE_UPLOAD_DIR_IN_HTML "/usr"
#define FACTORY_DEFAULT_FILE "/etc/WRConfig.ini"
#define FLASH_CONFIG_FILE "/config/WRConfig"
#define DEBUG_CONFIG_FILE "/swap/WRConfigDebug.ini"
#define HOSTS_FILE "/swap/hosts"
#define DHCP_INIT_CONFIG_FILE "/etc/udhcpd.conf"
#define DHCP_CONFIG_FILE "/swap/udhcpd.conf"
#define DHCP_STATUS_FILE "/swap/.dstatus"
#define MY_PID_LOG "/swap/httpd_id"
#define FLASH_UPDATE_TMP_FILE "/swap/Firmware.bin"
#define CONFIG_UPDATE_TMP_FILE "/swap/config.cfg"
#define PPPOE_CONF_FILE	"/swap/.pppd_info"
#define MODEM_CONF_FILE "/swap/.modem_info"
#define VPN_CONF_FILE "/swap/.pptp_info"
#define DHCP_CLIENT_INFO_FILE "/swap/.dhcpc_info"
#define FIRMWARE_UPDATE_LIMIT_SIZE ((1024+1024)*1024)
#define FILE_UPLOAD_LIMIT_SIZE (1*1024*1024)
#define FILE_UPLOAD_DEFAULT_DIR "/usr"
#define PRINT_SERVER_INFO "/swap/PrintServerWebData"
#else
#define FILE_UPLOAD_DIR_IN_HTML "Config/"
#define FACTORY_DEFAULT_FILE "Config/WRConfig.ini"
#define FLASH_CONFIG_FILE "Config/WRConfig"
#define DEBUG_CONFIG_FILE "Config/WRConfigDebug.ini"
#define HOSTS_FILE "Config/hosts"
#define DHCP_INIT_CONFIG_FILE "Config/Unknown_Init"
#define DHCP_CONFIG_FILE "Config/Unknown_Config"
#define DHCP_STATUS_FILE "Config/Unknown_Status"
#define MY_PID_LOG "Config/httpd_id"
#define FLASH_UPDATE_TMP_FILE "Config/Firmware.bin"
#define CONFIG_UPDATE_TMP_FILE "Config/config.cfg"
#define PPPOE_CONF_FILE "Config/Unknown_pppd_info"
#define MODEM_CONF_FILE "Config/Unknown_modem_info"
#define VPN_CONF_FILE "Config/Unknown_pptp_info"
#define DHCP_CLIENT_INFO_FILE "Config/Unknown_dhcpc_info"
#define FIRMWARE_UPDATE_LIMIT_SIZE (102*(1024+512)*1024)
#define FILE_UPLOAD_LIMIT_SIZE (2*1024*1024)
#define FILE_UPLOAD_DEFAULT_DIR "Config"
#define PRINT_SERVER_INFO "../printservermutex/PrintServerWebData"
#endif

#include "iptables.h"
#include "pppd.h"
#include "packet.h"
#include "Utility.h"
#include "Msg.h"
#include "Select.h"
#include "Firmware.h"
#include "FlashCtl.h"
#include "HttpClient.h"
#include "UdpServer.h"
#include "Version.h"
#include "Convert.h"
#include "RouterConfig.h"
#include "HttpInfo.h"
#include "System.h"
#include "Vserver.h"
#include "Admin.h"
#include "Upload.h"
#include "Status.h"
#include "DHCPTable.h"
#include "RouterTable.h"
#include "PPPoE.h"
#include "SpecialApp.h"
#include "ddns.h"
#include "timezone.h"
#include "system_setup.h"
#include "system_info.h"
#include "dhcp.h"
#include "acl_rule.h"
#include "log_table.h"
#include "backup.h"
#include "service.h"

//#include "Stat.h"
//#include "WebLog.h"
//#include "Modem.h"
//#include "VPN.h"
//#include "SRouter.h"
//#include "BasicSetup.h"
//#include "Expose.h"


extern WR_CONFIG_PARAM_T g_ConfigParam;
extern pid_t g_pidSnifferLan;
extern pid_t g_pidSnifferWan;
extern pid_t g_pidDhcpClient;
extern pid_t g_pidUpnp;
extern time_t tTimeServerStart;
extern WR_RUNTIME_STATE g_RunTimeState;

extern pthread_t g_ptdFlash;
extern MSG_QUEUE *g_pMsgFlash;
extern pthread_t g_ptdSelect;	/* pthread_t for SelectThread */
extern MSG_QUEUE *g_pMsgSelect;	/* message queue for SelectThread */

#endif
