#define CONVERT_C
#include "CommonDef.h"

char GetIPProtocol(const char *pcVal)
{
	char cRt;
	char *pc;
	pc = GetTrimString(pcVal);

	if (strcasecmp(pc, "TCP") == 0) cRt = PROTOCOL_TCP;
	else if (strcasecmp(pc, "UDP") == 0) cRt = PROTOCOL_UDP;
	else if (strcasecmp(pc, "TCPUDP") == 0) cRt = PROTOCOL_TCP_AND_UDP;
	else if (strcasecmp(pc, "UDPTCP") == 0) cRt = PROTOCOL_TCP_AND_UDP;
	else cRt = PROTOCOL_ALL;

	free(pc);
	return cRt;
}

const char *GetIPProtocolString(char cIPProtocol)
{
	if (cIPProtocol == PROTOCOL_ALL) return "ALL";
	else if (cIPProtocol == PROTOCOL_TCP) return "TCP";
	else if (cIPProtocol == PROTOCOL_UDP) return "UDP";
	else if (cIPProtocol == PROTOCOL_TCP_AND_UDP) return "TCPUDP";
	else return "";
}

char GetRoutingProtocol(const char *pcVal)
{
	char cRt;
	char *pc;
	pc = GetTrimString(pcVal);

	if (strcasecmp(pc, "RIP1") == 0) cRt = ROUTING_RIP1;
	else if (strcasecmp(pc, "RIP2") == 0) cRt = ROUTING_RIP2;
	else if (strcasecmp(pc, "RIP1-Compatible") == 0) cRt = ROUTING_RIP1_COMPATIBLE;
	else cRt = ROUTING_DISABLE;

	free(pc);
	return cRt;
}

const char *GetRoutingProtocolString(char cRoutingProtocol)
{
	if (cRoutingProtocol == ROUTING_DISABLE) return "Disable";
	else if (cRoutingProtocol == ROUTING_RIP1) return "RIP1";
	else if (cRoutingProtocol == ROUTING_RIP2) return "RIP2";
	else if (cRoutingProtocol == ROUTING_RIP1_COMPATIBLE) return "RIP1-Compatible";
	else return "";
}

char GetNetInterface(const char *pcVal)
{
	char *pc;
	char cRt;
	pc = GetTrimString(pcVal);

	if (strcasecmp(pc, "WAN") == 0) cRt = NET_WAN;
	else if (strcasecmp(pc, "LAN") == 0) cRt = NET_LAN;
	else cRt = NET_ERR;

	free(pc);
	return cRt;
}

const char *GetNetInterfaceString(char cNetInterface)
{
	if (cNetInterface == NET_WAN) return "WAN";
	else if (cNetInterface == NET_LAN) return "LAN";
	else return "";
}

long IPSub(unsigned long ulIP1, unsigned long ulIP2)
{
	return (long)(ntohl(ulIP1) - ntohl(ulIP2));
}

unsigned long IPAdd(unsigned long ulIP, long lAddValue)
{
	return htonl(ntohl(ulIP) + (unsigned long)lAddValue);
}

unsigned long IPMask(unsigned long ulIP, unsigned long ulIPRef, unsigned long ulMask)
{
	return ( ulIPRef & ulMask ) | (ulIP & ~ulMask);
}
