#include "CommonDef.h"

static BOOL WRReadDHCPTable(DHCP_TABLE_ITEM_T **ppItem, int *piCount)
{
	char *pcFileBuf;
	int iFileLength;
	int iCount;
	int i;

	if (!(ReadWholeFile(DHCP_LEASE_FILE, &pcFileBuf, &iFileLength)))
		return FALSE;

	iCount = iFileLength / (sizeof(DHCP_TABLE_ITEM_T));
	if (iCount<=0)
	{/* ûжõ */
		free(pcFileBuf);
		return FALSE;
	}

	*ppItem = (DHCP_TABLE_ITEM_T *)pcFileBuf;
	*piCount = iCount;

	return TRUE;
}

static int WRWriteDHCPTableArgument(HTTPCONNECTION hConnection, char *pcBuf)
{
	DHCP_TABLE_ITEM_T *pItem;
	int iItemCount;
	int i, j;
	int iCount;
	char ac[16];

	if (!WRReadDHCPTable(&pItem, &iItemCount))
	{
		pItem = NULL;
		iItemCount = 0;
	}

	iCount = 0;
	IP2String(GetIPAddress(G_PC_ETH0), ac);
	iCount += sprintf(pcBuf+iCount, "var va_DefaultGateway = '%s';\n", ac);
	iCount += sprintf(pcBuf+iCount, "var va_ComputerName = new Array(\n");
	for (i=0; i<iItemCount; i++)
		iCount += sprintf(pcBuf+iCount, "'-',\n");
	iCount += sprintf(pcBuf+iCount, "'');\nvar va_ComputerIP = new Array(\n");
	for (i=0; i<iItemCount; i++)
	{
		IP2String(pItem[i].yiaddr, ac);
		iCount += sprintf(pcBuf+iCount, "'%s',\n", ac);
	}
	iCount += sprintf(pcBuf+iCount, "'');\nvar va_ComputerMACAddress = new Array(\n");
	for (i=0; i<iItemCount; i++)
	{
		iCount += sprintf(pcBuf+iCount, "'");
		for (j=0; j<6; j++)
		{
			Char2Hex(pItem[i].chaddr[j], ac);

			if (j < 5)
				iCount += sprintf(pcBuf+iCount, "%s-", ac);
			else
				iCount += sprintf(pcBuf+iCount, "%s", ac);
		}
		iCount += sprintf(pcBuf+iCount, "',\n");
	}
	iCount += sprintf(pcBuf+iCount, "'');\n");

	if (pItem != NULL) free(pItem);

	return iCount;
}

int Http_DHCPTable(HTTPCONNECTION hConnection, void *pParam)
{
	char *pcFile;

	if (WRExternalAdmin(hConnection) == 0) return 0;
	if ((pcFile = GetRequestFilePath(hConnection)) == NULL) return 0;

	SendHtmlWithParam(hConnection, pcFile,
		WRWriteDHCPTableArgument
		);

	return 0;
}
