#ifndef FIRMWARE_H
#define FIRMWARE_H

#define MODEL_RX3141_EN		0x0410
#define MODEL_GX1104PS_EN	0x0411
#define MODEL_BRL04GP_JP	0x0417
#define MODEL_BRL04GP_EN	0x0418

typedef struct FirmWare{
	unsigned int magic;
	unsigned int version;
	unsigned int flag;
	unsigned int model;	/* brl-04gp: 0x0417, rx3141: 0x3141 */
	unsigned int pad2;
	unsigned int pad3;
	unsigned int pad4;
	unsigned int length_bin;
	unsigned int length_img;
	unsigned long sum;
}FirmWare;

#define BINZIP	0x00000001
#define IMGZIP	0x00000002

//#define GENBIN_MAGIC 0x47454E42
#define GENBIN_MAGIC	0x01b9a37b
#define GENROM_MAGIC	0x01b90119

#define ISBINZIP(flag)	 ((flag)&0x00000001)
#define ISBINUNZIP(flag) !((flag)&0x00000001)
#define ISIMGZIP(flag)	 ((flag)&0x00000002)
#define ISIMGUNZIP(flag) !((flag)&0x00000002)

#endif

