#ifndef HTTPCLIENT_H
#define HTTPCLIENT_H

typedef struct
{
	char acHostSmallBuf[512];
	char *pcExtraBuffer;
	struct hostent *psHostent;
} HOST_INFO_T;
HOST_INFO_T *ResolveHost(HOST_INFO_T *pHostInfo, const char *pcServer);
void DeleteHost(HOST_INFO_T *pHostInfo);

struct tagHTTPC;
typedef BOOL (*HTTPC_RESPONSE)(struct tagHTTPC *pHttpFD, char *pcResponse, int iLen);
typedef void (*HTTPC_REQUEST_OVER)(struct tagHTTPC *pHttpFD);
typedef struct tagHTTPC
{
	OBJHEADER oHeader;
	FD_T fd;
	time_t tLastOp;
	time_t tConnTimeout;
	HOST_INFO_T hostInfo;
	char **ppcHost;

	char *pcServer;
	char *pcPath;
	int iPort;
	char *pcHost;
	char *pcUserAgent;
	char *pcUser;
	char *pcPass;
	char *pcProxy;
	char *pcProxyUser;
	char *pcProxyPass;
	HTTPC_RESPONSE pfunOnResponse;
	HTTPC_REQUEST_OVER pfunOnRequestOver;
	int iLenTotal;
	int iLenOK;
	char acBuffer[1024];
} HTTPC;
OBJHEADER *HTTPC_Init(OBJHEADER *pObj, va_list vaInit);
void HTTPC_Final(OBJHEADER *pObj);

void Do_DDNS(const char *pcHost,
			unsigned long ulIP,
			const char *pcUser,
			const char *pcPass,
			const char *pcProxy,
			const char *pcProxyUser,
			const char *pcProxyPass);

#endif
