
#include "CommonDef.h"

#ifdef EMBED
#include "thcfg.h"
#if 0//new thread lib
struct thread_cfg thcfg={
	each_thread_pages: 4
};
#else
struct thread_cfg thcfg={
	manager_stack_size:8*1024,
	each_thread_stack_size:16*1024,
	main_thread:32*1024
};
#endif
#endif

WR_CONFIG_PARAM_T g_ConfigParam;
pid_t g_pidDhcpClient;
pid_t g_pidUpnp;
extern time_t tTimeServerStart;
int aiPort[] = {80, 8080, 0 }; /* first one is for LAN, second one is for WAN */
extern unsigned int factory_reset; /* defined in boa */
int resetButton=0;
unsigned int g_model_id = 0;
char g_model_name[32];

WR_RUNTIME_STATE g_RunTimeState;

pthread_t g_ptdFlash;
MSG_QUEUE *g_pMsgFlash;

pthread_t g_ptdSelect;
MSG_QUEUE *g_pMsgSelect;

void ResetSignalHandle(int iSignal)
{
	//Http_SetFactoryDefault(0, 0);
	WRSetFactoryDefault();
	WRReSetRouter();
	return;
}

#define RESETSIGNAL	36
#ifdef EMBED
static inline _syscall1(long, setresetpid, int, pid);
#else
long setresetpid(int pid)
{
	printf("Kernel received pid = %d\n", pid);
	return 0;
}
#endif


void InitSignalProc()
{
	struct sigaction action;

/*
	action.sa_handler = WRSigChildDie;
	sigprocmask(SIG_SETMASK, NULL, &action.sa_mask);
	action.sa_flags = 0;
	sigaction(SIGCHLD, (void*)&action, NULL);
*/
	signal(SIGCHLD, SIG_IGN);

	action.sa_handler = WRSigSetRuleConnected;
	sigprocmask(SIG_SETMASK, NULL, &action.sa_mask);
	action.sa_flags = 0;
	sigaction(SIGPWR, (void*)&action, NULL);	//dhcp dial up done

	action.sa_handler = WRSigSetRuleConnected;
	sigprocmask(SIG_SETMASK, NULL, &action.sa_mask);
	action.sa_flags = 0;
	sigaction(SIGWINCH, (void*)&action, NULL);	//pppoe dial up done

	action.sa_handler = WRSigSetRuleConnected;
	sigprocmask(SIG_SETMASK, NULL, &action.sa_mask);
	action.sa_flags = 0;
	sigaction(SIGIO, (void*)&action, NULL);

	action.sa_handler = WRSigPPPChanged;
	sigprocmask(SIG_SETMASK, NULL, &action.sa_mask);
	action.sa_flags = 0;
	sigaction(32, (void*)&action, NULL);	// SIGRTMIN

	action.sa_handler = WRSigUPNPError;
	sigprocmask(SIG_SETMASK, NULL, &action.sa_mask);
	action.sa_flags = 0;
	sigaction(40, (void*)&action, NULL);

	action.sa_handler = ResetSignalHandle;
	sigprocmask(SIG_SETMASK, NULL, &action.sa_mask);
	action.sa_flags = 0;
	sigaction(RESETSIGNAL, (void*)&action, NULL);

	signal(SIGUSR1, WRSigSetRuleConnected );
	signal(SIGUSR2, WRSigSetRuleConnected );
	
	signal(SIGINT, WRSIGTERM);
	signal(SIGTERM, WRSIGTERM);

	setresetpid(getpid());
	
}

void ResetOtherApp()
{
	pid_t pidMe = getpid();
	FILE *fp;
	if ((fp = fopen(MY_PID_LOG, "wb")) == NULL)
	{
		fprintf(stderr, "Can not write my pid to %s.\n", MY_PID_LOG);
		exit(0);
	}
	fwrite(&pidMe, sizeof(pidMe), 1, fp);
	fclose(fp);

	KillAllProc(PROG_PPPOE);
}

void ResetOtherThread()
{
	/* set message and thread for selecting fd */
	if ((g_pMsgSelect = CreateMsgQueue(0, TRUE)) == NULL)
	{
		//fprintf(stderr, "Can not create message queue for SelectThread!\n");
		exit(-1);
	}
	if (pthread_create(&g_ptdSelect, NULL, &SelectThread, NULL) != 0)
	{
		//fprintf(stderr, "Thread for \"Select\" creation failed!\n");
		exit(-1);
	}

	/* set message and thread for flash */
	if ((g_pMsgFlash = CreateMsgQueue(0, FALSE)) == NULL)
	{
		//fprintf(stderr, "Can not create message queue for FtpThread!\n");
		exit(-1);
	}
	if (pthread_create(&g_ptdFlash, NULL, &FlashThread, NULL) != 0)
	{
		//fprintf(stderr, "Thread for ftp creation failed!\n");
		exit(-1);
	}
}

/* use update_time_for_zone()  instead of update_conf()

#define TZFILE "/swap/tz"

void update_conf()
{
	FILE *fp;

	if( (fp=fopen(TZFILE,"wt"))!=NULL)
	{
		fwrite(g_ConfigParam.tz.va_gmt,strlen(g_ConfigParam.tz.va_gmt),1,fp);
		fclose(fp);
	}
	
}
*/


void ResetRouterParam_BeforeHttpService()
{
	memset(&g_ConfigParam, 0, sizeof(g_ConfigParam));
	
	if (!ReadFlashMemory(&g_ConfigParam))
	{
		if( resetButton == 0 )
			log(LOG_MGMT, MGMT_CONFIG_ERROR, NULL );
		
		fprintf(stderr, "Use factory-default config\n");
		if (!ReadFactoryDefault(&g_ConfigParam))
		{
			exit(-1);
		}
		dos_default();
		factory_reset = 1;
	}

	if( g_ConfigParam.synflood_threshold == 0 )
		g_ConfigParam.synflood_threshold = SYNFLOODTHRESH;
	if( g_ConfigParam.udpflood_threshold == 0 )
		g_ConfigParam.udpflood_threshold = UDPFLOODTHRESH;
	if( g_ConfigParam.icmpflood_threshold == 0 )
		g_ConfigParam.icmpflood_threshold = ICMPFLOODTHRESH;


	/* mac */
	GetMacAddress(G_PC_ETH0, g_ConfigParam.acLanMacAddress);
	GetMacAddress( G_PC_ETH1, g_ConfigParam.acFactoryWanMacAddress );	/* get factory mac */
	if ( factory_reset ) 
		memcpy(g_ConfigParam.acWanMacAddress, g_ConfigParam.acFactoryWanMacAddress, sizeof(g_ConfigParam.acFactoryWanMacAddress) );
	
	if (!InitNetInterface("eth0"))
		fprintf(stderr, "Can not activate eth0!\n");

	if (!InitNetInterface("eth1"))
		fprintf(stderr, "Can not activate eth1!\n");

	InitNetInterface("lo");

	if( g_ConfigParam.ulWanDuplex != 0 ) /* not default auto neg */
	{
		SetWanDuplex( g_ConfigParam.ulWanDuplex );
	}

	if (g_ConfigParam.bLanMacReconfig)
		SetMacAddress(G_PC_ETH0, g_ConfigParam.acLanMacAddress);
	if (g_ConfigParam.bWanMacReconfig)
		SetMacAddress(G_PC_ETH1, g_ConfigParam.acWanMacAddress);

	SetGeneralIP("lo", 0x0100007F, 0x000000FF);
	//update_conf();
	set_time_by_param(2000,1,1,0,0,0);
	
	if( ( g_ConfigParam.ulPrivateIPAddress | g_ConfigParam.ulPrivateSubnetMask ) ==  0 )
	{
		g_ConfigParam.ulPrivateIPAddress = 0xc0a80101;
		g_ConfigParam.ulPrivateSubnetMask = 0xffffff00;
	}

	if (!SetGeneralIP(G_PC_ETH0, g_ConfigParam.ulPrivateIPAddress, g_ConfigParam.ulPrivateSubnetMask))
	{
		fprintf(stderr, "Can not set IP and netmask on %s.\n", G_PC_ETH0);
		exit(-1);
	}
	NotifyLocalIP2Nat();
	route_install();
}


void ResetRouterParam_AfterHttpService()
{
	acl_init();	
	policy_install();
	if( factory_reset )
	{
		fwrule_default();
		WriteFlashMemory(&g_ConfigParam);
	}
	acl_install();		/* should before wan_service() */

	WRConfigSpecialApp(g_ConfigParam.asSpecialAppItem);
	WRConfigVserver(g_ConfigParam.avVirtualHostItem, TRUE);
	ToggleAdminLan(g_ConfigParam.bEnableAdminLan);
	ToggleAdminWan(g_ConfigParam.bEnableAdminWan);
	TogglePingLan(g_ConfigParam.bEnablePingLan);
	TogglePingWan(g_ConfigParam.bEnablePingWan);

	AuthSetUser("admin", g_ConfigParam.acHttpPassword, AUTH_USER);
	EnableUserCheck(TRUE);
	
	g_ConfigParam.usMtu = getSysMtu( g_ConfigParam.ulHowToGetIp, g_ConfigParam.usMtu );
	
	if (g_ConfigParam.ulHowToGetIp == GETIP_MAN)
	{
		SetMtu( G_PC_ETH1, g_ConfigParam.usMtu);
		
		if (!SetGeneralIP(G_PC_ETH1,
			g_ConfigParam.ulPublicIpAddress,
			g_ConfigParam.ulPublicSubnetMask))
			fprintf(stderr, "1: Can not set IP and netmask on %s.\n", G_PC_ETH1);

		if (!SetGateway(G_PC_ETH1, g_ConfigParam.ulDefaultGateway))
			fprintf(stderr, "Can not set default gateway.");

		if (!SetDNSServer(g_ConfigParam.aulDNSServer))
			fprintf(stderr, "Can not set dns.");
		WRSetOuterNetworkInterface(G_PC_ETH1);
		wan_service(0);
	}
	else if (g_ConfigParam.ulHowToGetIp == GETIP_DHCP)
	{
		SetMtu( G_PC_ETH1, g_ConfigParam.usMtu);
		/* Run DHCP client to get IP addr */
		RunProgram(&g_pidDhcpClient, "/bin/dhcpc", "-h", getHostname(), NULL);
		//WRRunDHCPClient();
		WRSetOuterNetworkInterface(G_PC_ETH1);
	}
	else if (g_ConfigParam.ulHowToGetIp == GETIP_PPP)
	{
		WRSetOuterNetworkInterface("ppp1");
		WRRunPPPoEClient(PPPOE_ID);
	}
	else if (g_ConfigParam.ulHowToGetIp == GETIP_UNNUM )
	{
		WRSetOuterNetworkInterface("ppp0");
		WRRunPPPoEClient(UNNUM_ID);
	}

	WRConfigUPNP(g_ConfigParam.bEnableUPNP,0);
	set_logout_idle( g_ConfigParam.bEnableLogoutIdle , g_ConfigParam.usLogoutIdle );

	ToggleDnsProxy();
	dos_install();
	ntp_install();
	dhcpd_install();

#ifdef WINBOND_DHCP

	if (WRIsEnableDHCPServer() != g_ConfigParam.bEnableDHCPServer)
	{
		WREnableDHCPServer(g_ConfigParam.bEnableDHCPServer);
	}

	unsigned long ulDHCPAddressTo;
	unsigned long ulDHCPAddressFrom;
	if (!WRGetDHCPInfo(&ulDHCPAddressFrom, &ulDHCPAddressTo, NULL, NULL, NULL, NULL)
		|| (ulDHCPAddressFrom != g_ConfigParam.ulDHCPAddressFrom || ulDHCPAddressTo != g_ConfigParam.ulDHCPAddressTo) )
		WRSetDHCPAddressRange(g_ConfigParam.ulDHCPAddressFrom, g_ConfigParam.ulDHCPAddressTo);

#endif

#ifdef WINBOND_ORIG
	/* Advance.htm */
	WRConfigDosDefense(g_ConfigParam.bEnableDosDefense, g_ConfigParam.ulDosRatePerHour);
	WRConfigHidePubIP(g_ConfigParam.bEnableHidePubIP);
	WREnableLanMonitor(g_ConfigParam.bEnableLanMonitor);
	WREnableWanMonitor(g_ConfigParam.bEnableWanMonitor);
#endif
	
}

int OnListenSocketCreate(int fd, int iPort)
{
	struct ifreq interface;
	const char *pcInterface;

#if 1	//lsshi 2003-7-28 17:08

	if (80 == iPort)
	{
		pcInterface = "eth0";
		strncpy(interface.ifr_ifrn.ifrn_name, pcInterface, IFNAMSIZ);
		if (setsockopt(fd, SOL_SOCKET, SO_BINDTODEVICE,(char *)&interface, sizeof(interface)) < 0)
			fprintf(stderr, "Can not bind %s!\n", pcInterface);
	}
	else pcInterface = "eth1";


#endif

	return 0;
}

int OnHttpInit(HTTPSERVER hServer)
{
	/* http server initilized, add your code here */

	ResetRouterParam_AfterHttpService();
	CreateUDPServer(INADDR_ANY, 55535);	//69
	tTimeServerStart = time(0);
	
	return 0;
}


void RegisterSubCmd(const char *pcCmd, SUBCMD_PFUN funData)
{
	RegisterEmbedFunEx(pcCmd, Http_SubCmdInit, AUTH_ANY, (void *)funData);
}


void RegisterUrls()
{
#ifdef DEBUG
	RegisterEmbedFun("GetConfig.cgi", Http_GetConfig, NULL);
	RegisterEmbedFun("GetPPPoE.cgi", Http_GetPPPoE, NULL);
	RegisterEmbedFun("GetModem.cgi", Http_GetModem, NULL);
	RegisterEmbedFun("GetVPN_Debug.cgi", Http_GetVPN, NULL);
	RegisterEmbedFun("ps.cgi", Http_Shell_Ps, NULL);
	RegisterEmbedFun("ps", Http_Shell_Ps, NULL);
#endif
	RegisterEmbedFun("acl_in.htm", get_acl_in, NULL);
	RegisterEmbedFun("acl_out.htm", get_acl_out, NULL);
	RegisterEmbedFun("acl_me.htm", get_acl_me, NULL);
	RegisterEmbedFun("acl_rule.htm", get_acl_rule, NULL);
	RegisterEmbedFunEx("post_acl_rule", Http_Post_Init, AUTH_ANY, post_acl_rule);

	RegisterEmbedFun("timezone.htm", get_timezone, NULL);
	RegisterEmbedFunEx("timezone", Http_Post_Init, AUTH_ANY, post_timezone);
	
	RegisterEmbedFun("system_setup.htm", get_system_setup, NULL);
	RegisterEmbedFunEx("post_system_setup", Http_Post_Init, AUTH_ANY, post_system_setup);

	RegisterEmbedFun("system_info.htm", get_system_info,NULL);
	RegisterEmbedFun("system_main.htm", get_system_main,NULL);
	RegisterEmbedFun("main.htm", get_system_info,NULL);

	RegisterEmbedFun("sysinfo", sysinfo, NULL );
	RegisterEmbedFunEx("postinfo", Http_Post_Init, AUTH_ANY, postinfo );

	RegisterEmbedFun("log_table.htm", get_log_table, NULL);

	RegisterEmbedFunEx("system_reset", Http_Post_Init, AUTH_ANY, Http_Config_Factory_Reset );
	RegisterEmbedFunEx("system_reboot", Http_Post_Init, AUTH_ANY, Http_Config_Reset );
	RegisterEmbedFunEx("system_login", Http_Post_Init, AUTH_ANY, Http_Config_Login );
	RegisterEmbedFunEx("system_logout", Http_Post_Init, AUTH_ANY, Http_Config_Logout );

	RegisterEmbedFunEx("system_backup", Http_Post_Init, AUTH_ANY, Http_Config_Backup );
	RegisterEmbedFunEx("system_restore", Http_Post_Init, AUTH_ANY, Http_Post_ConfigUpload );

	RegisterEmbedFun("system_admin.htm", Http_Admin, NULL);
	RegisterEmbedFunEx("ConfigAdmin", Http_Post_Init, AUTH_ANY, Http_Config_Admin);

	RegisterEmbedFun("cmd.htm", Http_Show_Cmd, NULL);
	RegisterEmbedFunEx("ConfigCmd", Http_Post_Init, AUTH_ANY, Http_Config_Cmd);

	RegisterEmbedFunEx("Upload.cgi", Http_Post_Init, AUTH_ANY, Http_Config_Upload); /* useless ?? */
	RegisterEmbedFunEx("FMUpload.cgi", Http_Post_Init, AUTH_ANY, Http_Post_FMUpload);
	RegisterEmbedFun("FMUpProcess.htm", Http_FMUpProcess, NULL);

	RegisterEmbedFun("route_table.htm", Http_RouterTable, NULL);
	RegisterEmbedFunEx("ConfigSRouter", Http_Post_Init, AUTH_ANY, Http_Config_SRouter);

	RegisterEmbedFun("dhcp_table.htm", Http_DHCPTable, NULL);
	RegisterEmbedFun("dhcp.htm", get_dhcp, NULL);
	RegisterEmbedFunEx("post_dhcp", Http_Post_Init, AUTH_ANY, post_dhcp);

	RegisterEmbedFun("virtual_srv.htm", Http_Vserver, NULL);
	RegisterEmbedFunEx("ConfigVserver", Http_Post_Init, AUTH_ANY, Http_Config_Vserver);

	RegisterEmbedFun("special_ap.htm", Http_SpecialApp, NULL);
	RegisterEmbedFunEx("ConfigSpecialApp", Http_Post_Init, AUTH_ANY, Http_Config_SpecialApp);

	RegisterEmbedFun("fw_general.htm", get_dos_conf, NULL);
	RegisterEmbedFunEx("dos_conf", Http_Post_Init, AUTH_ANY, post_dos_conf );

	RegisterEmbedFun("ddns.htm", get_ddns, NULL);
	RegisterEmbedFunEx("post_ddns", Http_Post_Init, AUTH_ANY, post_ddns);

#ifdef WINBOND_ORIG

	RegisterEmbedFun("*/BasicSetup.htm", Http_BasicSetup, NULL);
	RegisterEmbedFunEx("ConfigBasicSetup", Http_Post_Init, AUTH_ANY, Http_Config_BasicSetup);

	RegisterEmbedFun("*/Dhcp.htm", Http_Dhcp, NULL);
	RegisterEmbedFunEx("ConfigDhcp", Http_Post_Init, AUTH_ANY, Http_Config_Dhcp);
	RegisterEmbedFun("*/UrlFilter.htm", Http_UrlFilter, NULL);
	RegisterEmbedFunEx("ConfigUrlFilter", Http_Post_Init, AUTH_ANY, Http_Config_UrlFilter);

	RegisterEmbedFun("*/IpPortFilter.htm", Http_IpPortFilter, NULL);
	RegisterEmbedFunEx("ConfigIpPortFilter", Http_Post_Init, AUTH_ANY, Http_Config_IpPortFilter);


	RegisterEmbedFunEx("Upload.cgi", Http_Post_Init, AUTH_ANY, Http_Config_Upload);
	RegisterEmbedFun("*/FMUpProcess.htm", Http_FMUpProcess, NULL);
	RegisterEmbedFunEx("FMUpload.cgi", Http_Post_Init, AUTH_ANY, Http_Post_FMUpload);

	RegisterEmbedFun("*/Modem.htm", Http_Modem, NULL);
	RegisterEmbedFunEx("ConfigModem", Http_Post_Init, AUTH_ANY, Http_Config_Modem);

	RegisterEmbedFun("*/PrintServer.htm", Http_PrintServer, NULL);

	RegisterEmbedFun("*/Status.htm", Http_Status, NULL);
	RegisterEmbedFun("GetStatData.cgi", Http_StatData, NULL);

	RegisterEmbedFun("*/Admin.htm", Http_Admin, NULL);
	RegisterEmbedFunEx("ConfigAdmin", Http_Post_Init, AUTH_ANY, Http_Config_Admin);
	RegisterEmbedFunEx("ConfigReboot", Http_Post_Init, AUTH_ANY, Http_Config_Reset);

	RegisterEmbedFun("*/PPPoE.htm", Http_PPPoE, NULL);
	RegisterEmbedFunEx("ConfigPPPoE", Http_Post_Init, AUTH_ANY, Http_Config_PPPoE);

	RegisterEmbedFun("*/Expose.htm", Http_Expose, NULL);
	RegisterEmbedFunEx("ConfigExpose", Http_Post_Init, AUTH_ANY, Http_Config_Expose);

	RegisterEmbedFun("*/VPN.htm", Http_VPN, NULL);
	RegisterEmbedFunEx("ConfigVPN", Http_Post_Init, AUTH_ANY, Http_Config_VPN);
	RegisterEmbedFun("*/Log.htm", Http_GetLog, NULL);
#endif

	RegisterSubCmd("__SetRulesInHttpdThread__.cgi", Config_SetRules);
	RegisterEmbedFunEx("Cmd.cgi", Http_CommonCmdInit, AUTH_ANY, NULL);
}


void EscapeInitProcess()
{
	if ((pid_t)1 == getpid())
	{
		if (0 == vfork())
		{
			;
		}
		else
			while (1) pause();
	}
}

int OnRequestBegin(HTTPCONNECTION hConnection, void *pParam)
{
	return 1;
}

int Enable_IPFORWARD()
{
	FILE* fp;

	fp=fopen("/proc/sys/net/ipv4/ip_forward","w");
	
	if(fp==NULL)
		return 0;
	
	fprintf(fp,"%d",1);
	fclose(fp);
	
	return 1;
}

int main(int argc, char **argv)
{
	char *pcDocRoot = "/etc/ConfigPage";
	int iPortNumInCmdLine = 0;
	int i;
	volatile unsigned int iValue = 0;

	/*
	{
		iValue = *((volatile unsigned int *)0xfff82124);
		printf("[0x%08x]=%04x\n", 0xfff82124, iValue );
		
		iValue = *((volatile unsigned int *)0xfff83004);
		printf("[0x%08x]=%04x\n", 0xfff83004, iValue );
		
		iValue = *((volatile unsigned int *)0xfff83008);
		printf("[0x%08x]=%04x\n", 0xfff83008, iValue );
		
		iValue = *((volatile unsigned int *)0xfff8300C);
		printf("[0x%08x]=%04x\n",0xfff8300C, iValue);
		
	}
	*/

	//ref to kernel timer.c:do_timer() 
	//W90740ResetWatchDogTimer(); /* norton : test for watchdog timer result in repeatly reboot */

	/*
	{
		iValue = *((volatile unsigned int *)0xfff82124);
		printf("[0x%08x]=%04x\n", 0xfff82124, iValue );
		
		iValue = *((volatile unsigned int *)0xfff83004);
		printf("[0x%08x]=%04x\n", 0xfff83004, iValue );
		
		iValue = *((volatile unsigned int *)0xfff83008);
		printf("[0x%08x]=%04x\n", 0xfff83008, iValue );
		
		iValue = *((volatile unsigned int *)0xfff8300C);
		printf("[0x%08x]=%04x\n",0xfff8300C, iValue);
	}
	*/
	
	EscapeInitProcess();

	for (i = 1; i < argc; i++)
	{
		if (i + 1 < argc && strcmp(argv[i], "-d") == 0)
			pcDocRoot = argv[++i];
		if (i + 1 < argc && strcmp(argv[i], "-p") == 0)
		{
			if (iPortNumInCmdLine <= 1)
				aiPort[iPortNumInCmdLine++] = String2Long(argv[++i]);
		}
	}
	/* Save http port */
	g_RunTimeState.iPort[0] = aiPort[0];
	g_RunTimeState.iPort[1] = aiPort[1];

	ReadConfig(FACTORY_DEFAULT_FILE);

	fprintf(stderr,"product %s version %s\n", WRGetProductName(), WRGetProductVersion());
	fprintf(stderr,"config size: %ld flash offset: 0x%04x\n", sizeof(WR_CONFIG_PARAM_T), CONFIG_FLASH_OFFSET);

	Enable_IPFORWARD();
	InitSignalProc();
	
	ResetOtherThread();
	ResetOtherApp();
	/* test factory reset */
	resetButton = *((volatile unsigned int *)0x7ff0);
	if( resetButton )
	{
		printf(" - factory reset...!\n");
		log(LOG_MGMT, MGMT_FACTORY_RESET, NULL );
		WRSetFactoryDefault();
		WRSetFactoryDefault(); //write twice to make sure!
		sleep(1);
		//W90740Reboot();	
	}
	//openlog("mgmt", LOG_NDELAY, LOG_DAEMON);
	
	ResetRouterParam_BeforeHttpService();
	RegisterUrls();
	
	init_extensions();

	RunProgram(NULL, "/bin/klogd", NULL);
	RunProgram(NULL, "/bin/syslogd", NULL);

	SetAuthPrompt("Welcome to ASUS RX3141 Gateway", NULL, NULL);
	StartThttpdEx2(pcDocRoot, aiPort, 3600, 30 * 60 * 60, -1, OnListenSocketCreate, OnHttpInit, OnRequestBegin);


	return 0;
}
