#ifndef MSG_H
#define MSG_H

typedef struct
{
	unsigned int uiValue;
	pthread_mutex_t ptm;
	pthread_cond_t ptc;
} EMU_sem_t;

typedef struct
{
	long lMsg;
	long lData;
} MSG_T;

typedef struct
{
	LIST *plMsgList;
	int iMaxMsgLimit;
	EMU_sem_t sMsgSemProducer;	/* semphone for msg producer */
	EMU_sem_t sMsgSemConsumer;	/* semphone for msg consumer */
	pthread_mutex_t ptmMsg;	/* mutex for mail producer & consumer */

	BOOL bFDEvent;	/* if send msg event by file descriptor, for select */
	int aiFD[2];
} MSG_QUEUE;

MSG_QUEUE *CreateMsgQueue(int iMaxMsgLimit, BOOL bFDEvent);
void FreeMsgQueue(MSG_QUEUE *pMsgQueue);
BOOL SendMsg(MSG_QUEUE *pMsgQueue, MSG_T *pMsg);
BOOL GetMsg(MSG_QUEUE *pMsgQueue, MSG_T *pMsg);
BOOL TrySendMsg(MSG_QUEUE *pMsgQueue, MSG_T *pMsg);
BOOL TryGetMsg(MSG_QUEUE *pMsgQueue, MSG_T *pMsg);
/* check if pMsg exists in pMsgQueue. */
BOOL IsMsgExist(MSG_QUEUE *pMsgQueue, MSG_T *pMsg);


#include "Select.h"
/* for a fd trigger to function select. */
typedef struct
{
	OBJHEADER oHeader;
	FD_T fd;
	MSG_QUEUE *pMsgQueue;
	MSG_T *pMsg;
} SELECT_MSG;
OBJHEADER *SELECT_MSG_Init(OBJHEADER *pObj, va_list vaInit);
void SELECT_MSG_Final(OBJHEADER *pObj);

#endif
