
#include "CommonDef.h"
//#include "linux/route.h"

#define PROC_ROUTE_FILE_LINE_LEN 128

static int writePending = 0;

#ifdef WINBOND_ROUTE
static BOOL WRWriteRouterTable(PROC_ROUTE_ITEM_T *pItem, int iCount)
{
	FILE *fp;
	char pcBuf[129];
	fp = fopen("test.router", "wb");
	if (fp == NULL) return FALSE;

	fprintf(fp, "\t%x\t%x\t%x\t%d\t%d\t%d\t%x\t%d\t%d\t%d",
			&pItem[i].ulDestination,
			&pItem[i].ulGateway,
			&pItem[i].ulFlags,
			&pItem[i].iRefCnt,
			&pItem[i].iUse,
			&pItem[i].iMetric,
			&pItem[i].ulMask,
			&pItem[i].iMTU,
			&pItem[i].iWindow,
			&pItem[i].iIRTT);
}
#endif

int route_install()
{
	int i;
	
	printf("route_install running...\n");

#if 0
	AddRoute(String2IP("239.0.0.0"),	/* add for upnp */
			0,
			0x000000FF,
			0,
			G_PC_ETH0);
	AddRoute(0xFFFFFFFF,
			0,
			0xFFFFFFFF,
			0,
			G_PC_ETH0);
#endif
	
	for (i=0; i<MAX_STATIC_ROUTING_ITEM; i++)
	{
		/*
		printf("route[%d]: gw:%08x, dst:%08x, if=%s metric=%d\n",
			i,
			 g_ConfigParam.arRoutingTableItem[i].ulDefaultGateway,
			 g_ConfigParam.arRoutingTableItem[i].ulDestLanIPAddress,
			 g_ConfigParam.arRoutingTableItem[i].cNetInterface,
			 g_ConfigParam.arRoutingTableItem[i].lMetric );
		*/
		
		g_ConfigParam.arRoutingTableItem[i].cNetInterface[7]='\0';
		
		if( strstr(g_ConfigParam.arRoutingTableItem[i].cNetInterface,"eth")==NULL &&
			strstr(g_ConfigParam.arRoutingTableItem[i].cNetInterface,"ppp")==NULL )
			continue;

		if( g_ConfigParam.arRoutingTableItem[i].lMetric >= 256 )
			continue;

		if( g_ConfigParam.arRoutingTableItem[i].ulDefaultGateway | 
			(g_ConfigParam.arRoutingTableItem[i].lMetric) |
			g_ConfigParam.arRoutingTableItem[i].ulDestLanIPAddress )
		{
			RouteAdd(g_ConfigParam.arRoutingTableItem + i);
		}
	}
	return 0;
}

static BOOL WRReadRouterTable(PROC_ROUTE_ITEM_T **ppItem, int *piCount)
{
	char *pcFileBuf;
	int iFileLength;
	int iCount;
	PROC_ROUTE_ITEM_T *pItem;
	int i,j=0;

	if (!(ReadWholeFile(PROC_ROUTE_FILE, &pcFileBuf, &iFileLength)))
		return FALSE;

	iCount = iFileLength / PROC_ROUTE_FILE_LINE_LEN - 1;
	if (iCount<=0)
	{
		free(pcFileBuf);
		return FALSE;
	}

	if ((pItem = malloc(sizeof(PROC_ROUTE_ITEM_T)*iCount)) == NULL)
	{
		free(pcFileBuf);
		return FALSE;
	}
	memset(pItem, 0, sizeof(PROC_ROUTE_ITEM_T)*iCount);
	for (i=0,j=0; i<iCount; i++)
	{
		char *pc;
		char *pc1;
		pc = pcFileBuf+(i+1)*PROC_ROUTE_FILE_LINE_LEN;
		pc1 = strchr(pc, '\t');
		if (pc1 == NULL || pc1-pc >= PROC_ROUTE_FILE_LINE_LEN)
		{
			fprintf(stderr, "Error in file: %s\n", PROC_ROUTE_FILE);
			free(pcFileBuf);
			return FALSE;
		}

		memcpy(pItem[j].acIface, pc, (pc1-pc>7?7:pc1-pc));
		sscanf(pc1, "\t%lx\t%lx\t%lx\t%d\t%d\t%d\t%lx\t%d\t%d\t%d",
			&pItem[j].ulDestination,
			&pItem[j].ulGateway,
			&pItem[j].ulFlags,
			&pItem[j].iRefCnt,
			&pItem[j].iUse,
			&pItem[j].iMetric,
			&pItem[j].ulMask,
			&pItem[j].iMTU,
			&pItem[j].iWindow,
			&pItem[j].iIRTT);

		//norton
		if( (pItem[j].ulFlags & RTF_UP ) )
			j++; /* skip !RTF_UP route entry */
	}

	free(pcFileBuf);

	*ppItem = pItem;
	*piCount = j;
	return TRUE;
}

static int WRWriteRouterTableArgument(HTTPCONNECTION hConnection, char *pcBuf)
{
	PROC_ROUTE_ITEM_T *pItem;
	ROUTINGTABLE_T *gItem;
	int iItemCount;
	int i,j;
	int iCount;
	char ac[16];
	
	if (!WRReadRouterTable(&pItem, &iItemCount))
	{
		pItem = NULL;
		iItemCount = 0;
	}


	if (writePending)
	{
		/* save to static route */
		gItem = g_ConfigParam.arRoutingTableItem;
		memset(g_ConfigParam.arRoutingTableItem,0,sizeof(ROUTINGTABLE_T)*MAX_STATIC_ROUTING_ITEM );
		
		for (i=0,j=0; i<MAX_STATIC_ROUTING_ITEM; i++)
		{
			if( pItem[i].iMetric != 1 && 
				(pItem[i].ulFlags & RTF_DYNAMIC)==0 &&
				(pItem[i].iWindow == 0 ) )
				continue;

			if( pItem[i].iMetric >= 256 ||
				(strncmp(pItem[i].acIface,"eth",3) &&
				strncmp(pItem[i].acIface,"ppp",3)) )
				break;
			
			gItem[j].ulDestLanIPAddress = pItem[i].ulDestination;
			gItem[j].ulSubnetMask = pItem[i].ulMask;
			gItem[j].ulDefaultGateway = pItem[i].ulGateway;
			gItem[j].lMetric = pItem[i].iMetric;
			
			//fprintf(stderr,"Keep route[%d] dst=%08lx acIface=%s \n",i, gItem[j].ulDestLanIPAddress, pItem[i].acIface);
			/*
			if (strcmp(pItem[i].acIface, "eth0") == 0 
				|| strcmp(pItem[i].acIface, "lo") == 0)
				gItem[j].cNetInterface = (int)NET_LAN;
			else if (strcmp(pItem[i].acIface, WRGetOuterNetworkInterface()) == 0)
				gItem[j].cNetInterface = (int)NET_WAN;
			else gItem[j].cNetInterface = NET_LAN;
			*/
			strlcpy(gItem[j].cNetInterface, pItem[i].acIface, sizeof(gItem[j].cNetInterface) );
			
			j++;
		}
		
		//WebLog(CL_PRIVILEGE_ADMIN, CL_SET_ROUTER, NULL, hConnection);
		WriteFlashMemory(&g_ConfigParam);
		writePending = 0;
	}

	iCount = 0;
	iCount += sprintf(pcBuf+iCount, "var va_RtDestLanIP = new Array(\n");
	for (i=0; i<iItemCount; i++)
	{
		IP2String(pItem[i].ulDestination, ac);
		iCount += sprintf(pcBuf+iCount, "'%s',\n", ac);
	}
	iCount += sprintf(pcBuf+iCount, "'');\nvar va_RtSubnetMask = new Array(\n");
	for (i=0; i<iItemCount; i++)
	{
		IP2String(pItem[i].ulMask, ac);
		iCount += sprintf(pcBuf+iCount, "'%s',\n", ac);
	}
	iCount += sprintf(pcBuf+iCount, "'');\nvar va_RtDefaultGateway = new Array(\n");
	for (i=0; i<iItemCount; i++)
	{
		IP2String(pItem[i].ulGateway, ac);
		iCount += sprintf(pcBuf+iCount, "'%s',\n", ac);
	}
	iCount += sprintf(pcBuf+iCount, "'');\nvar va_RtMetric = new Array(\n");
	for (i=0; i<iItemCount; i++)
		iCount += sprintf(pcBuf+iCount, "%d,\n", pItem[i].iMetric);
	iCount += sprintf(pcBuf+iCount, "'');\nvar va_RtInterface = new Array(\n");
	for (i=0; i<iItemCount; i++)
	{
		/*
		if (strcmp(pItem[i].acIface, "eth0") == 0
			|| strcmp(pItem[i].acIface, "lo") == 0)
			iInterface = (int)NET_LAN;
		else if (strcmp(pItem[i].acIface, WRGetOuterNetworkInterface()) == 0)
			iInterface = (int)NET_WAN;
		else iInterface = (int)NET_ERR;
		*/
		iCount += sprintf(pcBuf+iCount, "'%s',\n", pItem[i].acIface);

		//fprintf(stderr,"\nRoute[%d], outif=%s if=%s->%d",i,WRGetOuterNetworkInterface(),pItem[i].acIface,iInterface);
	}
	iCount += sprintf(pcBuf+iCount, "'');//0:WAN, 1:LAN\n");

	if (pItem != NULL) free(pItem);

	iCount += sprintf(pcBuf+iCount, "\nvar va_SrDestLanIp = '0.0.0.0';" );//	, String2IP(pItem->ulDestLanIPAddress));
	iCount += sprintf(pcBuf+iCount, "\nvar va_SrSubnetMask = '255.255.255.0';");//	,String2IP(pItem->ulSubnetMask ));
	iCount += sprintf(pcBuf+iCount, "\nvar va_SrDefaultGateway = '0.0.0.0';");//	,String2IP(pItem->ulDefaultGateway ));
	iCount += sprintf(pcBuf+iCount, "\nvar va_SrMetric = '1';");//	,pItem->cNetInterface));
	iCount += sprintf(pcBuf+iCount, "\nvar va_SrInterface = '0';");//	,pItem->cNetInterface));
	iCount += sprintf(pcBuf+iCount, "\nvar va_id = '0';");
	iCount += sprintf(pcBuf+iCount, "\nvar va_op = '0';");
	iCount += sprintf(pcBuf+iCount, "\nvar va_max_entry = 18;");

	return iCount;
}

int Http_RouterTable(HTTPCONNECTION hConnection, void *pParam)
{
	char *pcFile;

	if (WRExternalAdmin(hConnection) == 0) return 0;
	if ((pcFile = GetRequestFilePath(hConnection)) == NULL) return 0;

	SendHtmlWithParam(hConnection, pcFile,
		WRWriteRouterTableArgument
		);

	return 0;
}


#ifndef EMBED
int route_add(char *dstip,char *gwip,char *mno,char *mskv,char *interface)
{
	fprintf(stderr, "route_add: %s %s %s %s %s\n", dstip, gwip, mno, mskv, interface);
	return 0;
}

int route_del(char *dstip,char *gwip,char *mno,char *mskv,char *interface)
{
	fprintf(stderr, "route_del: %s %s %s %s %s\n", dstip, gwip, mno, mskv, interface);
	return 0;
}

#endif

static BOOL RouteSet(ROUTINGTABLE_T *pItem, BOOL bAdd)
{
	char pcDestLanIPAddress[16];
	char pcSubnetMask[16];
	char pcDefaultGateway[16];
	char pcNetInterface[8];	/* NET_WAN or NET_LAN */

	memset( &pcNetInterface, 0 , sizeof(pcNetInterface));
	
	if (pItem->ulDestLanIPAddress == 0
		&& pItem->ulSubnetMask == 0
		&& pItem->ulDefaultGateway == 0
		) //&& pItem->lMetric == 0 )
		//&& pItem->cNetInterface == 0) 
		return FALSE;

	IP2String(pItem->ulDestLanIPAddress, pcDestLanIPAddress);
	IP2String(pItem->ulSubnetMask, pcSubnetMask);
	IP2String(pItem->ulDefaultGateway, pcDefaultGateway);

	/*
	if (pItem->cNetInterface == NET_WAN)
		strcpy(pcNetInterface, WRGetOuterNetworkInterface());
	else if (pItem->cNetInterface == NET_LAN)
		strcpy(pcNetInterface, G_PC_ETH0);
	else
		*pcNetInterface = 0;
	*/
	if( pItem->cNetInterface[0] )
		strlcpy(pcNetInterface, pItem->cNetInterface,sizeof(pcNetInterface));
	
	/*
	fprintf(stderr,"\nRouteSet %s (dst=%s, gw=%s , msk=%s, metric= %lu, if= %s(%d) )",
		bAdd ? "Add" : "Del" ,pcDestLanIPAddress, pcDefaultGateway, pcSubnetMask, 
		pItem->lMetric, pcNetInterface, pItem->cNetInterface );
	*/

	if (bAdd)
		//AddRoute(pItem->ulDestLanIPAddress,pItem->ulDefaultGateway,pItem->ulSubnetMask,pItem->lMetric,pcNetInterface);
		AddRoute(String2IP(pcDestLanIPAddress), String2IP(pcDefaultGateway), String2IP(pcSubnetMask), pItem->lMetric, pcNetInterface);
	else
		//DelRoute(pItem->ulDestLanIPAddress,pItem->ulDefaultGateway,pItem->ulSubnetMask,pItem->lMetric,pcNetInterface);
		DelRoute(String2IP(pcDestLanIPAddress), String2IP(pcDefaultGateway), String2IP(pcSubnetMask), pItem->lMetric, pcNetInterface);

	return TRUE;
}

BOOL RouteAdd(ROUTINGTABLE_T *pItem)
{
	return RouteSet(pItem, TRUE);
}

BOOL RouteDel(ROUTINGTABLE_T *pItem)
{
	return RouteSet(pItem, FALSE);
}

#ifdef WINBOND_SROUTE
int Http_SRouter(HTTPCONNECTION hConnection, void *pParam)
{
	char *pcQuery;
	int iEntry;
	ROUTINGTABLE_T *pItem;
	char *pcFile;

	if (WRExternalAdmin(hConnection) == 0) return 0;
	if ((pcFile = GetRequestFilePath(hConnection)) == NULL) return 0;

	iEntry = 0;
	pcQuery = GetQueryString(hConnection);
	if (pcQuery != NULL)
	{
		char *pcCmp = "SelectEntry=";
		if (strncmp(pcQuery, pcCmp, strlen(pcCmp)) == 0)
			iEntry = atoi(pcQuery + strlen(pcCmp));
	}
	if (iEntry < 0) iEntry = 0;
	if (iEntry >= MAX_STATIC_ROUTING_ITEM) iEntry = MAX_STATIC_ROUTING_ITEM - 1;

	pItem = g_ConfigParam.arRoutingTableItem + iEntry;

	SendHtmlWithParam(hConnection, pcFile,
		iEntry,
		pItem->ulDestLanIPAddress,
		pItem->ulSubnetMask,
		pItem->ulDefaultGateway,
		(int)pItem->lMetric,
		(int)pItem->cNetInterface
		);
	return 0;
}
#endif

int Http_Config_SRouter(HTTPCONNECTION hConnection, void *pParam)
{
	LIST *pList;
	const char *interface = NULL;
	/* Config params */
	ROUTINGTABLE_T rItem;
	int iId;
	int iAction;

#define ACTION_SROUTER_SET 0
#define ACTION_SROUTER_INS 1
#define ACTION_SROUTER_DEL 2

	/* Last params */
	ROUTINGTABLE_T *pItem;

	pList = (LIST *)pParam;

	/* Read page parameters. */
	iAction = GetLong(pList,"va_op");
	iId = GetLong(pList,"va_id");

	pItem = g_ConfigParam.arRoutingTableItem;
	
	writePending = 0;
	memset(&rItem,0,sizeof(rItem));

	if (iAction == ACTION_SROUTER_DEL)
	{
		rItem.ulDestLanIPAddress = String2IP(GetString(pList, "va_dst"));
		rItem.ulSubnetMask = String2IP(GetString(pList, "va_dmsk"));
		rItem.ulDefaultGateway = String2IP(GetString(pList, "va_gw"));
		rItem.lMetric = GetLong(pList, "va_metric");
		interface = GetString(pList, "va_if"); /* va_if: it is used for delete a route */
		strlcpy( rItem.cNetInterface, interface, sizeof(rItem.cNetInterface) );
		
		if ( rItem.ulDestLanIPAddress == 0
			&& rItem.ulSubnetMask == 0
			&& rItem.ulDefaultGateway == 0 )
			;
		else
		{
			if (RouteDel( &rItem) )
				writePending = 1;
		}
	}
	else if (iAction == ACTION_SROUTER_SET)
	{
		rItem.ulDestLanIPAddress = GetIP4(pList, "IP_SrDestLanIp");
		rItem.ulSubnetMask = GetIP4(pList, "IP_SrSubnetMask");
		rItem.ulDefaultGateway = GetIP4(pList, "IP_SrDefaultGateway");
		interface = GetString(pList, "WR_SrInterface");
		rItem.lMetric = (char)GetLong(pList, "Num_SrMetric");
		
		if( strcmp(interface,"AUTO")!=0 )
			strlcpy( rItem.cNetInterface, interface, sizeof(rItem.cNetInterface) );

#if 0
		if( WRGetProductName() && strcmp(WRGetProductName(),"brl-04gp")!=0 )
		{
			if( rItem.lMetric == 0 )
				rItem.lMetric = 1; /* user manual route set metric to 1, for accounting */
		}
#endif

		if (rItem.ulDestLanIPAddress == 0
			&& rItem.ulSubnetMask == 0
			&& rItem.ulDefaultGateway == 0
			// && rItem.lMetric == 0
			) //&& rItem.cNetInterface == 0)
			;
		else
		{
			if(RouteAdd(&rItem))
				writePending = 1;
		}
	}

#ifdef WINBOND_ROUTE_WRITE
	if (bIsChange)
	{
		//WebLog(CL_PRIVILEGE_ADMIN, CL_SET_ROUTER, NULL, hConnection);
		WriteFlashMemory(&g_ConfigParam);
	}
#endif
	SetKeepAliveMode(hConnection, FALSE);
	SendReDirectPage(hConnection);
	return 0;
}
