#include "CommonDef.h"

#define MAX_SPEC_CT   10
struct spec_list
{
	unsigned char  flag;
	unsigned short out_port_start ;
	unsigned short out_port_end ;

	unsigned short in_port_start ;
	unsigned short in_port_end ;

	unsigned int  dst_ip ;
	struct ip_conntrack *spec_ct[MAX_SPEC_CT] ;
	unsigned int  ct_count ;   //MAX is 10
}__attribute__ ((aligned (4)));;

#ifdef EMBED
static inline _syscall2(char,nat_spec_reset,unsigned long *,args,char,count);
#else
static char nat_spec_reset(unsigned long *args, char count)
{
	int i;
	struct spec_list *pItem;
	char ac[16];
	fprintf(stderr, "Special Application item:\n");
	for (i=0; i<(int)count; i++)
	{
		pItem = (struct spec_list *)args[0] + i;
		IP2String(pItem->dst_ip, ac);
		fprintf(stderr, "	out - %hd %hd	int - %hd %hd	flag - %d	%s\n",
			pItem->out_port_start,
			pItem->out_port_end,
			pItem->in_port_start,
			pItem->in_port_end,
			(int)pItem->flag,
			ac
			);
	}
}
#endif

BOOL WRConfigSpecialApp(SPECIALAPPLICATION_T *psSpecialAppItem)
{
	struct spec_list specapp[MAX_SPECIAL_APP_ITEM];
	unsigned long args[1];
	SPECIALAPPLICATION_T *pItem;
	int i, j, k;

	memset(specapp, 0, sizeof(specapp));
	for (i=0, j=0; i<MAX_SPECIAL_APP_ITEM; i++)
	{
		pItem = psSpecialAppItem + i;
		if (pItem->bIsActivated
			&& ( pItem->usOutPortFrom!=0 || pItem->usOutPortTo!=0 )
			&& ( pItem->usInPortFrom!=0 || pItem->usInPortTo!=0 )
			)
		{
			specapp[j].flag = (char)pItem->bIsActivated;
			specapp[j].out_port_start = pItem->usOutPortFrom;
			specapp[j].out_port_end = pItem->usOutPortTo;
			specapp[j].in_port_start = pItem->usInPortFrom;
			specapp[j].in_port_end = pItem->usInPortTo;
			specapp[j].dst_ip = 0;

			if (specapp[j].out_port_start > specapp[j].out_port_end)
				__SWAP(unsigned short, specapp[j].out_port_start, specapp[j].out_port_end);
			if (specapp[j].in_port_start > specapp[j].in_port_end)
				__SWAP(unsigned short, specapp[j].in_port_start, specapp[j].in_port_end);

			for (k=0; k<j; k++)
			{
				if (specapp[k].flag == specapp[j].flag
					&& specapp[k].out_port_start == specapp[j].out_port_start
					&& specapp[k].out_port_end == specapp[j].out_port_end
					&& specapp[k].in_port_start == specapp[j].in_port_start
					&& specapp[k].in_port_end == specapp[j].in_port_end) break;
			}
			if (k < j) continue;

			j++;
		}
	}

	args[0]=(unsigned long)specapp;
	nat_spec_reset(args,j);

	return TRUE;
}

static int WRWriteSpecialAppArgument(HTTPCONNECTION hConnection, char *pcBuf)
{
	int i;
	int iCount;
	char *pc;
	char ac[16];

	SPECIALAPPLICATION_T *pItem;

	pItem = g_ConfigParam.asSpecialAppItem;

	iCount = 0;

	iCount += sprintf(pcBuf+iCount, "var va_SelectThisApp = new Array(\n");
	for (i=0; i<MAX_SPECIAL_APP_ITEM; i++)
	{
		Bool2String(pItem[i].bIsActivated, ac);
		iCount += sprintf(pcBuf+iCount, "%s,\n", ac);
	}

	iCount += sprintf(pcBuf+iCount, "'');\nvar va_AppName = new Array(\n");
	for (i=0; i<MAX_SPECIAL_APP_ITEM; i++)
	{
		if ((pc = GetWebInCString(pItem[i].acAppName)) != NULL)
		{
			iCount += sprintf(pcBuf+iCount, "'%s',\n", pc);
			free(pc);
		}
		else iCount += sprintf(pcBuf+iCount, "'',\n");
	}

	iCount += sprintf(pcBuf+iCount, "'');\nvar va_AppOutPortRange = new Array(\n");
	for (i=0; i<MAX_SPECIAL_APP_ITEM; i++)
	{
		iCount += sprintf(pcBuf+iCount, "%d,%d,\n", (int)pItem[i].usOutPortFrom, (int)pItem[i].usOutPortTo);
	}

	iCount += sprintf(pcBuf+iCount, "'');\nvar va_AppInPortRange = new Array(\n");
	for (i=0; i<MAX_SPECIAL_APP_ITEM; i++)
	{
		iCount += sprintf(pcBuf+iCount, "%d,%d,\n", (int)pItem[i].usInPortFrom, (int)pItem[i].usInPortTo);
	}
	iCount += sprintf(pcBuf+iCount, "'');\n");

	return iCount;
}

int Http_SpecialApp(HTTPCONNECTION hConnection, void *pParam)
{
	char *pcFile;
	if (WRExternalAdmin(hConnection) == 0) return 0;
	if ((pcFile = GetRequestFilePath(hConnection)) == NULL) return 0;
	SendHtmlWithParam(hConnection, pcFile, WRWriteSpecialAppArgument);
	return 0;
}

int Http_Config_SpecialApp(HTTPCONNECTION hConnection, void *pParam)
{
	LIST *pList;
	BOOL bIsChange;
	int i;
	char pcName[32];

	/* Config params */
	SPECIALAPPLICATION_T asSpecialAppItem[MAX_SPECIAL_APP_ITEM];

	pList = (LIST *)pParam;

	/* Read page parameters. */
	for (i=0; i<MAX_SPECIAL_APP_ITEM; i++)
	{
		sprintf(pcName, "WR_SelectThisApp%d", i);
		asSpecialAppItem[i].bIsActivated = GetBool(pList, pcName);

		sprintf(pcName, "Txt_AppName%d", i);
		MyStrncpy(asSpecialAppItem[i].acAppName, GetString(pList, pcName), sizeof(asSpecialAppItem[i].acAppName));

		sprintf(pcName, "Num_AppOutPortRangeL%d", i);
		asSpecialAppItem[i].usOutPortFrom = (unsigned short)GetLong(pList, pcName);

		sprintf(pcName, "Num_AppOutPortRangeH%d", i);
		asSpecialAppItem[i].usOutPortTo= (unsigned short)GetLong(pList, pcName);

		sprintf(pcName, "Num_AppInPortRangeL%d", i);
		asSpecialAppItem[i].usInPortFrom = (unsigned short)GetLong(pList, pcName);

		sprintf(pcName, "Num_AppInPortRangeH%d", i);
		asSpecialAppItem[i].usInPortTo = (unsigned short)GetLong(pList, pcName);
	}

	/* config */
	bIsChange = FALSE;

	if (memcmp(asSpecialAppItem, g_ConfigParam.asSpecialAppItem, sizeof(g_ConfigParam.asSpecialAppItem)) != 0)
	{
		if (WRConfigSpecialApp(asSpecialAppItem))
		{
			memcpy(g_ConfigParam.asSpecialAppItem, asSpecialAppItem, sizeof(g_ConfigParam.asSpecialAppItem));
			bIsChange = TRUE;
		}
	}

	if (bIsChange)
	{
		//WebLog(CL_PRIVILEGE_ADMIN, CL_SET_SPECIALAPP, NULL, hConnection);
		WriteFlashMemory(&g_ConfigParam);
	}
	SetKeepAliveMode(hConnection, FALSE);
	SendReDirectPage(hConnection);
	return 0;
}
