#include "CommonDef.h"

unsigned long GetPubIPInfo(unsigned long *pulPublicIpAddress,
							unsigned long *pulPublicSubnetMask,
							unsigned long *pulDefaultGateway )
{
	unsigned long *pulBuf;
	int iLen;
	int i;
	*pulPublicIpAddress = g_ConfigParam.ulPublicIpAddress;
	*pulPublicSubnetMask = g_ConfigParam.ulPublicSubnetMask;
	*pulDefaultGateway = g_ConfigParam.ulDefaultGateway;
//	memset(pulDNSServer, 0, sizeof(unsigned long) * 3);

	if (g_ConfigParam.ulHowToGetIp == GETIP_MAN)
	{
		*pulPublicIpAddress = GetIPAddress(G_PC_ETH1);
		*pulPublicSubnetMask = GetNetMask(G_PC_ETH1);
		*pulDefaultGateway = GetGateway(G_PC_ETH1);
		//memcpy(pulDNSServer, g_ConfigParam.aulDNSServer, sizeof(unsigned long) * 3);
	}
	else if (g_ConfigParam.ulHowToGetIp == GETIP_DHCP)
	{
		if ( GetIPAddress(G_PC_ETH1)==0L )
		{
			for (i = 0; i < 3; i++)
					g_ConfigParam.aulDNSServer[i] = 0L; 
			
			return 1;		
		}
		if (ReadWholeFile(DHCP_CLIENT_INFO_FILE, (char **)&pulBuf, &iLen))
		{
			if (iLen >= sizeof(unsigned long) * 4)
			{
				*pulPublicIpAddress = *pulBuf;
				*pulPublicSubnetMask = *(pulBuf + 1);
				*pulDefaultGateway = *(pulBuf + 2);
				for (i = 0; i < 3 && sizeof(unsigned long) * (i + 4) <= iLen; i++)
					g_ConfigParam.aulDNSServer[i] = *(pulBuf + 3 + i); //pulDNSServer[i] = *(pulBuf + 3 + i);
			}
			free(pulBuf);
		}
	}
	else if (g_ConfigParam.ulHowToGetIp == GETIP_PPP)
	{
		int iPPPState, id = 1;
		struct ppp_info pInfo;

		/* obsolete code ?? */
		
		iPPPState = WRGetPPPoEState( id ); //test
		memset(&pInfo, 0, sizeof(pInfo));
		if (iPPPState == PPPOE_DOD_ON || iPPPState == PPPOE_COMM_ON)
		{
			if (!ppp_read_config( id, &pInfo))
			{
				memset(&pInfo, 0, sizeof(pInfo));
			}
		}
		else
		{
			if (!ppp_read_config( id+1, &pInfo))
				memset(&pInfo, 0, sizeof(pInfo));
		}

		*pulPublicIpAddress = String2IP(pInfo.loc_addr);
		*pulPublicSubnetMask = String2IP(pInfo.netmask);
		//*pulDefaultGateway = String2IP(pInfo.gateway);
		*pulDefaultGateway = GetGateway(WRGetOuterNetworkInterface());
		
		for (i = 0; i < 2; i++)
			g_ConfigParam.aulDNSServer[i] = String2IP(pInfo.got_dnsaddr[i]); //pulDNSServer[i] = String2IP(pInfo.dnsaddr[i]);
	}
	else if (g_ConfigParam.ulHowToGetIp == GETIP_UNNUM)
	{
		int iPPPState;
		struct ppp_info pInfo;

		iPPPState = WRGetPPPoEState(UNNUM_ID); //test
		memset(&pInfo, 0, sizeof(pInfo));
		if (iPPPState == PPPOE_DOD_ON || iPPPState == PPPOE_COMM_ON)
		{
			if (!ppp_read_config(UNNUM_ID, &pInfo))
				memset(&pInfo, 0, sizeof(pInfo));
		}
		*pulPublicIpAddress = String2IP(pInfo.loc_addr);
		*pulPublicSubnetMask = String2IP(pInfo.netmask);
		*pulDefaultGateway = String2IP(pInfo.gateway);
		for (i = 0; i < 2; i++)
			g_ConfigParam.aulDNSServer[i] = String2IP(pInfo.got_dnsaddr[i]); //pulDNSServer[i] = String2IP(pInfo.dnsaddr[i]);
	}
	g_ConfigParam.ulPublicIpAddress = *pulPublicIpAddress;
	g_ConfigParam.ulPublicSubnetMask = *pulPublicSubnetMask;
	
	return 1;
}

int Http_Status(HTTPCONNECTION hConnection, void *pParam)
{
	unsigned long ulPublicIpAddress;
	unsigned long ulPublicSubnetMask;
	unsigned long ulDefaultGateway;
	//unsigned long aulDNSServer[3];
	unsigned long ulDHCPServerAddress;
	unsigned long ulDHCPLeasedTime_InSec;
	unsigned long ulDHCPRemainTime_InSec;
	unsigned long ulPrivateIPAddress;
	unsigned long ulPrivateSubnetMask;
	char *pcFile;

	if (WRExternalAdmin(hConnection) == 0) return 0;
	if ((pcFile = GetRequestFilePath(hConnection)) == NULL) return 0;

	GetPubIPInfo(&ulPublicIpAddress,
				&ulPublicSubnetMask,
				&ulDefaultGateway );

	ulPrivateIPAddress = GetIPAddress(G_PC_ETH0);
	ulPrivateSubnetMask = GetNetMask(G_PC_ETH0);

	ulDHCPServerAddress = ulPrivateIPAddress;
	ulDHCPLeasedTime_InSec = 0;
	ulDHCPRemainTime_InSec = 0;

	SendHtmlWithParam(hConnection, pcFile,
		ulPublicIpAddress,
		ulPublicSubnetMask,
		ulDefaultGateway,
		g_ConfigParam.aulDNSServer[0],
		g_ConfigParam.aulDNSServer[1],
		g_ConfigParam.aulDNSServer[2],
		ulDHCPServerAddress,
		ulDHCPLeasedTime_InSec,
		ulDHCPRemainTime_InSec,
		ulPrivateIPAddress,
		ulPrivateSubnetMask
		);
	return 0;
}
