#ifndef SYSTEM_H
#define SYSTEM_H

#if 0 //before 4.24.2003
#ifdef NEW_KERNEL //lsshi add
#define __NR_nat_spec_reset		(__NR_SYSCALL_BASE+226)//lsshi add
#define __NR_set_out_ip		(__NR_SYSCALL_BASE+227)//lsshi add
#define __NR_nat_url_filter_reset		(__NR_SYSCALL_BASE+228)//lsshi add
#define __NR_nat_ip_filter_reset	(__NR_SYSCALL_BASE+229)//lsshi add
#define __NR_set_local_ip         (__NR_SYSCALL_BASE+230)//lsshi add
#else
#define __NR_nat_spec_reset		(__NR_SYSCALL_BASE+218)//lsshi add
#define __NR_set_out_ip		(__NR_SYSCALL_BASE+219)//lsshi add
#define __NR_nat_url_filter_reset		(__NR_SYSCALL_BASE+220)//lsshi add
#define __NR_nat_ip_filter_reset	(__NR_SYSCALL_BASE+221)//lsshi add
#define __NR_set_local_ip         (__NR_SYSCALL_BASE+222)//lsshi add
#endif

#else

#ifdef NEW_KERNEL //lsshi add
#define __NR_nat_spec_reset             (__NR_SYSCALL_BASE+222)//lsshi add
#define __NR_set_out_ip         (__NR_SYSCALL_BASE+223)//lsshi add
#define __NR_nat_url_filter_reset               (__NR_SYSCALL_BASE+224)//lsshi add
#define __NR_nat_ip_filter_reset        (__NR_SYSCALL_BASE+225)//lsshi add
#define __NR_set_local_ip         (__NR_SYSCALL_BASE+226)//lsshi add
#define __NR_setresetpid         (__NR_SYSCALL_BASE+232)//lsshi add
#else
#define __NR_nat_spec_reset             (__NR_SYSCALL_BASE+218)//lsshi add
#define __NR_set_out_ip         (__NR_SYSCALL_BASE+219)//lsshi add
#define __NR_nat_url_filter_reset               (__NR_SYSCALL_BASE+220)//lsshi add
#define __NR_nat_ip_filter_reset        (__NR_SYSCALL_BASE+221)//lsshi add
#define __NR_set_local_ip         (__NR_SYSCALL_BASE+222)//lsshi add
#endif

#endif

/* Init network interface */
BOOL InitNetInterface(const char *pcInterface);

/* Set Mac Address */
BOOL SetMacAddress(const char *pcInterface, const char *pcMacAddress);

/* Get Mac Address
Return: if success, return pcMacAddress, else return NULL */
char *GetMacAddress(const char *pcInterface, char *pcMacAddress);

/* Set Ip & Netmask */
BOOL SetGeneralIP(const char *pcInterface, unsigned long ulIP, unsigned long ulNetmask);

/* Get Ip Address
Return: if success, return ip address, else return 0; */
unsigned long GetIPAddress(const char *pcInterface);

/* Get Subnet mask
Return: if success, return netmask, else return NULL */
unsigned long GetNetMask(const char *pcInterface);

/* Let Nat system know local ip changed. */
void NotifyLocalIP2Nat();
/* Let Nat system know pub ip changed. */
void NotifyPubIP2Nat(const char *pcInterface);

/* Get default gateway. */
unsigned long GetGateway(const char *pcInterface);

/* Set default gateway. */
BOOL SetGateway(const char *pcInterface, unsigned long ulIP);

/* Set DNS to "/swap/resolv.conf" */
BOOL SetDNSServer(unsigned long *pulDNS);

/* Reset Nat */
void ResetNat();//const char *pcInterface);


char GetProcessState(pid_t pid);

void SynProcess(pid_t *pid);

#ifdef DEBUG
int Http_Shell_Ps(HTTPCONNECTION hConnection, void *pParam);
#endif

int sysinfo(HTTPCONNECTION hConnection, void *pParam);
int postinfo(HTTPCONNECTION hConnection, void *pParam);

/* Kill a process and wait it exit in limit time. */
BOOL LimitKill(pid_t *g_pid, int iSignal, unsigned long ulLimitTime_InMiniSec);

/* The procedure for SIGCHLD */
void WRSigChildDie(int iSignal);

/* The procedure for SIGWINCH */
void WRSigSetRuleConnected(int iSignal);
int Config_SetRules(HTTPCONNECTION hConnection, LIST *pParamList, int iAction, XML *pReturnXML);

/* The procedure for signal 32 */
void WRSigPPPChanged(int iSignal);

/* The procedure for SIGTERM & SIGINT */
void WRSIGTERM(int iSignal);

/* Prevent from receving signal */
void BlockSignal();

/* get all the pid of pcPidName. */
pid_t* FindPidByName(char* pcPidName);

/* Kill the process with a brutal way (SIGKILL) */
BOOL KillAllProc(char *pcProcName);
BOOL SafeLimitKill(pid_t pid, int iSignal, unsigned long ulLimitTime_InMiniSec);

/* Get Network interface for "ppp0..". */
const char *WRGetOuterNetworkInterface();

/* Check if allow external administration.
** Return 0: Not permitted.
** Return -1: no affect, pass.*/
int WRExternalAdmin(HTTPCONNECTION hConnection);

/* Set to factory default config. */
void WRSetFactoryDefault();

/* reset router. */
void WRReSetRouter();

/* run a program. return pid or 0 if failed. */
BOOL RunProgram(pid_t *ppidFork, char *pcPath, ...);

BOOL AddRoute(unsigned long ulIP,
				unsigned long ulGateway,
				unsigned long ulNetmask,
				short sMetric,
				const char *pcInterface);

BOOL DelRoute(unsigned long ulIP,
				unsigned long ulGateway,
				unsigned long ulNetmask,
				short sMetric,
				const char *pcInterface);
void nat_install( int enable ) ;
void fwstate_check(int enable) ;
extern int NATA_SetMAC(int, const char *);
int lan_service(unsigned long old_lan, unsigned long new_lan, unsigned long netmask, int updateDhcp );
int wan_service(int sess_no);
BOOL SetMtu(const char *pcInterface, long lMtu);
int SetWanDuplex(unsigned long mode);
const char *int_ntoa(unsigned long ipaddr);

#endif
