#include "CommonDef.h"

struct tagUDPSERVER;
typedef BOOL (*UDP_TALK)(struct tagUDPSERVER *pUdpServer);
typedef struct tagUDPSERVER
{
	OBJHEADER oHeader;
	FD_T fd;
	int iPort;
	struct sockaddr_in sClient;
} UDPSERVER;


BOOL UDPSERVER_Process(FD_T *pFD, BOOL bReadable, BOOL bWritable)
{
	UDPSERVER *pUdpServer = (UDPSERVER *)((char *)(pFD) - (unsigned long)(&((UDPSERVER *)0)->fd));
	int fd;
	socklen_t sLen;
	char ac[256];
	int iLen;

	if (!bReadable && !bWritable) return TRUE;

	//printf("rw: %d %d\n", bReadable, bWritable);

	sLen = sizeof(pUdpServer->sClient);
	iLen = recvfrom(pFD->iFD, ac, sizeof(ac), 0,
		(struct sockaddr *)&pUdpServer->sClient, &sLen);
//	PTI;

	if (iLen >= 4)
	{
		unsigned long ulPrivateIpAddress;

		ulPrivateIpAddress = GetIPAddress(G_PC_ETH0);


#if 0

		if (g_ConfigParam.bEnableExternalAdmin)
			GetPubIPInfo(&ulPublicIpAddress,
					&ulPublicSubnetMask,
					&ulDefaultGateway,
					aulDNSServer);
		else ulPublicIpAddress = 0L;
		iLen = sprintf(ac, "LAN: ");
		iLen += IP2String(ulPrivateIpAddress, ac + iLen);
		iLen += sprintf(ac + iLen, "\nPORT: %d\n", 80);
		iLen += sprintf(ac + iLen, "WAN: ");
		iLen += IP2String(ulPublicIpAddress, ac + iLen);
		iLen += sprintf(ac + iLen, "\nPORT: %d\n",
			(ulPublicIpAddress != 0 ? (int)g_ConfigParam.usExternalAdminPort : 0)
			);
		iLen += sprintf(ac + iLen, "CLIENT: ");
		iLen += IP2String(pUdpServer->sClient.sin_addr.s_addr, ac + iLen);
		iLen += sprintf(ac + iLen, "\n");
		printf("%s\n", ac);
//		PTI;

		sendto(pFD->iFD, ac, strlen(ac), 0, (struct sockaddr *)&pUdpServer->sClient, sizeof(pUdpServer->sClient));
#else
	{
		struct
		{
			unsigned long ulHeader;
			char acHostName[32];
			char acIP[16];
			int iPort;
		} s;

		s.ulHeader = *(unsigned long *)ac;
		//There's a bug if g_ConfigParam is not protected by critical area.
		MyStrncpy(s.acHostName, g_ConfigParam.acHostName, sizeof(s.acHostName));
		IP2String(ulPrivateIpAddress, s.acIP);
		s.iPort = g_RunTimeState.iPort[0];

		IP2String(pUdpServer->sClient.sin_addr.s_addr, ac);
		printf("Client scaning... [%s]\n", ac);
		pUdpServer->sClient.sin_addr.s_addr = 0xFFFFFFFF;
		sendto(pFD->iFD, &s, sizeof(s), 0, (struct sockaddr *)&pUdpServer->sClient, sizeof(pUdpServer->sClient));
	}
#endif
	}
//	PTI;
	return TRUE;
}

OBJHEADER *UDPSERVER_Init(OBJHEADER *pObj, va_list vaInit)
{
	UDPSERVER *pThis = (UDPSERVER *)pObj;
	unsigned long ulServer = va_arg(vaInit, unsigned long);
	int iPort = va_arg(vaInit, int);
	FUNPROCESSFD_T pfunProcessFD = va_arg(vaInit, FUNPROCESSFD_T);

	struct sockaddr_in sServer;
	int fd;
	int iFl;

//	PTI;

	if ((fd = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP)) == -1)
		goto lE_socket;

	{
		struct ifreq interface;
		int iOn;
		strncpy(interface.ifr_ifrn.ifrn_name, G_PC_ETH0, IFNAMSIZ);
		if (setsockopt(fd, SOL_SOCKET, SO_BINDTODEVICE,(char *)&interface, sizeof(interface)) < 0)
			fprintf(stderr, "Can not bind %s!\n", G_PC_ETH0);

		iOn = 1;
		if (setsockopt(fd, SOL_SOCKET, SO_BROADCAST, &iOn, sizeof(iOn)) < 0)
			fprintf(stderr, "SO_BROADCAST -> Error!\n");

		//iOn = 1;
		//if (setsockopt(fd, SOL_SOCKET, SO_DONTROUTE, &iOn, sizeof(iOn)) < 0)
		//	fprintf(stderr, "SO_DONTROUTE -> Error!\n");
	}


	sServer.sin_family = AF_INET;
	sServer.sin_addr.s_addr = htonl(ulServer);
	sServer.sin_port = htons(iPort);
	if (bind(fd, (struct sockaddr *)&sServer, sizeof(sServer)) == -1)
		goto lE_bind;

	iFl = fcntl(fd, F_GETFL, 0);
	if (fcntl(fd, F_SETFL, iFl | O_NDELAY) != 0)
	{
		fprintf(stderr, "Can not set socket fd to O_NDELAY mode.\n");
		goto lE_bind;
	}

	pThis->iPort = iPort;

	if (ObjInit((OBJHEADER *)pThis, sizeof(FD_T), (OBJHEADER *)&pThis->fd,
			FD_Final, FD_Init,
			fd, SE_TP_UDPSERVER, ST_NET_INIT, -1, TRUE, FALSE, pfunProcessFD) == NULL)
		goto lE_bind;
	//printf("==>%d %d\n", pThis->fd.bWantRead, pThis->fd.bWantWrite);

	return pObj;

lE_bind:
	close(fd);
lE_socket:
	return NULL;
}

void UDPSERVER_Final(OBJHEADER *pObj)
{
	UDPSERVER *pThis = (UDPSERVER *)pObj;
//	PTI;
	close(pThis->fd.iFD);
	ObjFinal((OBJHEADER *)&pThis->fd);
}


void CreateUDPServer(unsigned long ulBindIP, int iPort)
{
	UDPSERVER *pServer;
	pServer = (UDPSERVER *)ObjInit(NULL, sizeof(UDPSERVER), NULL,
		UDPSERVER_Final, UDPSERVER_Init,
		ulBindIP, iPort, UDPSERVER_Process);
	if (pServer != NULL)
		AddSelectFD(&pServer->fd);
}
