#include "CommonDef.h"

int Http_Post_Upload(HTTPCONNECTION hConnection,
		int *piPostState,
		char **ppcPostBuf,
		int *piPostBufLen,
		int *piPostDataLen,
		char *pcFillData,
		int iFillDataLen,
		int iIsMoreData/*bool*/,
		void *pParam/*other parameter for extend use*/)
{
	if (*ppcPostBuf == NULL)
	{
		//test
		printf("limit size=%d \n",FILE_UPLOAD_LIMIT_SIZE);
		fflush(stdout);
		*piPostBufLen = FILE_UPLOAD_LIMIT_SIZE;
		sleep(10);
		*ppcPostBuf = (char *)malloc(*piPostBufLen);
		*piPostDataLen = 0;
	}

	if (*ppcPostBuf == NULL || iFillDataLen + *piPostDataLen >= *piPostBufLen)
	{
		AddHttpBodyString(hConnection, "Too many post data or not enmough memory.");
		SetHttpHeader(hConnection, 200, "OK", NULL, NULL, "text/plain", TRUE);
		return 0;
	}

	memcpy(*ppcPostBuf + *piPostDataLen, pcFillData, iFillDataLen);
	*piPostDataLen += iFillDataLen;

	if (!iIsMoreData)
	{
		typedef int (*UPLOAD_PFUN)(HTTPCONNECTION hConnection, char *pcBuf, int iBufLen);
		UPLOAD_PFUN funUseData;

		(*ppcPostBuf)[*piPostDataLen] = '\0';

		funUseData = (UPLOAD_PFUN)pParam;
		(*funUseData)(hConnection, *ppcPostBuf, *piPostDataLen);
		free(*ppcPostBuf);
		*ppcPostBuf = NULL;
		*piPostDataLen = *piPostBufLen = 0;
		return 1;
	}
	return 1;
}

int Http_Config_Upload(HTTPCONNECTION hConnection, char *pcBuf, int iBufLen)
{
	int r;
	LIST *pFileList;
	LISTNODE *pNode;

	r = HttpUpload(hConnection,
		pcBuf,
		iBufLen,
		FILE_UPLOAD_DEFAULT_DIR, NULL, &pFileList);

	if (r < 0)
	{
		AddHttpBodyString(hConnection, "File upload failed! Please <a href='javascript:history.back();'>retry</a> again.");
		AddHttpBodyString(hConnection, "<br><p>Click <a href='javascript:history.back();'>here</a> to go back.<br>Click <a href='javascript:window.close();'>here</a> to close the browser.<br>");
		SetHttpHeader(hConnection, 200, "OK", "", "Expires: 01 Jan 1970 00:00:00 GMT\r\n", "text/html", TRUE);
	}
	else
	{
		AddHttpBodyString(hConnection, "File upload successfully! System should be restarted before new software takes effect.");
		AddHttpBodyString(hConnection, "<br><p>Click <a href='javascript:history.back();'>here</a> to go back.<br>Click <a href='javascript:window.close();'>here</a> to close the browser.<br>");
		SetHttpHeader(hConnection, 200, "OK", "", "Expires: 01 Jan 1970 00:00:00 GMT\r\n", "text/html", TRUE);
		for (pNode = pFileList->pFirstNode; pNode != pFileList->pLastNode; pNode=pNode->pNextNode)
		{
			if (pNode->pValue)
			{
				chmod((char *)pNode->pValue, 00777);
				printf("Upload file: %s\n", (char *)pNode->pValue);
			}
		}
	}

	HttpUploadClear(hConnection, NULL, &pFileList);
	return 0;
}






typedef struct
{
	int iState;
	int iBoundaryLen;
	int iPrivilege;
	FILE *pfFlashTmpFile;
	LIST *pParamList;
	char *pcInnerPartName;
	char *pcBufEnd;
	char *pcBufDataHeader;
	char *pcBufDataEnd;
	char acBoundary[128];
	char acBuf[32 * 1024];
} PROCESS_MULTIPART_T;


static void MPAddChar(PROCESS_MULTIPART_T *pMPart, char ch)
{
	char *pcNewDataEnd;
	pcNewDataEnd = pMPart->pcBufDataEnd + 1;
	if (pcNewDataEnd == pMPart->pcBufEnd) pcNewDataEnd = pMPart->acBuf;
	if (pcNewDataEnd == pMPart->pcBufDataHeader)
	{
		if (++pMPart->pcBufDataHeader == pMPart->pcBufEnd)
			pMPart->pcBufDataHeader = pMPart->acBuf;
	}
	*pMPart->pcBufDataEnd = ch;
	pMPart->pcBufDataEnd = pcNewDataEnd;
}

unsigned int gcd(unsigned int x, unsigned int y)
{
	for (;;) {
		if (!x)
			return y;
		if (!y)
			return x;
		if (x > y)
			x %= y;
		else
			y %= x;
	}
}

static void MPClean(PROCESS_MULTIPART_T *pMPart)
{
	//δû˿ö
	char *pcBuf;
	int iValidLen;
	int iBufLen;
	int iMove;

	int i;
	int j;
	char c;
	int iPos=0, iPosPre=0;

	int iComDiv;
	int iEachMove;

	pcBuf = pMPart->acBuf;
	iBufLen = sizeof(pMPart->acBuf);
	iValidLen = pMPart->pcBufDataEnd + iBufLen - pMPart->pcBufDataHeader;
	if (iValidLen > iBufLen) iValidLen -= iBufLen;
	iMove = iBufLen - (pMPart->pcBufDataHeader - pMPart->acBuf);

	iMove = (iMove % iBufLen + iBufLen ) % iBufLen;
	if (iMove == 0) return;

	iComDiv = gcd(iMove, iBufLen);
	iEachMove = iBufLen / iComDiv;

	iMove = iBufLen - iMove;
	for (i = 0; i < iComDiv; i++)
	{
		iPosPre = i;
		c = pcBuf[iPosPre];
		for (j = 0; j < iEachMove; j++)
		{
			iPos = iPosPre;
			iPosPre += iMove;
			if (iPosPre >= iBufLen) iPosPre -= iBufLen;
			pcBuf[iPos] = pcBuf[iPosPre];
		}
		pcBuf[iPos] = c;
	}

	pMPart->pcBufDataHeader = pMPart->acBuf;
	pMPart->pcBufDataEnd = pMPart->pcBufDataHeader + iValidLen;
}

static void MPClear(PROCESS_MULTIPART_T *pMPart)
{
	pMPart->pcBufDataHeader = pMPart->acBuf;
	pMPart->pcBufDataEnd = pMPart->pcBufDataHeader;
}

static char *MPTestBoundary(PROCESS_MULTIPART_T *pMPart)
{
	char *pc;
	int iBLen;
	pc = pMPart->pcBufDataEnd - 1;
	if (pc < pMPart->acBuf) return NULL;
	if (*pc != '\n' && *pc != '-') return NULL;
	if (--pc < pMPart->acBuf) return NULL;
	if (*pc == '\r')
	{
		pc--;
		if (pc < pMPart->acBuf) return NULL;
	}
	iBLen = pMPart->iBoundaryLen;
	pc = pc + 1 - iBLen;
	if (pc < pMPart->acBuf) return NULL;
	if (memcmp(pc, pMPart->acBoundary, iBLen) == 0)
	{
		if (--pc < pMPart->acBuf) return NULL;
		if (*pc != '-') return NULL;
		if (--pc < pMPart->acBuf) return NULL;
		if (*pc != '-') return NULL;
		return pc;
	}
	else return NULL;
}


void MPTestWriteFlash(PROCESS_MULTIPART_T *pMPart)
{
	if (pMPart->pcBufDataEnd + 1 == pMPart->pcBufEnd)
	{
		int iLen;
		
		iLen = pMPart->pcBufDataEnd - pMPart->pcBufDataHeader - pMPart->iBoundaryLen - 2;
		iLen = iLen /4 * 4;
		if (pMPart->pfFlashTmpFile != NULL)
			fwrite(pMPart->acBuf, iLen, 1, pMPart->pfFlashTmpFile);
		pMPart->pcBufDataHeader = pMPart->acBuf + iLen;
		MPClean(pMPart);
	}
}

#define MPST_IGNORE 0
#define MPST_HEADER 1
#define MPST_ONE_CR 2
#define MPST_TWO_LF 3
#define MPST_TWO_CR 4
#define MPST_BODYFILE 5
#define MPST_BODYPARAM 6

char *GetBoundary(char *pcContentType);//from C_HttpSupport.h
char *GetInnerPartName(INNERPART_T *pInner);//from C_HttpSupport.h

void ProcessUpdate(PROCESS_MULTIPART_T *pMPart, char *pcFillData, int iFillDataLen)
{
	char *pc;
	char *pcFillDataEnd;
	char *pcThis;
	pcFillDataEnd = pcFillData + iFillDataLen;
//	write(1, pcFillData, iFillDataLen);

	//printf("upload 7 \n");fflush(stdout);
	
	for (pcThis = pcFillData; pcThis < pcFillDataEnd; pcThis++)
	{
		MPAddChar(pMPart, *pcThis);
		switch (pMPart->iState)
		{
		case MPST_IGNORE:
			if (*pcThis == '\n')
			{
				MPClean(pMPart);
				if (MPTestBoundary(pMPart) != NULL)
				{
					MPClear(pMPart);
					pMPart->iState = MPST_HEADER;
				}
			}
			break;
		case MPST_HEADER:
			if (*pcThis == '\n')
			{
				MPClean(pMPart);
				if (MPTestBoundary(pMPart) == NULL)
				{
					pMPart->iState = MPST_ONE_CR;
				}
			}
			break;
		case MPST_ONE_CR:
			if (*pcThis == '\r')
			{
				pMPart->iState = MPST_TWO_LF;
				break;
			}
		case MPST_TWO_LF:
			if (*pcThis == '\n')
			{
				INNERPART_T *pInnerPart;
				char *pcName = NULL;

				MPClean(pMPart);

				pInnerPart = ParseSinglePart(pMPart->pcBufDataHeader, pMPart->pcBufDataEnd - pMPart->pcBufDataHeader);
				if (pInnerPart != NULL)
				{
					pcName = GetInnerPartName(pInnerPart);
					DeleteSinglePart(pInnerPart);
				}

				MPClear(pMPart);

				if (pcName != NULL)
				{
					if (strcmp(pcName, "SourceFile") == 0)
					{
						pMPart->iState = MPST_BODYFILE;
						write(1, "[", 1);
						free(pcName);
					}
					else
					{
						if (pMPart->pcInnerPartName != NULL)
							free(pMPart->pcInnerPartName);
						pMPart->pcInnerPartName = pcName;
						pMPart->iState = MPST_BODYPARAM;
					}
				}
				else pMPart->iState = MPST_IGNORE;
			}
			else pMPart->iState = MPST_HEADER;
			break;
		case MPST_BODYFILE:
			if ( (pc = MPTestBoundary(pMPart)) != NULL)
			{
				if (pc > pMPart->acBuf && *(pc - 1) == '\n')
				{
					pc--;
					if (pc > pMPart->acBuf && *(pc - 1) == '\r')
						pc--;
				}

				if (pMPart->pfFlashTmpFile != NULL)
					fwrite(pMPart->acBuf, 1, pc - pMPart->acBuf, pMPart->pfFlashTmpFile);
				write(1, "]", 1);

				MPClear(pMPart);
				pMPart->iState = MPST_HEADER;
			}
			else MPTestWriteFlash(pMPart);
			break;
		case MPST_BODYPARAM:
			MPClean(pMPart);
			if ( (pc = MPTestBoundary(pMPart)) != NULL)
			{
				char ac;
				if (pc > pMPart->acBuf && *(pc - 1) == '\n')
				{
					pc--;
					if (pc > pMPart->acBuf && *(pc - 1) == '\r')
						pc--;
				}

				ac = *pc;
				*pc = '\0';
				SetString(pMPart->pParamList, pMPart->pcInnerPartName, pMPart->acBuf);
				free(pMPart->pcInnerPartName);
				pMPart->pcInnerPartName = NULL;

				MPClear(pMPart);
				pMPart->iState = MPST_HEADER;
			}
			break;
		}
	}
}

#define POST_INIT 0
#define POST_OK 1
#define POST_ERROR -1
#define POST_NO_MEM -2
#define POST_NO_PRIVILEGE -3
#define POST_SHARE_FLASHING -4
#define POST_SHARE_UPLOADING -5
#define POST_ERROR_FILE -6

int Http_Post_FMUpload(HTTPCONNECTION hConnection,
	int *piPostState,
	char **ppcPostBuf,
	int *piPostBufLen,
	int *piPostDataLen,
	char *pcFillData,
	int iFillDataLen,
	int iIsMoreData/*bool*/,
	void *pParam/*other parameter for extend use*/)
{
	static int upload_init = 1;
	
	switch (*piPostState)
	{
	case POST_INIT:
		
		if (GetAuthPrivilege(hConnection) < AUTH_USER)
			*piPostState = POST_NO_PRIVILEGE;
		else
		{
			char *pcBoundary;

			if( upload_init )
			{
				KillAllProc(  PROG_DDNS );
				KillAllProc(  PROG_UPNP );
				KillAllProc(  PROG_DNS );
				upload_init = 0;
				printf("upload initialized\n");
			}
			set_logout_idle( 0, 0 ); //disable auto logout before upgrade
			
			*piPostBufLen = GetContentLength(hConnection) + 8;
			if (g_RunTimeState.iFlashUpdateState == FIRMWARE_UPLOADING)
				*piPostState = POST_SHARE_UPLOADING;
			else if (g_RunTimeState.iFlashUpdateState == FIRMWARE_FLASHING)
				*piPostState = POST_SHARE_FLASHING;
			else if (*piPostBufLen < 256 || *piPostBufLen >= FIRMWARE_UPDATE_LIMIT_SIZE)
				*piPostState = POST_ERROR_FILE;
			else if ((pcBoundary = GetBoundary(GetContentType(hConnection))) == NULL)
				*piPostState = POST_ERROR;
			else
			{
				*ppcPostBuf = (char *)malloc(sizeof(PROCESS_MULTIPART_T));
				 
				if (*ppcPostBuf == NULL)
				{
					PRINT_MEM_OUT;
					*piPostState = POST_NO_MEM;
				}
				else
				{
					PROCESS_MULTIPART_T *pMPart;
					
					pMPart = (PROCESS_MULTIPART_T *)*ppcPostBuf;
					memset(pMPart, 0, sizeof(PROCESS_MULTIPART_T));

					pMPart->pfFlashTmpFile = fopen(FLASH_UPDATE_TMP_FILE, "wb");
					MyStrncpy(pMPart->acBoundary, pcBoundary, sizeof(pMPart->acBoundary));
					pMPart->iBoundaryLen = strlen(pMPart->acBoundary);
					pMPart->iState = MPST_IGNORE;
					pMPart->pcBufEnd = pMPart->acBuf + sizeof(pMPart->acBuf);
					pMPart->pcBufDataHeader = pMPart->acBuf;
					pMPart->pcBufDataEnd = pMPart->pcBufDataHeader;
					pMPart->pParamList = CreateDict();
					pMPart->pcInnerPartName = NULL;

					g_RunTimeState.iFlashUpdateState = FIRMWARE_UPLOADING;
					*piPostState = POST_OK;
					
					ProcessUpdate((PROCESS_MULTIPART_T *)*ppcPostBuf, pcFillData, iFillDataLen);
				}
				free(pcBoundary);
			}
		}
		break;
	case POST_OK:
		
		ProcessUpdate((PROCESS_MULTIPART_T *)*ppcPostBuf, pcFillData, iFillDataLen);
		break;
	default:
		break;
	}

	if (!iIsMoreData)
	{
		char *pcResponseText;
		PROCESS_MULTIPART_T *pMPart;
		pMPart = (PROCESS_MULTIPART_T *)*ppcPostBuf;

		switch (*piPostState)
		{
		case POST_OK:
			g_RunTimeState.iFlashUpdateState = FIRMWARE_STOP;
			pcResponseText = "OK";
			break;
		case POST_ERROR:
			pcResponseText = "Error";
			break;
		case POST_NO_MEM:
			pcResponseText = "Low Memory";
			break;
		case POST_SHARE_FLASHING:
			pcResponseText = "Firmware Writing";
			break;
		case POST_SHARE_UPLOADING:
			pcResponseText = "Firmware Uploading";
			break;
		case POST_ERROR_FILE:
			pcResponseText = "File Error";
			break;
		default:
			pcResponseText = "Busy";
		}

		if (*piPostState == POST_NO_PRIVILEGE)
			SendAuthRequired(hConnection, AUTH_ADMIN);
		else
		{
			char acExtraHeader[256];
			const char *pcUrl;

			if (pMPart != NULL && pMPart->pParamList != NULL
				&& (pcUrl = GetString(pMPart->pParamList, "RedirectUrl")) != NULL
				&& pcUrl[0] != '\0')
			{
				struct stat st;
				sprintf(acExtraHeader, "Location: %s?%s\r\n", pcUrl, pcResponseText);
				SetHttpHeader(hConnection, 302, "OK", "", acExtraHeader, "text/html", TRUE);

				if (stat(FLASH_UPDATE_TMP_FILE, &st) == 0)
				{
					g_RunTimeState.iFlashUpdateState = FIRMWARE_FLASHING;
					g_RunTimeState.iFlashWriteTotalSize = st.st_size;
					g_RunTimeState.iFlashWriteSize = 0;
					SendFlashMsgFirmwareUpdate();
					//set_logout_idle( g_ConfigParam.bEnableLogoutIdle , g_ConfigParam.usLogoutIdle ); //enable autologout again
				}
			}
			else
			{
				AddHttpBodyString(hConnection, pcResponseText);
				SetHttpHeader(hConnection, 200, "OK", NULL, NULL, "text/plain", TRUE);
			}
		}

		if (*ppcPostBuf != NULL)
		{
			if (pMPart->pfFlashTmpFile != NULL)
				fclose(pMPart->pfFlashTmpFile);
			if (pMPart->pParamList != NULL);
				DeleteDict(pMPart->pParamList);
			if (pMPart->pcInnerPartName != NULL)
				free(pMPart->pcInnerPartName);
		}
	}

	return 1;
}


int Http_Post_ConfigUpload(HTTPCONNECTION hConnection,
	int *piPostState,
	char **ppcPostBuf,
	int *piPostBufLen,
	int *piPostDataLen,
	char *pcFillData,
	int iFillDataLen,
	int iIsMoreData/*bool*/,
	void *pParam/*other parameter for extend use*/)
{
	int restore_ret=0;
	
	switch (*piPostState)
	{
	case POST_INIT:
		
		if (GetAuthPrivilege(hConnection) < AUTH_USER)
			*piPostState = POST_NO_PRIVILEGE;
		else
		{
			char *pcBoundary;
			
			set_logout_idle( 0, 0 ); //disable auto logout before upgrade
			
			*piPostBufLen = GetContentLength(hConnection) + 8;
			if (g_RunTimeState.iFlashUpdateState == FIRMWARE_UPLOADING)
				*piPostState = POST_SHARE_UPLOADING;
			else if (g_RunTimeState.iFlashUpdateState == FIRMWARE_FLASHING)
				*piPostState = POST_SHARE_FLASHING;
			else if (*piPostBufLen < 256 || *piPostBufLen >= FIRMWARE_UPDATE_LIMIT_SIZE)
			{
				printf("piPostBufLen = %d \n", piPostBufLen );
				*piPostState = POST_ERROR_FILE;
			}
			else if ((pcBoundary = GetBoundary(GetContentType(hConnection))) == NULL)
				*piPostState = POST_ERROR;
			else
			{
				*ppcPostBuf = (char *)malloc(sizeof(PROCESS_MULTIPART_T));
				 
				if (*ppcPostBuf == NULL)
				{
					PRINT_MEM_OUT;
					*piPostState = POST_NO_MEM;
				}
				else
				{
					PROCESS_MULTIPART_T *pMPart;
					
					pMPart = (PROCESS_MULTIPART_T *)*ppcPostBuf;
					memset(pMPart, 0, sizeof(PROCESS_MULTIPART_T));

					pMPart->pfFlashTmpFile = fopen(CONFIG_UPDATE_TMP_FILE, "wb");
					MyStrncpy(pMPart->acBoundary, pcBoundary, sizeof(pMPart->acBoundary));
					pMPart->iBoundaryLen = strlen(pMPart->acBoundary);
					pMPart->iState = MPST_IGNORE;
					pMPart->pcBufEnd = pMPart->acBuf + sizeof(pMPart->acBuf);
					pMPart->pcBufDataHeader = pMPart->acBuf;
					pMPart->pcBufDataEnd = pMPart->pcBufDataHeader;
					pMPart->pParamList = CreateDict();
					pMPart->pcInnerPartName = NULL;

					g_RunTimeState.iFlashUpdateState = FIRMWARE_UPLOADING;
					*piPostState = POST_OK;
					
					ProcessUpdate((PROCESS_MULTIPART_T *)*ppcPostBuf, pcFillData, iFillDataLen);
				}
				free(pcBoundary);
			}
		}
		break;
	case POST_OK:
		ProcessUpdate((PROCESS_MULTIPART_T *)*ppcPostBuf, pcFillData, iFillDataLen);
		break;
	default:
		break;
	}

	if (!iIsMoreData)
	{
		char *pcResponseText;
		PROCESS_MULTIPART_T *pMPart;
		pMPart = (PROCESS_MULTIPART_T *)*ppcPostBuf;

		switch (*piPostState)
		{
		case POST_OK:
			g_RunTimeState.iFlashUpdateState = FIRMWARE_STOP;
			pcResponseText = "OK";
			break;
		case POST_ERROR:
			pcResponseText = "Error";
			break;
		case POST_NO_MEM:
			pcResponseText = "Low Memory";
			break;
		case POST_SHARE_FLASHING:
			pcResponseText = "Firmware Writing";
			break;
		case POST_SHARE_UPLOADING:
			pcResponseText = "Firmware Uploading";
			break;
		case POST_ERROR_FILE:
			pcResponseText = "File Error";
			break;
		default:
			pcResponseText = "Busy";
		}

		if (*piPostState == POST_NO_PRIVILEGE)
			SendAuthRequired(hConnection, AUTH_ADMIN);
		else
		{
			char acExtraHeader[256];
			const char *pcUrl;

			if (pMPart != NULL && pMPart->pParamList != NULL
				&& (pcUrl = GetString(pMPart->pParamList, "RedirectUrl")) != NULL
				&& pcUrl[0] != '\0')
			{
				struct stat st;
				sprintf(acExtraHeader, "Location: %s?%s\r\n", pcUrl, pcResponseText);
				SetHttpHeader(hConnection, 302, "OK", "", acExtraHeader, "text/html", TRUE);

				if (stat(CONFIG_UPDATE_TMP_FILE, &st) == 0)
				{
					g_RunTimeState.iFlashUpdateState = FIRMWARE_FLASHING;
					g_RunTimeState.iFlashWriteTotalSize = st.st_size;
					g_RunTimeState.iFlashWriteSize = 0;
					
					restore_ret = Http_Config_Restore(CONFIG_UPDATE_TMP_FILE); //should lock config from changing by user during flash writing
					//SendFlashMsgWriteConfig();
					
					set_logout_idle( g_ConfigParam.bEnableLogoutIdle , g_ConfigParam.usLogoutIdle );
				}
			}
			else
			{
				set_logout_idle( g_ConfigParam.bEnableLogoutIdle , g_ConfigParam.usLogoutIdle );

				restore_ret = Http_Config_Restore(CONFIG_UPDATE_TMP_FILE); //should lock config from changing by user during flash writing

				SetKeepAliveMode(hConnection, FALSE); 
				AddHttpBodyString(hConnection, pcResponseText);
				SetHttpHeader(hConnection, 200, "OK", NULL, NULL, "text/plain", TRUE);
				if( restore_ret == 0 )
					SendReDirectHtml(hConnection, "message.htm", "index.htm", FALSE, 0, "MSG_RESTORE_OK", NULL );
				else
					SendReDirectHtml(hConnection, "message.htm", "index.htm", FALSE, 0, "MSG_RESTORE_FAIL", NULL );
			}
		}

		if (*ppcPostBuf != NULL)
		{
			if (pMPart->pfFlashTmpFile != NULL)
				fclose(pMPart->pfFlashTmpFile);
			if (pMPart->pParamList != NULL);
				DeleteDict(pMPart->pParamList);
			if (pMPart->pcInnerPartName != NULL)
				free(pMPart->pcInnerPartName);
		}
	}

	return 1;
}



int Http_FMUpProcess(HTTPCONNECTION hConnection, void *pParam)
{
	int iFinish;
	int iTotal;
	const char *pcFile;

	//if (WRExternalAdmin(hConnection) == 0) return 0;
	if ((pcFile = GetRequestFilePath(hConnection)) == NULL) return 0;

	iFinish = g_RunTimeState.iFlashWriteSize;
	iTotal = g_RunTimeState.iFlashWriteTotalSize;

	SendHtmlWithParam(hConnection, pcFile,
		iFinish,
		iTotal
		);

	return 0;
}

