#include "CommonDef.h"

#define MAX_URL	100
struct http_list
{
	unsigned char url[MAX_URL];
};

#ifdef EMBED
static inline _syscall3(void,nat_url_filter_reset,unsigned long *,args,char,count, char, flag);
#else
static void nat_url_filter_reset(unsigned long *args, char count, char flag)
{
	int i;
	fprintf(stderr, "Url filter items: %d (%s)\n", (int)count, (flag=='\0'?"Block":"Allow"));
	for (i=0; i<count; i++)
		fprintf(stderr, "	Web site: %s\n", ((struct http_list *)args[0])[i].url);
}
#endif

BOOL WRConfigUrlFilter(BOOL bEnableURLLimit, BOOL bEnableWebsite, char **ppcWebSite)
{
	struct http_list search[20];
	unsigned long args[1];
	int i, j, k;
	char *pc;
	char *pcTrim;
	char flag;

	flag = (bEnableWebsite?'\1':'\0');
	args[0]=(unsigned long)search;

	if (bEnableURLLimit)
	{
		for (i=0, j=0; i<MAX_URL_FILTER_ITEM; i++)
		{
			pc = ppcWebSite[i];
			if ((pcTrim = GetTrimString(pc)) != NULL)
			{
				if (pcTrim[0] != '\0')
				{
					for (k=0; k<j; k++)
						if (strcasecmp(pcTrim, search[k].url) == 0) break;
					if (k >= j)
					{
						MyStrncpy(search[j].url, pcTrim, sizeof(search[j].url));
						j++;
					}
				}
				free(pcTrim);
			}
		}
		for (i=0; i<j; i++)
		{
			pc = search[i].url;
			for (k=0; pc[k]!='\0'; k++)
				if (pc[k] >= 'A' && pc[k] <= 'Z')
					pc[k] += 'a' - 'A';
		}
		nat_url_filter_reset(args, j, flag);
	}
	else nat_url_filter_reset(args, 0, 0);
	return TRUE;
}

static int WRWriteUrlFilterArgument(HTTPCONNECTION hConnection, char *pcBuf)
{
	int i;
	int iCount;
	const char *pc;
	char *pcWebCString;

	iCount = 0;

	iCount += sprintf(pcBuf+iCount, "var va_EnableURLLimit = %d;\n", (int)g_ConfigParam.bEnableURLLimit);
	iCount += sprintf(pcBuf+iCount, "var va_EnableWebsite = %d;\n", (int)g_ConfigParam.bEnableWebsite);
	iCount += sprintf(pcBuf+iCount, "var va_WebSite = new Array(\n");
	for (i=0; i<MAX_URL_FILTER_ITEM; i++)
	{
		pc = g_ConfigParam.aacWebSite[i];
		if (pc[0] != '\0')
		{
			if ((pcWebCString = GetWebInCString(pc)) != NULL)
			{
				iCount += sprintf(pcBuf+iCount, "'%s',\n", pcWebCString);
				free(pcWebCString);
			}
		}
	}
	iCount += sprintf(pcBuf+iCount, "'');\n");

	return iCount;
}

int Http_UrlFilter(HTTPCONNECTION hConnection, void *pParam)
{
	char *pcFile;
	if (WRExternalAdmin(hConnection) == 0) return 0;
	if ((pcFile = GetRequestFilePath(hConnection)) == NULL) return 0;
	SendHtmlWithParam(hConnection, pcFile, WRWriteUrlFilterArgument);
	return 0;
}

int Http_Config_UrlFilter(HTTPCONNECTION hConnection, void *pParam)
{
	LIST *pList;
	BOOL bIsChange;
	int i, j;
	char pcName[32];
	char *pc;

	/* Config params */
	char *apcWebSite[MAX_URL_FILTER_ITEM];
	BOOL bEnableURLLimit;
	BOOL bEnableWebsite;
	char *pcUrlAddress;
	int iAction;
#define ACTION_NONE 0
#define ACTION_ADD 1
#define ACTION_DEL 2

	pList = (LIST *)pParam;

	/* Read page parameters. */
	bEnableURLLimit = GetBool(pList, "WR_EnableURLLimit");
	bEnableWebsite = GetBool(pList, "WR_EnableWebsite");

	pc = (char *)GetString(pList, "WhichButton");
	iAction = ACTION_NONE;
	if ((pc = GetTrimString(pc)) != NULL)
	{
		if (strcmp(pc, "Add") == 0)
			iAction = ACTION_ADD;
		else if (strcmp(pc, "Del") == 0)
			iAction = ACTION_DEL;
		free(pc);
	}

	pcUrlAddress = (char *)GetString(pList, "Txt_UrlAddress");
	if ((pc = GetTrimString(pcUrlAddress)) != NULL)
	{
		SetString(pList, "Txt_UrlAddress", pc);
		free(pc);
	}
	else
		SetString(pList, "Txt_UrlAddress", "");
	pcUrlAddress = (char *)GetString(pList, "Txt_UrlAddress");

	for (i=0; i<MAX_URL_FILTER_ITEM; i++)
	{
		sprintf(pcName, "Txt_WebSite%d", i);
		pc = (char *)GetString(pList, pcName);
		if ((pc = GetTrimString(pc)) != NULL)
		{
			SetString(pList, pcName, pc);
			free(pc);
		}
		else SetString(pList, pcName, "");
		apcWebSite[i] = (char *)GetString(pList, pcName);
	}

	/* config */
	bIsChange = FALSE;

	for (i=0, j=0; i<MAX_URL_FILTER_ITEM; i++)
	{
		if (apcWebSite[i][0] == '\0') continue;
		if (iAction == ACTION_DEL)
		{
			if (strcmp(pcUrlAddress, apcWebSite[i]) == 0) continue;
		}
		apcWebSite[j++] = apcWebSite[i];
	}
	if (iAction == ACTION_ADD && j<MAX_URL_FILTER_ITEM)
	{
		if (pcUrlAddress[0] != '\0')
			apcWebSite[j++] = pcUrlAddress;
	}
	for (i=j; i<MAX_URL_FILTER_ITEM; i++)
		apcWebSite[i] = "";

	for (i=0; i<MAX_URL_FILTER_ITEM; i++)
		if (strcmp(apcWebSite[i], g_ConfigParam.aacWebSite[i]) != 0)
			break;
	if (i < MAX_URL_FILTER_ITEM
		|| bEnableURLLimit != g_ConfigParam.bEnableURLLimit
		|| bEnableWebsite != g_ConfigParam.bEnableWebsite)
	{
		if (WRConfigUrlFilter(bEnableURLLimit, bEnableWebsite, apcWebSite))
		{
			for (i=0; i<MAX_URL_FILTER_ITEM; i++)
				MyStrncpy(g_ConfigParam.aacWebSite[i], apcWebSite[i], sizeof(g_ConfigParam.aacWebSite[i]));
			g_ConfigParam.bEnableURLLimit = bEnableURLLimit;
			g_ConfigParam.bEnableWebsite = bEnableWebsite;
			bIsChange = TRUE;
		}
	}

	if (bIsChange)
	{
		WebLog(CL_PRIVILEGE_ADMIN, CL_SET_URLFILTER, NULL, hConnection);
		WriteFlashMemory(&g_ConfigParam);
	}

	SendReDirectPage(hConnection);
	return 0;
}
