#include "CommonDef.h"
#ifdef EMBED
static inline _syscall2(void,nat_ip_filter_reset,unsigned long *,args,int,count);
#endif //#else

int __WRCompareVirtualServerItem(VIRTUALHOSTITEM_T *pItem1, VIRTUALHOSTITEM_T *pItem2, int iCount)
{
	int i;
	for (i=0; i<iCount; i++)
	{
		if ((pItem1 + i)->ulIPAddress != (pItem2 + i)->ulIPAddress
			|| (pItem1 + i)->bActive_Log_BypassAcl != (pItem2 +i)->bActive_Log_BypassAcl //norton
			|| (pItem1 + i)->usPortFrom != (pItem2 + i)->usPortFrom
			|| (pItem1 + i)->usPortTo != (pItem2 + i)->usPortTo
			|| (pItem1 + i)->cProtocolType != (pItem2 + i)->cProtocolType) return -1;
	}
	return 0;
}

#ifndef EMBED
int Add_virtual_server(struct Virtual_Server *vs)
{
	fprintf(stderr, "Add vserver: ip:%s port:%s-%s %s\n", vs->ip, vs->sport, vs->eport, vs->proto);
	return 0;
}
int Del_virtual_server(struct Virtual_Server *vs)
{
	fprintf(stderr, "Del vserver: ip:%s port:%s-%s %s\n", vs->ip, vs->sport, vs->eport, vs->proto);
	return 0;
}
#endif

int VS_Rule(VIRTUALHOSTITEM_T vs,int op)
{
	struct aos_fw_acl acl;
	struct in_addr addr;
	//unsigned long pubip=0,pubipmsk=0,defgw=0;
	
	//GetPubIPInfo(&pubip,&pubipmsk,&defgw);
		
		if( ( op == AOS_FW_RULE_INS|| op == AOS_FW_RULE_ADD ) && VS_ACTIVE(vs) == 0 )
			return -1;
			
		if( ( op == AOS_FW_RULE_DEL) && VS_ACTIVE(vs) == 0 )
		{
			return -1;
		}
		if( (vs.usPortFrom|vs.usPortTo) == 0 || vs.ulIPAddress == 0 )
		{
			if( vs.cProtocolType != 4 /* all */ &&
				vs.cProtocolType != 5 /* esp */ )
				return -1;
		}
		memset(&acl,0,sizeof(acl));
		strcpy(acl.chain,"PREROUTING");
		acl.objtype = AOS_FW_NAT_DNAT;
		acl.op = op;
		
		acl.dsttype = AOS_FW_NET_IP;
		//addr.s_addr = pubip;
		addr.s_addr = 0xff00ff00;
		strcpy(acl.dst1, inet_ntoa(addr));
		
		acl.dport1 = vs.usPortFrom;
		acl.dport2 = vs.usPortTo;

		addr.s_addr = vs.ulIPAddress;
		strcpy(acl.taddr1, (char *)inet_ntoa(addr));
		strcpy(acl.taddr2, acl.taddr1);

		acl.taddrtype = AOS_FW_NET_IP;
		acl.tport1 = vs.usPortFrom;
		acl.tport2 = vs.usPortTo;

		acl.log = VS_LOG(vs) ? 1:0;
		
		if( acl.dport1 == 0 )	/* port start from 1 not 0 */
		{
			acl.dport1 = 1;
			acl.tport1 = 1;
		}
		switch (vs.cProtocolType)
		{
		case 1: // tcp 
			strcpy(acl.proto, "tcp");
			break;
		case 2: //udp
			strcpy(acl.proto, "udp");
			break;
		case 3: //udp & tcp 
			strcpy(acl.proto, "tcp");
			aos_fw_rule( &acl );
			strcpy(acl.proto, "udp");
			break;
		case 4: // ip 
			strcpy(acl.proto, "ip" );
			break;
		case 5:
			strcpy(acl.proto, "esp" );
			break;
		default:
			strcpy(acl.proto, "udp");
		}
		aos_fw_rule( &acl );

	return 0;

}


BOOL WRConfigVserver(VIRTUALHOSTITEM_T *pvVirtualHostItem, BOOL bForceUpdate)
{
	int i=0;

/*
	static VIRTUALHOSTITEM_T avVirtualHostItem_Last[MAX_VIRTUAL_HOST_ITEM];
	VIRTUALHOSTITEM_T avVirtualHostItem[MAX_VIRTUAL_HOST_ITEM];
	struct Virtual_Server vRealConfItem;
	unsigned long ulPrivateIP;
	
	ulPrivateIP = GetIPAddress(G_PC_ETH0);
	memcpy(avVirtualHostItem, pvVirtualHostItem, sizeof(avVirtualHostItem));
	for (i=0; i<MAX_VIRTUAL_HOST_ITEM; i++)
		(avVirtualHostItem+i)->ulIPAddress = IPMask((avVirtualHostItem+i)->ulIPAddress, ulPrivateIP, 0x00FFFFFF);
*/

	for (i=0; i<MAX_VIRTUAL_HOST_ITEM; i++)
	{
#ifdef XX
		if (__WRIsValidVirtualServerItem(avVirtualHostItem_Last + i))
		{
			if (!bForceUpdate)
			{
				for (j=0; j<MAX_VIRTUAL_HOST_ITEM; j++)
				{
					if (__WRCompareVirtualServerItem(avVirtualHostItem_Last + i, avVirtualHostItem + j, 1) == 0)
						break;
				}
			}

			if (bForceUpdate || j >= MAX_VIRTUAL_HOST_ITEM)
			{
				__WRConvert_VIRTUALHOSTITEM_T_Virtual_Server(avVirtualHostItem_Last + i, &vRealConfItem);
				if( avVirtualHostItem[i].bIsActivated == 0 )
				{
					//Del_virtual_server(&vRealConfItem);
					VS_Rule(avVirtualHostItem[i],AOS_FW_RULE_DEL);
				}
			}
		}
#endif
		VS_Rule(g_ConfigParam.avVirtualHostItem[i],AOS_FW_RULE_DEL);
		
	}

	for (i=0; i<MAX_VIRTUAL_HOST_ITEM; i++)
	{
#ifdef XX
		if (__WRIsValidVirtualServerItem(avVirtualHostItem + i))
		{
			if (!bForceUpdate)
			{
				for (j=0; j<MAX_VIRTUAL_HOST_ITEM; j++)
				{
					if (__WRCompareVirtualServerItem(avVirtualHostItem + i, avVirtualHostItem_Last + j, 1) == 0)
						break;
				}
			}

			if (bForceUpdate || j >= MAX_VIRTUAL_HOST_ITEM)
			{
				if( avVirtualHostItem[i].bIsActivated )
				{
					__WRConvert_VIRTUALHOSTITEM_T_Virtual_Server(avVirtualHostItem + i, &vRealConfItem);
					//Add_virtual_server(&vRealConfItem);
					//VS_Add(avVirtualHostItem[i]);
					VS_Rule(avVirtualHostItem[i],AOS_FW_RULE_ADD);
				}
			}
		}
#endif
		/* note: virtual server only support class c port redirect */
		pvVirtualHostItem[i].ulIPAddress = htonl( (ntohl(g_ConfigParam.ulPrivateIPAddress) & 0xffffff00) | (ntohl(pvVirtualHostItem[i].ulIPAddress) & 0x000000ff) );
		VS_Rule(pvVirtualHostItem[i],AOS_FW_RULE_ADD);
	}

	//memcpy(avVirtualHostItem_Last, avVirtualHostItem, sizeof(avVirtualHostItem_Last));
	/* call NAT_Entry_ClearAll() & flush udp/esp conntrack entries */
	nat_ip_filter_reset( NULL,0 ); /* this syscall api should rename to nat_reset_nata_cache_and_conntrack_udp_esp_cache() */

	return TRUE;
}

static int WRWriteVserverArgument(HTTPCONNECTION hConnection, char *pcBuf)
{
	int i;
	int iCount = 0;
	unsigned long ulPrivateIP;
	VIRTUALHOSTITEM_T *pItem;

	pItem = g_ConfigParam.avVirtualHostItem;
	ulPrivateIP = GetIPAddress(G_PC_ETH0);

	iCount = 0;

	iCount += sprintf(pcBuf+iCount, "var va_id = new Array(\n");
	for (i=0; i<MAX_VIRTUAL_HOST_ITEM; i++)
		iCount += sprintf(pcBuf+iCount, "%d,", VS_ACTIVE(pItem[i]) ? 1 : 0 );

	iCount += sprintf(pcBuf+iCount, "'');\nvar va_log = new Array(\n");
	for (i=0; i<MAX_VIRTUAL_HOST_ITEM; i++)
		iCount += sprintf(pcBuf+iCount, "%d,", VS_LOG(pItem[i]) ? 1 : 0 );
	
	iCount += sprintf(pcBuf+iCount, "'');\nvar va_Proto = new Array(\n");
	for (i=0; i<MAX_VIRTUAL_HOST_ITEM; i++)
		iCount += sprintf(pcBuf+iCount, "%d,", (int)pItem[i].cProtocolType);

	iCount += sprintf(pcBuf+iCount, "'');\nvar va_VserverPort = new Array(\n");
	for (i=0; i<MAX_VIRTUAL_HOST_ITEM; i++)
	{
		iCount += sprintf(pcBuf+iCount, "%d,%d,\n",
							(int)pItem[i].usPortFrom,
							(int)pItem[i].usPortTo);
	}

	iCount += sprintf(pcBuf+iCount, "'');\nvar va_ToAddr = new Array(\n");
	for (i=0; i<MAX_VIRTUAL_HOST_ITEM; i++)
	{
		char ac[16];
		IP2String(IPMask(pItem[i].ulIPAddress, ulPrivateIP, 0x00FFFFFF), ac);
		iCount += sprintf(pcBuf+iCount, "'%s',", ac);
	}
	iCount += sprintf(pcBuf+iCount, "'');\n");

	return iCount;
}



int Http_Vserver(HTTPCONNECTION hConnection, void *pParam)
{
	char *pcFile;
	if (WRExternalAdmin(hConnection) == 0) return 0;
	if ((pcFile = GetRequestFilePath(hConnection)) == NULL) return 0;
	SendHtmlWithParam(hConnection, pcFile, WRWriteVserverArgument);
	return 0;

	return 0;

}


int Http_Config_Vserver(HTTPCONNECTION hConnection, void *pParam)
{
	LIST *pList;
	BOOL bIsChange;
	int i;
	char pcName[32];

	/* Config params */
       VIRTUALHOSTITEM_T avVirtualHostItem[MAX_VIRTUAL_HOST_ITEM];
	memset( &avVirtualHostItem[0], 0, sizeof(avVirtualHostItem));
	pList = (LIST *)pParam;
	
	/* Read page parameters. */
	for (i=0; i<MAX_VIRTUAL_HOST_ITEM; i++)
	{
		sprintf(pcName, "WR_id%d", i);
		avVirtualHostItem[i].bActive_Log_BypassAcl |= VS_SET_ACTIVE( GetLong(pList, pcName) );
		sprintf(pcName, "WR_Log%d", i);
		avVirtualHostItem[i].bActive_Log_BypassAcl |= VS_SET_LOG( GetLong(pList, pcName) );
		sprintf(pcName, "WR_BypassAcl%d", i);
		avVirtualHostItem[i].bActive_Log_BypassAcl |= VS_SET_BYPASSACL( GetLong(pList, pcName) );
		sprintf(pcName, "IP_ToAddr%d", i);
		avVirtualHostItem[i].ulIPAddress =  (unsigned long)GetIP4(pList, pcName);
		sprintf(pcName, "Num_ToPortL%d", i);
		avVirtualHostItem[i].usPortFrom = (unsigned short)GetLong(pList, pcName);
		sprintf(pcName, "Num_ToPortH%d", i);
		avVirtualHostItem[i].usPortTo = (unsigned short)GetLong(pList, pcName);
		sprintf(pcName, "WR_Proto%d", i);
		avVirtualHostItem[i].cProtocolType = (char)(GetLong(pList, pcName) );
		if (avVirtualHostItem[i].usPortFrom > avVirtualHostItem[i].usPortTo)
			__SWAP(unsigned short, avVirtualHostItem[i].usPortFrom, avVirtualHostItem[i].usPortTo);

	}

	/* config */
	bIsChange = FALSE;

	if (__WRCompareVirtualServerItem(avVirtualHostItem, g_ConfigParam.avVirtualHostItem, MAX_VIRTUAL_HOST_ITEM) != 0)
	{
		if (WRConfigVserver(avVirtualHostItem, FALSE))
		{
			//WRConfigDMZ(g_ConfigParam.ulDMZHost, TRUE);
			memcpy(g_ConfigParam.avVirtualHostItem, avVirtualHostItem, sizeof(g_ConfigParam.avVirtualHostItem));
			//vs_install();
			bIsChange = TRUE;
		}
	}

	if (bIsChange)
	{
		//WebLog(CL_PRIVILEGE_ADMIN, CL_SET_VSERVER, NULL, hConnection);
		WriteFlashMemory(&g_ConfigParam);
	}
	
	SetKeepAliveMode(hConnection, FALSE);
	SendReDirectPage(hConnection);

	return 0;
}
