
#include "CommonDef.h"

int ConfigRead(char *pcFileName, WR_CONFIG_PARAM_T *pwConfigParam);
int ConfigWrite(char *pcFileName, WR_CONFIG_PARAM_T *pwConfigParam);

extern unsigned int g_model_id;
extern char g_model_name[32];

char *doslistname[]={"syn","icmp","udp","pingofdeath",
	"land","teardrop","srcroute","spoof",
	"tcpscan","smurf","winnuke" ,"portprobe","stealth" };

int Http_Config_Restore(char *pcFileName)
{
	WR_CONFIG_PARAM_T tempConfig;
	
	if( ConfigRead( CONFIG_UPDATE_TMP_FILE, &tempConfig ) != 0 )
	{
		printf("restore config failed\n");
		return -1;
	}
	WriteFlashMemory(&tempConfig);
	//skip this: memcpy( g_ConfigParam, tempConfig, sizeof(CONFIG_UPDATE_TMP_FILE));
	ConfigWrite( "/swap/config.cfg.restore", &tempConfig);
	
	return 0;
}

int Http_Config_Backup(HTTPCONNECTION hConnection, void *pParam)
{
	ConfigWrite( CONFIG_UPDATE_TMP_FILE, &g_ConfigParam );

	SetKeepAliveMode(hConnection, FALSE);
	SendReDirectHtml(hConnection, "message.htm", "config.cfg", TRUE, 1000, "MSG_BACKUP_OK", NULL );	

	return 0;

}

/* ACLID_1 = chain=1 srctype=0 srcip=0.0.0.0 srcmask=0.0.0.0 dsttype=0 dstip=0.0.0.0 dstmask=0.0.0.0 sporttype=0 sport0=0 sport1=0 dporttype=0 dport0=0 dport1=0 proto=0 action=0 icmptype=0 log=0 route= dstdomain= */
int parse_acl_pool(char *buf, fw_acl *acl, int id)
{
	char *p,*p2;
	char acName[32];
	char acValue[64];
	char tmp[128];
	
	memset(acl,0,sizeof(fw_acl));
	p = strtok(buf, " ,\t\r\n");
	if( p==NULL ) return 0;
	while(p)
	{
		memset(acName,0,sizeof(acName));
		memset(acValue,0,sizeof(acValue));
		strlcpy(tmp,p,sizeof(tmp));
		p2 = strchr(tmp, '=');
		*p2 = '\0';
		strlcpy(acName,tmp,sizeof(acName));
		strlcpy(acValue,p2+1,sizeof(acValue));
		if( acName[0] == '\0' ) return -1;
		if( acValue[0] == '\0')
		{
			if( strncmp(acName,"route",5)!=0 && 
				strncmp(acName,"dstdomain",9)!=0 )
			{
				printf("acName=%s value=NULL\n",acName);
				return -1;
			}
		}
		
		if( strncmp(acName,"chain",5)==0 )
			acl->chain = String2Long(acValue);
		else if( strncmp(acName,"srctype",7)==0 )
			acl->srctype = String2Long(acValue);
		else if( strncmp(acName,"srcip",5)==0 )
			acl->src = String2IP(acValue);
		else if( strncmp(acName,"srcmask",7)==0 )
			acl->smsk = String2IP(acValue);
		else if( strncmp(acName,"dsttype",7)==0 )
			acl->dsttype = String2Long(acValue);
		else if( strncmp(acName,"dstip",5)==0 )
			acl->dst = String2IP(acValue);
		else if( strncmp(acName,"dstmask",7)==0 )
			acl->dmsk = String2IP(acValue);
		else if( strncmp(acName,"sporttype",9)==0 )
			acl->sporttype = String2Long(acValue);
		else if( strncmp(acName,"sport0",6)==0 )
			acl->sport[0] = String2Long(acValue);
		else if( strncmp(acName,"sport1",6)==0 )
			acl->sport[1] = String2Long(acValue);
		else if( strncmp(acName,"dporttype",9)==0 )
			acl->dporttype = String2Long(acValue);
		else if( strncmp(acName,"dport0",6)==0 )
			acl->dport[0] = String2Long(acValue);
		else if( strncmp(acName,"dport1",6)==0 )
			acl->dport[1] = String2Long(acValue);
		else if( strncmp(acName,"proto",5)==0 )
			acl->proto = String2Long(acValue);
		else if( strncmp(acName,"action",6)==0 )
			acl->action = String2Long(acValue);
		else if( strncmp(acName,"icmptype",8)==0 )
			acl->icmptype = String2Long(acValue);
		else if( strncmp(acName,"log",3)==0 )
			acl->log = String2Long(acValue);
		else if( strncmp(acName,"route",5)==0 )
			strlcpy(acl->route, acValue,sizeof(acl->route));
		else if( strncmp(acName,"dstdomain",9)==0 )
			strlcpy(acl->dstdomain, acValue,sizeof(acl->dstdomain));
		else 
		{
			printf("acName=%s unrecognized\n",acName);
			return -1;
		}
		p = strtok(NULL, " ,\t\r\n");
	}		
	
	acl->id = id; /* set id only when parse ok */
	
	return 0;
}

int parse_acl_id(char *acValue, int *acl)
{
	char *p;
	int id;
	int index=0;
	
	memset(acl,0,sizeof(int)*MAX_IP_PORT_FILTER_ITEM);
	p = strtok(acValue, " ,\t\r\n");
	if( p==NULL ) return 0;
	while(p)
	{
		id = strtoul(p,NULL,10);
		if( id >= MAX_IP_PORT_FILTER_ITEM ) return -1;
		acl[index++] = id;
		p = strtok(NULL, " ,\t\r\n");
	}
	return 0;
}

int ConfigRead(char *pcFileName, WR_CONFIG_PARAM_T *pwConfigParam)
{
	int i;
	char acName[32];
	char acValue[256];
	LIST *pList;
	LISTNODE *pNode;


#define __ReadDefault(pcSeg, pcName, acVal) \
	{if (!ReadConfigValue(pcFileName, pcSeg, pcName, acVal, sizeof(acVal))) acVal[0] = '\0';}

	memset(pwConfigParam, 0, sizeof(WR_CONFIG_PARAM_T));

	__ReadDefault("BasicSetup", "ModelName", acValue);
	if( strncmp( acValue, g_model_name, sizeof(g_model_name)) != 0 )
	{
		printf("Incorrect mode name \n");
		return -1;
	}
	__ReadDefault("BasicSetup", "ModelId", acValue);
	if( strtoul(acValue,NULL,16) != g_model_id )
	{
		printf("Incorrect model id\n");
		return -1;
	}

	/* BasicSetup */
	__ReadDefault("BasicSetup", "HostName", acValue);
	MyStrncpy(pwConfigParam->acHostName, acValue, sizeof(pwConfigParam->acHostName));
	__ReadDefault("BasicSetup", "DomainName", acValue);
	MyStrncpy(pwConfigParam->acDomainName, acValue, sizeof(pwConfigParam->acDomainName));
	
	__ReadDefault("BasicSetup", "PrivateIPAddress", acValue);
	pwConfigParam->ulPrivateIPAddress = String2IP(acValue);
	__ReadDefault("BasicSetup", "PrivateSubnetMask", acValue);
	pwConfigParam->ulPrivateSubnetMask = String2IP(acValue);
	__ReadDefault("BasicSetup", "HowToGetIp", acValue);
	pwConfigParam->ulHowToGetIp = atoi(acValue);

	__ReadDefault("BasicSetup", "PublicIPAddress", acValue);
	pwConfigParam->ulPublicIpAddress = String2IP(acValue);
	__ReadDefault("BasicSetup", "PublicSubnetMask", acValue);
	pwConfigParam->ulPublicSubnetMask = String2IP(acValue);
	__ReadDefault("BasicSetup", "DefaultGateway", acValue);
	pwConfigParam->ulDefaultGateway = String2IP(acValue);
	for (i=0; i<MAX_DNS_SERVER; i++)
	{
		sprintf(acName, "DNSServer%d", i);
		__ReadDefault("BasicSetup", acName, acValue);
		pwConfigParam->aulDNSServer[i] = String2IP(acValue);
	}
	/* SNTP */
	__ReadDefault("SNTP", "SNTPEnable", acValue);
	MyStrncpy(pwConfigParam->tz.va_gmt, acValue, sizeof(pwConfigParam->tz.va_enable));
	__ReadDefault("SNTP", "SNTPTimezone", acValue);
	MyStrncpy(pwConfigParam->tz.va_gmt, acValue, sizeof(pwConfigParam->tz.va_gmt));
	__ReadDefault("SNTP", "SNTPServer0", acValue);
	MyStrncpy(pwConfigParam->tz.va_sntp0, acValue, sizeof(pwConfigParam->tz.va_sntp1));
	__ReadDefault("SNTP", "SNTPServer1", acValue);
	MyStrncpy(pwConfigParam->tz.va_sntp1, acValue, sizeof(pwConfigParam->tz.va_sntp1));
	__ReadDefault("SNTP", "SNTPServer2", acValue);
	MyStrncpy(pwConfigParam->tz.va_sntp2, acValue, sizeof(pwConfigParam->tz.va_sntp1));

	/* DHCPD */
	__ReadDefault("DHCPD", "DHCPDEnable", acValue);
	pwConfigParam->dhcp.enable = String2Bool(acValue);
	__ReadDefault("DHCPD", "DHCPDStartIP", acValue);
	pwConfigParam->dhcp.startip = String2IP(acValue);
	__ReadDefault("DHCPD", "DHCPDEndIP", acValue);
	pwConfigParam->dhcp.endip = String2IP(acValue);
	__ReadDefault("DHCPD", "DHCPDLeaseTime", acValue);
	pwConfigParam->dhcp.leasetime = String2Long(acValue);
	__ReadDefault("DHCPD", "DHCPDGateway", acValue);
	pwConfigParam->dhcp.defgw = String2IP(acValue);
	__ReadDefault("DHCPD", "DHCPDWINS0", acValue);
	pwConfigParam->dhcp.wins = String2IP(acValue);
	__ReadDefault("DHCPD", "DHCPDWINS1", acValue);
	pwConfigParam->dhcp.wins1 = String2IP(acValue);
	__ReadDefault("DHCPD", "DHCPDDNS0", acValue);
	pwConfigParam->dhcp.dns = String2IP(acValue);
	__ReadDefault("DHCPD", "DHCPDDNS1", acValue);
	pwConfigParam->dhcp.dns1 = String2IP(acValue);

	/* FIREWALL/NAT */
	for(i=0;i<DOS_LAST; i++)
	{
		snprintf(acName,sizeof(acName),"FW%s",doslistname[i]);
		__ReadDefault("FIREWALL/NAT", acName, acValue);
		pwConfigParam->fw_dos[i] = String2Long(acValue);
	}
	__ReadDefault("FIREWALL/NAT", "FWEnable", acValue);
	pwConfigParam->fw_rule = String2Long(acValue);
	__ReadDefault("FIREWALL/NAT", "NATEnable", acValue);
	pwConfigParam->fw_nat = String2Long(acValue);

	/* ACL */
	/* ACLID_1 = chain=1 srctype=0 srcip=0.0.0.0 srcmask=0.0.0.0 dsttype=0 dstip=0.0.0.0 dstmask=0.0.0.0 sporttype=0 sport0=0 sport1=0 dporttype=0 dport0=0 dport1=0 proto=0 action=0 icmptype=0 log=0 route= dstdomain= */
	for(i=0; i<MAX_IP_PORT_FILTER_ITEM; i++)
	{
		sprintf(acName,"ACLID_%d", i+1);
		__ReadDefault("ACL", acName, acValue);
		if( parse_acl_pool(acValue, &(pwConfigParam->fw_acl_pool[i]),i+1) != 0 )
			return -1;
	}
	__ReadDefault("ACL", "ACLIN", acValue);
	if( parse_acl_id(acValue, &(pwConfigParam->fw_acl_in[0]) ) != 0 )
		return -1;
	__ReadDefault("ACL", "ACLOUT", acValue);
	if( parse_acl_id(acValue, &(pwConfigParam->fw_acl_out[0]) ) != 0 )
		return -1;
	__ReadDefault("ACL", "ACLSELF", acValue);
	if( parse_acl_id(acValue, &(pwConfigParam->fw_acl_me[0]) ) != 0 )
		return -1;
	
	/* Virtual server */
	for (i=0; i<MAX_VIRTUAL_HOST_ITEM; i++)
	{
		VIRTUALHOSTITEM_T *pItem;

		sprintf(acName, "VirtualServer%d", i);
		__ReadDefault("VServer", acName, acValue);

		pItem = pwConfigParam->avVirtualHostItem + i;
		memset(pItem, 0, sizeof(VIRTUALHOSTITEM_T));

		pList = SplitString(acValue, ',');
		pNode = (pList==NULL?NULL:pList->pFirstNode);
		
		if (pNode != NULL && pNode != pList->pLastNode)
		{
			pItem->bActive_Log_BypassAcl = String2Long((char *)pNode->pValue);
			pNode = pNode->pNextNode;
		}
		if (pNode != NULL && pNode != pList->pLastNode)
		{
			pItem->ulIPAddress = String2IP((char *)pNode->pValue);
			pNode = pNode->pNextNode;
		}
		if (pNode != NULL && pNode != pList->pLastNode)
		{
			pItem->usPortFrom = (unsigned short)String2Long((char *)pNode->pValue);
			pNode = pNode->pNextNode;
		}
		if (pNode != NULL && pNode != pList->pLastNode)
		{
			pItem->usPortTo = (unsigned short)String2Long((char *)pNode->pValue);
			pNode = pNode->pNextNode;
		}
		if (pNode != NULL && pNode != pList->pLastNode)
		{
			pItem->cProtocolType = GetIPProtocol((char *)pNode->pValue);
		}
		if (pList) DeleteSplitString(pList);
	}

	/* ADMIN */
	__ReadDefault("Admin", "HttpPassword", acValue);
	if(strlen(acValue) <= 2)
		pwConfigParam->acHttpPassword[0] = '\0';
	else
	{
		acValue[strlen(acValue) - 1] = '\0';
		MyStrncpy(pwConfigParam->acHttpPassword, acValue + 1, sizeof(pwConfigParam->acHttpPassword));
	}

	__ReadDefault("Admin", "LanMacReconfig", acValue);
	pwConfigParam->bLanMacReconfig = String2Bool(acValue);

	__ReadDefault("Admin", "LanMacAddress", acValue);
	pList = SplitString(acValue, '-');
	pNode = pList->pFirstNode;
	memset(pwConfigParam->acLanMacAddress, 0, sizeof(pwConfigParam->acLanMacAddress));
	for (i=0; i<6; i++)
	{
		if (pNode != NULL && pNode != pList->pLastNode)
		{
			pwConfigParam->acLanMacAddress[i] = Hex2Char((char *)pNode->pValue);
			pNode = pNode->pNextNode;
		}
		else break;
	}
	if (pList) DeleteSplitString(pList);

	__ReadDefault("Admin", "WanMacReconfig", acValue);
	pwConfigParam->bWanMacReconfig = String2Bool(acValue);

	__ReadDefault("Admin", "WanMacAddress", acValue);
	pList = SplitString(acValue, '-');
	pNode = pList->pFirstNode;
	memset(pwConfigParam->acWanMacAddress, 0, sizeof(pwConfigParam->acWanMacAddress));
	for (i=0; i<6; i++)
	{
		if (pNode != NULL && pNode != pList->pLastNode)
		{
			pwConfigParam->acWanMacAddress[i] = Hex2Char((char *)pNode->pValue);
			pNode = pNode->pNextNode;
		}
		else break;
	}
	if (pList) DeleteSplitString(pList);

	/* skip factory wan mac addr */
	
	__ReadDefault("Admin", "UPNPEnable", acValue);
	pwConfigParam->bEnableUPNP = String2Bool(acValue);

	__ReadDefault("Admin", "IdleLogoutEnable", acValue);
	pwConfigParam->bEnableLogoutIdle = String2Bool(acValue);
	__ReadDefault("Admin", "IdleLogoutSec", acValue);
	pwConfigParam->usLogoutIdle = String2Long(acValue);
	__ReadDefault("Admin", "DNSProxyEnable", acValue);
	pwConfigParam->bEnableDnsProxy = String2Bool(acValue);
	__ReadDefault("Admin", "DNSProxyEnable", acValue);
	pwConfigParam->bEnableDnsProxy = String2Bool(acValue);
	__ReadDefault("Admin", "AdminLanEnable", acValue);
	pwConfigParam->bEnableAdminLan = String2Bool(acValue);
	__ReadDefault("Admin", "AdminWanEnable", acValue);
	pwConfigParam->bEnableAdminWan = String2Bool(acValue);
	__ReadDefault("Admin", "PingWanEnable", acValue);
	pwConfigParam->bEnablePingWan = String2Bool(acValue);
	__ReadDefault("Admin", "PingLanEnable", acValue);
	pwConfigParam->bEnablePingLan = String2Bool(acValue);
	__ReadDefault("Admin", "ExternalAdminPort", acValue);
	pwConfigParam->usExternalAdminPort = (unsigned short)String2Long(acValue);
	__ReadDefault("Admin", "NaptUnnumEnable", acValue);
	pwConfigParam->bEnableNaptUnnum = String2Bool(acValue);

	__ReadDefault("Admin", "Mtu", acValue);
	pwConfigParam->usMtu = atoi(acValue);
	if ( pwConfigParam->usMtu < MIN_VALID_MTU )
		pwConfigParam->usMtu = 0;
	__ReadDefault("Admin", "WanDuplex", acValue);
	pwConfigParam->ulWanDuplex= atoi(acValue);

	/* SROUTE */
	for (i=0; i<MAX_STATIC_ROUTING_ITEM; i++)
	{
		ROUTINGTABLE_T *pItem;

		sprintf(acName, "SRouting%d", i);
		__ReadDefault("SRouter", acName, acValue);

		pItem = pwConfigParam->arRoutingTableItem + i;
		memset(pItem, 0, sizeof(ROUTINGTABLE_T));

		pList = SplitString(acValue, ',');
		pNode = (pList==NULL?NULL:pList->pFirstNode);

		if (pNode != NULL && pNode != pList->pLastNode)
		{
			pItem->ulDestLanIPAddress = String2IP((char *)pNode->pValue);
			pNode = pNode->pNextNode;
		}
		if (pNode != NULL && pNode != pList->pLastNode)
		{
			pItem->ulSubnetMask = String2IP((char *)pNode->pValue);
			pNode = pNode->pNextNode;
		}
		if (pNode != NULL && pNode != pList->pLastNode)
		{
			pItem->ulDefaultGateway = String2IP((char *)pNode->pValue);
			pNode = pNode->pNextNode;
		}
		if (pNode != NULL && pNode != pList->pLastNode)
		{
			pItem->lMetric = (long)String2Long((char *)pNode->pValue);
			pNode = pNode->pNextNode;
		}
		if (pNode != NULL && pNode != pList->pLastNode)
		{
			char ifname[8];
			char origifname[8];
			int sp;
			memset(ifname,0,sizeof(ifname));
			memset(origifname,0,sizeof(origifname));

			strlcpy(origifname, (char*)pNode->pValue, sizeof(origifname));

			/* remove leading space */
			for(sp=0; sp<8; sp++)
			{
				if( *(origifname+sp) == '\0')
					break;
				if( isalpha( *(origifname+sp)  ) )
				{
					snprintf(ifname,sizeof(ifname),"%s", (origifname+sp) );
					break;
				}
			}
			MyStrncpy(pItem->cNetInterface, ifname, sizeof(pItem->cNetInterface));
		}
		if (pList != NULL) DeleteSplitString(pList);
	}

	/* PPPOE */
	for(i=0; i<MAX_PPPOE_AND_UNNUM; i++)
	{
		snprintf(acName,sizeof(acName),"PPPoE_%d_Enable",i);
		__ReadDefault("PPPoE", acName, acValue);
		pwConfigParam->pppoeConf[i].enable = String2Bool(acValue);

		snprintf(acName,sizeof(acName),"PPPoE_%d_Demand",i);
		__ReadDefault("PPPoE", acName, acValue);
		pwConfigParam->pppoeConf[i].demand = String2Bool(acValue);

		snprintf(acName,sizeof(acName),"PPPoE_%d_UserName",i);
		__ReadDefault("PPPoE", acName, acValue);
		MyStrncpy(pwConfigParam->pppoeConf[i].user, acValue, sizeof(pwConfigParam->pppoeConf[0].user));

		snprintf(acName,sizeof(acName),"PPPoE_%d_UserPass",i);
		__ReadDefault("PPPoE", acName, acValue);
		MyStrncpy(pwConfigParam->pppoeConf[i].pass, acValue, sizeof(pwConfigParam->pppoeConf[0].pass));

		snprintf(acName,sizeof(acName),"PPPoE_%d_ServiceName",i);
		__ReadDefault("PPPoE", acName, acValue);
		MyStrncpy(pwConfigParam->pppoeConf[i].srvname, acValue, sizeof(pwConfigParam->pppoeConf[0].srvname));

		snprintf(acName,sizeof(acName),"PPPoE_%d_ACName",i);
		__ReadDefault("PPPoE", acName, acValue);
		MyStrncpy(pwConfigParam->pppoeConf[i].acname, acValue, sizeof(pwConfigParam->pppoeConf[0].acname));

		snprintf(acName,sizeof(acName),"PPPoE_%d_IdleTimeout",i);
		__ReadDefault("PPPoE", acName, acValue);
		pwConfigParam->pppoeConf[i].idle = String2Long(acValue);

		snprintf(acName,sizeof(acName),"PPPoE_%d_IPAddr",i);
		__ReadDefault("PPPoE", acName, acValue);
		pwConfigParam->pppoeConf[i].loc_addr = String2IP(acValue);

		snprintf(acName,sizeof(acName),"PPPoE_%d_Netmask",i);
		__ReadDefault("PPPoE", acName, acValue);
		pwConfigParam->pppoeConf[i].netmask = String2IP(acValue);

		snprintf(acName,sizeof(acName),"PPPoE_%d_Network",i);
		__ReadDefault("PPPoE", acName, acValue);
		pwConfigParam->pppoeConf[i].network = String2IP(acValue);

		snprintf(acName,sizeof(acName),"PPPoE_%d_DNS1",i);
		__ReadDefault("PPPoE", acName, acValue);
		pwConfigParam->pppoeConf[i].dnsaddr[0] = String2IP(acValue);

		snprintf(acName,sizeof(acName),"PPPoE_%d_DNS2",i);
		__ReadDefault("PPPoE", acName, acValue);
		pwConfigParam->pppoeConf[i].dnsaddr[1] = String2IP(acValue);
		
	}
	/* SPECIAL */
	for (i=0; i<MAX_SPECIAL_APP_ITEM; i++)
	{
		SPECIALAPPLICATION_T *pItem;
		pItem = pwConfigParam->asSpecialAppItem + i;
		memset(pItem, 0, sizeof(SPECIALAPPLICATION_T));

		sprintf(acName, "Name_%d", i);
		__ReadDefault("SpecialApp", acName, acValue);
		MyStrncpy(pItem->acAppName, acValue, sizeof(pItem->acAppName));

		sprintf(acName, "Value_%d", i);
		__ReadDefault("SpecialApp", acName, acValue);

		pList = SplitString(acValue, ',');
		pNode = (pList==NULL?NULL:pList->pFirstNode);
		if (pNode != NULL && pNode != pList->pLastNode)
		{
			pItem->usInPortFrom = String2Long((char*)pNode->pValue);
			pNode = pNode->pNextNode;
		}
		if (pNode != NULL && pNode != pList->pLastNode)
		{
			pItem->usInPortTo = String2Long((char*)pNode->pValue);
			pNode = pNode->pNextNode;
		}
		if (pNode != NULL && pNode != pList->pLastNode)
		{
			pItem->usOutPortFrom = String2Long((char*)pNode->pValue);
			pNode = pNode->pNextNode;
		}
		if (pNode != NULL && pNode != pList->pLastNode)
		{
			pItem->usOutPortTo = String2Long((char*)pNode->pValue);
			pNode = pNode->pNextNode;
		}
		if (pNode != NULL && pNode != pList->pLastNode)
		{
			pItem->bIsActivated = String2Bool((char*)pNode->pValue);
		}
		if (pList != NULL) DeleteSplitString(pList);
	}
	
	/* DDNS */
	__ReadDefault("DDNS", "DDNSEnable", acValue);
	pwConfigParam->bEnableDDNS = String2Bool(acValue);
	__ReadDefault("DDNS", "DDNSDomain", acValue);
	MyStrncpy(pwConfigParam->acDDNSDomainName, acValue, sizeof(pwConfigParam->acDDNSDomainName));
	__ReadDefault("DDNS", "DDNSUserName", acValue);
	MyStrncpy(pwConfigParam->acDDNSUserName, acValue, sizeof(pwConfigParam->acDDNSUserName));
	__ReadDefault("DDNS", "DDNSPassword", acValue);
	MyStrncpy(pwConfigParam->acDDNSUserPass, acValue, sizeof(pwConfigParam->acDDNSUserPass));

	/* Set CheckSum */
	// pwConfigParam->ulCheckSum = GetConfigCheckSum(pwConfigParam); //will be set by WriteFlashMemory(), cannot set here!

	return 0;
}


int ConfigWrite(char *pcFileName, WR_CONFIG_PARAM_T *pwConfigParam)
{
	int i;
	FILE *fp;
	char ac[32], srcip[32],dstip[32], smsk[32], dmsk[32];
	char acMac[6][4];
	char buf[64];
	
	fp = fopen(pcFileName, "wt");
	if (fp == NULL) return FALSE;

	printf("model=%s , id=%04x\n",g_model_name, g_model_id);
	fflush(stdout);
	
	fprintf(fp, "[BasicSetup]\n");
	fprintf(fp, "ModelName = %s\n", g_model_name);
	
	snprintf(buf,sizeof(buf),"%s %s",WRGetProductName(),WRGetProductVersion());
	fprintf(fp, "Version = %s\n", buf);

	fprintf(fp, "ModelId = 0x%04x\n", g_model_id);
	fprintf(fp, "HostName = %s\n", pwConfigParam->acHostName);
	
	fprintf(fp, "DomainName = %s\n", pwConfigParam->acDomainName);
	IP2String(pwConfigParam->ulPrivateIPAddress, ac);
	fprintf(fp, "PrivateIPAddress = %s\n", ac);
	IP2String(pwConfigParam->ulPrivateSubnetMask, ac);
	fprintf(fp, "PrivateSubnetMask = %s\n", ac);
	fprintf(fp, "HowToGetIp = %d\n", (int)pwConfigParam->ulHowToGetIp);
	IP2String(pwConfigParam->ulPublicIpAddress, ac);
	fprintf(fp, "PublicIPAddress = %s\n", ac);
	IP2String(pwConfigParam->ulPublicSubnetMask, ac);
	fprintf(fp, "PublicSubnetMask = %s\n", ac);
	IP2String(pwConfigParam->ulDefaultGateway, ac);
	fprintf(fp, "DefaultGateway = %s\n", ac);
	for (i=0; i<MAX_DNS_SERVER; i++)
	{
		IP2String(pwConfigParam->aulDNSServer[i], ac);
		fprintf(fp, "DNSServer%d = %s\n", i, ac);
	}
	fprintf(fp, "\n");

	/* Timezone */
	fprintf(fp, "[SNTP]\n");
	fprintf(fp, "SNTPEnable = %d\n", pwConfigParam->tz.va_enable);
	fprintf(fp, "SNTPTimezone = %s\n",pwConfigParam->tz.va_gmt);
	fprintf(fp, "SNTPServer0 = %s\n",pwConfigParam->tz.va_sntp0);
	fprintf(fp, "SNTPServer1 = %s\n",pwConfigParam->tz.va_sntp1);
	fprintf(fp, "SNTPServer2 = %s\n",pwConfigParam->tz.va_sntp2);
	fprintf(fp, "\n");
	
	/* DHCP */
	fprintf(fp, "[DHCPD]\n");
	fprintf(fp, "DHCPDEnable = %d\n", (int)pwConfigParam->dhcp.enable);
	IP2String(pwConfigParam->dhcp.startip, ac);
	fprintf(fp, "DHCPDStartIP = %s\n", ac);
	IP2String(pwConfigParam->dhcp.endip, ac);
	fprintf(fp, "DHCPDEndIP = %s\n", ac);
	// subnet
	fprintf(fp, "DHCPDLeaseTime = %lu\n", pwConfigParam->dhcp.leasetime);
	IP2String(pwConfigParam->dhcp.defgw, ac);
	fprintf(fp, "DHCPDGateway = %s\n", ac);
	IP2String(pwConfigParam->dhcp.wins, ac);
	fprintf(fp, "DHCPDWINS0 = %s\n", ac);
	IP2String(pwConfigParam->dhcp.wins1, ac);
	fprintf(fp, "DHCPDWINS1 = %s\n", ac);
	IP2String(pwConfigParam->dhcp.dns, ac);
	fprintf(fp, "DHCPDDNS0 = %s\n", ac);
	IP2String(pwConfigParam->dhcp.dns1, ac);
	fprintf(fp, "DHCPDDNS1 = %s\n", ac);
	fprintf(fp, "\n");

	/* Firewall */
	fprintf(fp, "[FIREWALL/NAT]\n");
	for(i=0; i<DOS_LAST; i++)
		fprintf(fp, "FW%s = %d\n", doslistname[i],(int)pwConfigParam->fw_dos[i]);
	fprintf(fp,"FWEnable = %d\n", pwConfigParam->fw_rule);
	fprintf(fp,"NATEnable = %d\n", pwConfigParam->fw_nat);
	fprintf(fp, "\n");
	
	
	/* ACL */
	fprintf(fp, "[ACL]\n");
	for (i=0; i<MAX_IP_PORT_FILTER_ITEM; i++)
	{
		IP2String(pwConfigParam->fw_acl_pool[i].src, srcip);
		IP2String(pwConfigParam->fw_acl_pool[i].dst, dstip);
		IP2String(pwConfigParam->fw_acl_pool[i].smsk, smsk);
		IP2String(pwConfigParam->fw_acl_pool[i].dmsk, dmsk);
		
		if( pwConfigParam->fw_acl_pool[i].id == 0 )
			continue;

		fprintf(fp,"ACLID_%d = chain=%d srctype=%d srcip=%s srcmask=%s dsttype=%d dstip=%s dstmask=%s sporttype=%d sport0=%d sport1=%d dporttype=%d dport0=%d dport1=%d proto=%d action=%d icmptype=%d log=%d route=%s dstdomain=%s\n",
			i+1,
			pwConfigParam->fw_acl_pool[i].chain,
			pwConfigParam->fw_acl_pool[i].srctype,
			srcip,
			smsk,
			pwConfigParam->fw_acl_pool[i].dsttype,
			dstip,
			dmsk,
			pwConfigParam->fw_acl_pool[i].sporttype,
			pwConfigParam->fw_acl_pool[i].sport[0],
			pwConfigParam->fw_acl_pool[i].sport[1],
			pwConfigParam->fw_acl_pool[i].dporttype,
			pwConfigParam->fw_acl_pool[i].dport[0],
			pwConfigParam->fw_acl_pool[i].dport[1],
			pwConfigParam->fw_acl_pool[i].proto,
			pwConfigParam->fw_acl_pool[i].action,
			pwConfigParam->fw_acl_pool[i].icmptype,
			pwConfigParam->fw_acl_pool[i].log,
			pwConfigParam->fw_acl_pool[i].route,
			pwConfigParam->fw_acl_pool[i].dstdomain
			);
	}
	
	
	fprintf(fp,"ACLIN =");
	for (i=0; i<MAX_IP_PORT_FILTER_ITEM; i++)
	{
		if( pwConfigParam->fw_acl_in[i] == 0 ) break;
		fprintf(fp," %d",pwConfigParam->fw_acl_in[i]);
	}
	fprintf(fp,"\nACLOUT =");
	for (i=0; i<MAX_IP_PORT_FILTER_ITEM; i++)
	{
		if( pwConfigParam->fw_acl_out[i] == 0 ) break;
		fprintf(fp," %d",pwConfigParam->fw_acl_out[i]);
	}
	fprintf(fp,"\nACLSELF =");
	for (i=0; i<MAX_IP_PORT_FILTER_ITEM; i++)
	{
		if( pwConfigParam->fw_acl_me[i] == 0 ) break;
		fprintf(fp," %d",pwConfigParam->fw_acl_me[i]);
	}
	fprintf(fp, "\n\n");

	/* Virtual Server */
	fprintf(fp, "[VServer]\n");
	for (i=0; i<MAX_VIRTUAL_HOST_ITEM; i++)
	{
		VIRTUALHOSTITEM_T *pItem;
		pItem = pwConfigParam->avVirtualHostItem + i;
		IP2String(pItem->ulIPAddress, ac);
		fprintf(fp, "VirtualServer%d = %d, %s, %d, %d, %s\n", 
			i,
			pItem->bActive_Log_BypassAcl,
			ac,
			(int)pItem->usPortFrom,
			(int)pItem->usPortTo,
			GetIPProtocolString(pItem->cProtocolType));
	}
	fprintf(fp, "\n");

	/* ADMIN */
	fprintf(fp, "[Admin]\n");
	fprintf(fp, "HttpPassword = {%s}\n", pwConfigParam->acHttpPassword);

	for (i=0; i<6; i++)
		Char2Hex(pwConfigParam->acLanMacAddress[i], acMac[i]);
	fprintf(fp, "LanMacAddress = %s-%s-%s-%s-%s-%s",acMac[0],acMac[1],acMac[2],acMac[3],acMac[4],acMac[5]);

	fprintf(fp, "\nLanMacReconfig = %d\n", pwConfigParam->bLanMacReconfig);

	for (i=0; i<6; i++)
		Char2Hex(pwConfigParam->acWanMacAddress[i], acMac[i]);

	fprintf(fp, "WanMacAddress = %s-%s-%s-%s-%s-%s",acMac[0],acMac[1],acMac[2],acMac[3],acMac[4],acMac[5]);
	fprintf(fp, "\nWanMacReconfig = %d\n", pwConfigParam->bWanMacReconfig);

	for (i=0; i<6; i++)
		Char2Hex(pwConfigParam->acFactoryWanMacAddress[i], acMac[i]);
	fprintf(fp, "FactoryWanMacAddress = %s-%s-%s-%s-%s-%s",acMac[0],acMac[1],acMac[2],acMac[3],acMac[4],acMac[5]);
	fprintf(fp,"\n");

	fprintf(fp, "UPNPEnable = %d\n", (int)pwConfigParam->bEnableUPNP);
	fprintf(fp, "IdleLogoutEnable = %d\n", (int)pwConfigParam->bEnableLogoutIdle);
	fprintf(fp, "IdleLogoutSec = %d\n", (int)pwConfigParam->usLogoutIdle);
	fprintf(fp, "DNSProxyEnable = %d\n", (int)pwConfigParam->bEnableDnsProxy);
	fprintf(fp, "AdminLanEnable = %d\n", (int)pwConfigParam->bEnableAdminLan);
	fprintf(fp, "AdminWanEnable = %d\n", (int)pwConfigParam->bEnableAdminWan);
	fprintf(fp, "PingLanEnable = %d\n", (int)pwConfigParam->bEnablePingLan);
	fprintf(fp, "PingWanEnable = %d\n", (int)pwConfigParam->bEnablePingWan);
	
	fprintf(fp, "Mtu = %d\n", (int)pwConfigParam->usMtu);
	fprintf(fp, "WanDuplex = %d\n", (int)pwConfigParam->ulWanDuplex);

	fprintf(fp, "ExternalAdminPort = %d\n", (int)pwConfigParam->usExternalAdminPort);
	fprintf(fp, "NaptUnnumEnable = %d\n", (int)pwConfigParam->bEnableNaptUnnum);

	fprintf(fp, "\n");

	/* static route */
	fprintf(fp, "[SRouter]\n");
	for (i=0; i<MAX_STATIC_ROUTING_ITEM; i++)
	{
		ROUTINGTABLE_T *pItem;

		pItem = pwConfigParam->arRoutingTableItem + i;

		if( pItem->lMetric >= 256 ) break;
		if( strncmp(pItem->cNetInterface,"eth",3) &&
			strncmp(pItem->cNetInterface,"ppp",3) )
			break;
		
		//if( pItem->ulDefaultGateway == 0 && pItem->ulDestLanIPAddress == 0 )
		//	break;			
		IP2String(pItem->ulDestLanIPAddress, ac);
		fprintf(fp, "SRouting%d = %s, ", i, ac);
		IP2String(pItem->ulSubnetMask, ac);
		fprintf(fp, "%s, ", ac);
		IP2String(pItem->ulDefaultGateway, ac);
		fprintf(fp, "%s, %d, %s\n",
			ac,
			(int)pItem->lMetric,
			pItem->cNetInterface);
	}
	fprintf(fp, "\n");

	/* PPPoE */
	fprintf(fp, "[PPPoE]\n");
	for(i=0; i<MAX_PPPOE_AND_UNNUM; i++)
	{
		fprintf(fp, "PPPoE_%d_Enable = %d\n", i,(int)pwConfigParam->pppoeConf[i].enable);
		fprintf(fp, "PPPoE_%d_Demand = %d\n", i,(int)pwConfigParam->pppoeConf[i].demand);
		fprintf(fp, "PPPoE_%d_UserName = %s\n", i,pwConfigParam->pppoeConf[i].user);
		fprintf(fp, "PPPoE_%d_UserPass = %s\n", i,pwConfigParam->pppoeConf[i].pass);
		fprintf(fp, "PPPoE_%d_ServiceName = %s\n", i,pwConfigParam->pppoeConf[i].srvname);
		fprintf(fp, "PPPoE_%d_ACName = %s\n", i,pwConfigParam->pppoeConf[i].acname);
		fprintf(fp, "PPPoE_%d_IdleTimeout = %u\n", i,(unsigned int)pwConfigParam->pppoeConf[i].idle);
		
		fprintf(fp, "PPPoE_%d_IPAddr = %s\n", i, int_ntoa(pwConfigParam->pppoeConf[i].loc_addr));
		fprintf(fp, "PPPoE_%d_Netmask = %s\n", i,int_ntoa(pwConfigParam->pppoeConf[i].netmask));
		fprintf(fp, "PPPoE_%d_Network = %s\n", i,int_ntoa(pwConfigParam->pppoeConf[i].network));
		fprintf(fp, "PPPoE_%d_DNS1 = %s\n", i, int_ntoa(pwConfigParam->pppoeConf[i].dnsaddr[0]));
		fprintf(fp, "PPPoE_%d_DNS2 = %s\n", i, int_ntoa(pwConfigParam->pppoeConf[i].dnsaddr[1]));
	}
	fprintf(fp, "\n");

	/* SpecialApp.htm */
	fprintf(fp, "[SpecialApp]\n");
	fprintf(fp, "# Name_<n> = <Application Name>\n");
	fprintf(fp, "# Value_<n> = <InPortFrom>, <InPortTo>, <OutPortFrom>, <OutPortTo>, <IsActive>\n");
	for (i=0; i<MAX_SPECIAL_APP_ITEM; i++)
	{
		SPECIALAPPLICATION_T *pItem;
		pItem = pwConfigParam->asSpecialAppItem + i;
		fprintf(fp, "Name_%d = %s\n", i, pItem->acAppName);
		fprintf(fp, "Value_%d = %d, %d, %d, %d, %d\n", i,
			(int)pItem->usInPortFrom,
			(int)pItem->usInPortTo,
			(int)pItem->usOutPortFrom,
			(int)pItem->usOutPortTo,
			(int)pItem->bIsActivated);
	}
	fprintf(fp, "\n");

	/* DDNS */
	fprintf(fp, "[DDNS]\n");
	fprintf(fp, "DDNSEnable = %d\n", (int)pwConfigParam->bEnableDDNS);
	fprintf(fp, "DDNSDomain = %s\n", pwConfigParam->acDDNSDomainName);
	fprintf(fp, "DDNSUserName = %s\n", pwConfigParam->acDDNSUserName);
	fprintf(fp, "DDNSPassword = %s\n", pwConfigParam->acDDNSUserPass);
	fprintf(fp, "\n");

	fclose(fp);
	return TRUE;
}
