#include "CommonDef.h"

/* Return:
	1 - OK
	0 - FAILE
*/

int ddns_getstate(char *file)
{
	FILE *fr;
	char *p;
	char buf[100];
	char msg[128];
	int ret = 0;

	memset(msg,0,sizeof(msg));
	
	if((fr = fopen(file,"rt"))== NULL)
	{
		//printf("Can't Open %s\n", file );
		return -1;
	}	
 
	while(fgets(buf, sizeof(buf),fr) != NULL)
	{
		if( buf[0] == '#' || buf[0] == '\r' || buf[0]=='\n' ) continue;

		p=strtok(buf,":\n\r ");

		if(p==NULL)	break;
		printf("read status of ddns: %s\n",p);

		if( strcmp(p, "UPDATERES_OK" )==0 )
		{
			ret = DO_DDNS_UPDATE_OK;
			strcpy(msg, "Update OK" );
		}
		else if( strcmp(p, "NOT_UPDATED")==0 )
		{
			ret = DO_DDNS_NO_UPDATE;
			strcpy(msg, "Not updated" );
		}
		else if( strcmp(p, "UPDATING" )==0 )
		{
			ret = DO_DDNS_UPDATING;
			strcpy(msg, "Updating...");
		}
		else if( strcmp(p, "UPDATERES_ERROR_RESOLVE_SERVER" ) ==0 )
		{
			ret = DO_DDNS_UPDATE_FAIL;
			strcpy(msg, "Fail to look up dns server");
		}
		else if( strcmp(p, "UPDATERES_ERROR_CONNECT" )==0 )
		{
			ret = DO_DDNS_UPDATE_FAIL;
			strcpy(msg, "Connect fail");
		}
		else if( strcmp(p, "UPDATERES_SHUTDOWN_BADAUTH" )==0 )
		{
			ret = DO_DDNS_UPDATE_FAIL;
			strcpy(msg, "Authentication failure" );
		}
		else if( strcmp(p, "UPDATERES_SHUTDOWN_BADSYS" )==0 )
		{
			ret = DO_DDNS_UPDATE_FAIL;
			strcpy(msg,  "Invalid system parameter");
		}
		else if( strcmp(p, "UPDATERES_SHUTDOWN_BADAGENT" )==0 )
		{
			ret = DO_DDNS_UPDATE_FAIL;
			strcpy(msg,  "This useragent has been blocked");
		}	
		else if( strcmp(p, "UPDATERES_SHUTDOWN_NUMHOST" )==0 )
		{
			ret = DO_DDNS_UPDATE_FAIL;
			strcpy(msg,  "Too many or too few hosts found");
		}	
		else if( strcmp(p, "UPDATERES_ERROR_DNSERR")==0 )
		{
			ret = DO_DDNS_UPDATE_FAIL;
			strcpy(msg,  "Dyndns internal error");
		}	
		else if( strcmp(p, "UPDATERES_SHUTDOWN_911" )==0 )
		{
			ret = DO_DDNS_UPDATE_FAIL;
			strcpy(msg,  "Error Code: 911");
		}	
		else if( strcmp(p, "UPDATERES_SHUTDOWN_999" )==0 )
		{
			ret = DO_DDNS_UPDATE_FAIL;
			strcpy(msg,  "Error Code: 999");
		}	
		else if( strcmp(p, "UPDATERES_OK_NOTDONATOR" )==0 )
		{
			ret = DO_DDNS_UPDATE_FAIL;
			strcpy(msg,  "A feature requested is only available to donators");
		}	
		else if( strcmp(p, "UPDATERES_ERROR_WAITRESP")==0 )
		{
			ret = DO_DDNS_UPDATE_FAIL;
			strcpy(msg,  "Waiting for response");
		}	
		else if( strcmp(p, "UPDATERES_ERROR_PROCESS" )==0 )
		{
			ret = DO_DDNS_UPDATE_FAIL;
			strcpy(msg,  "Error processing request");
		}	
		else if( strcmp(p, "UPDATERES_ERROR_UNKNOWN" )==0 )
		{
			ret = DO_DDNS_UPDATE_FAIL;
			strcpy(msg,   "Unknown error" );
		}	
		else if( strcmp(p, "UPDATERES_ERROR_STRANGE" )==0 )
		{
			ret = DO_DDNS_UPDATE_FAIL;
			strcpy(msg,  "Strange server response");
		}	
		else if( strcmp(p, "UPDATERES_SHUTDOWN_NOHOST" )==0 )
		{
			ret = DO_DDNS_UPDATE_FAIL;
			strcpy(msg,  "Invalid domain name");
		}	
		else if( strcmp(p, "UPDATERES_SHUTDOWN_NOTFQDN" )==0 )
		{
			ret = DO_DDNS_UPDATE_FAIL;
			strcpy(msg,  "Malformed domain name");
		}	
		else if( strcmp(p, "UPDATERES_SHUTDOWN_NOTYOURS" )==0 )
		{
			ret = DO_DDNS_UPDATE_FAIL;
			strcpy(msg,  "Not your domain name");
		}	
		else if( strcmp(p, "UPDATERES_SHUTDOWN_ABUSE" )==0 )
		{
			ret = DO_DDNS_UPDATE_FAIL;
			strcpy(msg,  "The domain name has been blocked for abuse");
		}	
		else if( strcmp(p, "UPDATERES_ERROR_SERVER_NOTREADY" )==0 )
		{
			ret = DO_DDNS_UPDATE_FAIL;
			strcpy(msg,  "Server not ready");
		}	
		break;
		
   	}    
	
	fclose(fr);
    	return ret;	
}

int get_ddns(HTTPCONNECTION hConnection, void *pParam)
{
	char *pcFile;
	const char *pcDDNSState;

	if (WRExternalAdmin(hConnection) == 0) return 0;
	if ((pcFile = GetRequestFilePath(hConnection)) == NULL) return 0;

	g_RunTimeState.iDDNSState = ddns_getstate( DDNS_STATUS );
	
	switch (g_RunTimeState.iDDNSState)
	{
	case DO_DDNS_UPDATE_OK:
		pcDDNSState = 0;//"Updated";
		break;
	case DO_DDNS_UPDATE_FAIL:
		pcDDNSState = 1;//"Updating Failed";
		break;
	case DO_DDNS_UPDATING:
		pcDDNSState = 3;//"Updating...";
		break;
	default:
		pcDDNSState = 2;//"Not Update";
		break;
	}

	SendHtmlWithParam(hConnection, pcFile,
		(int)g_ConfigParam.bEnableDDNS,
		g_ConfigParam.acDDNSUserName,
		g_ConfigParam.acDDNSUserPass,
		g_ConfigParam.acDDNSDomainName,
		pcDDNSState,
		g_ConfigParam.acProxy,
		g_ConfigParam.acProxyUser,
		g_ConfigParam.acProxyPass
		);
	return 0;

}

char *getWanIfName( int type )
{
	char *ifname[]={"eth1", "ppp0", "ppp1", "ppp2" };
	int n = 0;
	
	switch( g_ConfigParam.ulHowToGetIp)
	{
	case GETIP_MAN:  n=0;break;
	case GETIP_DHCP:  n=0;break;
	case GETIP_PPP:  n=2;break;
	case GETIP_UNNUM:  n=1;break;
	default:
		n = 0 ; break;
	}
	return ifname[n];
}

int ddns_writeconf( char *file)
{
	FILE *fw;

	if( (fw=fopen(file,"wt"))==NULL )
		return -1;

	fprintf(fw, "service-type=DynDNS\n");
	fprintf(fw, "user=%s:%s\n", 
		g_ConfigParam.acDDNSUserName,
		g_ConfigParam.acDDNSUserPass );
	fprintf(fw, "host=%s\n", g_ConfigParam.acDDNSDomainName);
	fprintf(fw, "interface=%s\n", getWanIfName(  g_ConfigParam.ulHowToGetIp ) );
	fprintf(fw, "max-interval=86400\n");
	fclose(fw);

	return 0;
}

int writeFile( char * file, char *str)
{
	FILE *fp;

	if( (fp=fopen(file,"wt"))==NULL )
		return -1;
	fprintf(fp, "%s", str);
	fclose(fp);
	return 0;
}

int	ddns_install(void)
{
	KillAllProc( PROG_DDNS );
	writeFile( DDNS_STATUS, "UPDATING" );
	g_RunTimeState.iDDNSState = DO_DDNS_UPDATING;
	RunProgram( NULL, PROG_DDNS , "-c", DDNS_CONF, "-z" , DDNS_STATUS, "-d" , NULL );
	return 0;
}
		
int post_ddns(HTTPCONNECTION hConnection, void *pParam)
{
	LIST *pList;
	BOOL bIsChange;

	BOOL bEnableDDNS;
	const char *pcDDNSUserName;
	const char *pcDDNSUserPass;
	const char *pcDDNSDomainName;
	const char *pcProxy;
	const char *pcProxyUser;
	const char *pcProxyPass;
	unsigned long ulDDNSIP;
	BOOL bIsChangeDDNS;

	pList = (LIST *)pParam;

	bEnableDDNS = GetBool(pList, "WR_EnableDDNS");
	pcDDNSUserName = GetString(pList, "Txt_DDNSUserName");
	pcDDNSUserPass = GetString(pList, "Txt_DDNSUserPass");
	pcDDNSDomainName = GetString(pList, "Txt_DDNSDomainName");
	pcProxy = GetString(pList, "Txt_DDNSProxy");
	pcProxyUser = GetString(pList, "Txt_DDNSProxyUser");
	pcProxyPass = GetString(pList, "Txt_DDNSProxyPass");
	ulDDNSIP = GetIP4(pList, "IP_DDNS");

	/* Config */
	bIsChange = FALSE;

	if (bEnableDDNS != g_ConfigParam.bEnableDDNS
		|| strcmp(pcDDNSUserName, g_ConfigParam.acDDNSUserName) != 0
		|| strcmp(pcDDNSUserPass, g_ConfigParam.acDDNSUserPass) != 0
		|| strcmp(pcDDNSDomainName, g_ConfigParam.acDDNSDomainName) != 0
		|| strcmp(pcProxy, g_ConfigParam.acProxy) != 0
		|| strcmp(pcProxyUser, g_ConfigParam.acProxyUser) == 0
		|| strcmp(pcProxyPass, g_ConfigParam.acProxyPass) == 0)
	{
		g_ConfigParam.bEnableDDNS = bEnableDDNS;
		MyStrncpy(g_ConfigParam.acDDNSUserName, pcDDNSUserName, sizeof(g_ConfigParam.acDDNSUserName));
		MyStrncpy(g_ConfigParam.acDDNSUserPass, pcDDNSUserPass, sizeof(g_ConfigParam.acDDNSUserPass));
		MyStrncpy(g_ConfigParam.acDDNSDomainName, pcDDNSDomainName, sizeof(g_ConfigParam.acDDNSDomainName));
		MyStrncpy(g_ConfigParam.acProxy, pcProxy, sizeof(g_ConfigParam.acProxy));
		MyStrncpy(g_ConfigParam.acProxyUser, pcProxyUser, sizeof(g_ConfigParam.acProxyUser));
		MyStrncpy(g_ConfigParam.acProxyPass, pcProxyPass, sizeof(g_ConfigParam.acProxyPass));
		bIsChange = TRUE;
		bIsChangeDDNS = TRUE;
	}
	else bIsChangeDDNS = FALSE;

	if (g_ConfigParam.bEnableDDNS && (bIsChangeDDNS || g_RunTimeState.iDDNSState != DDNS_UPDATE_OK))
	{
		ddns_writeconf(  DDNS_CONF );
		ddns_install();
/*
		unsigned long def_wan_ip = 0;
		
		//printf("%x\n", ulDDNSIP); PTE;
		if( (def_wan_ip = GetDefaultWanIP()) )
		{
			Do_DDNS(pcDDNSDomainName,
				def_wan_ip,
				pcDDNSUserName,
				pcDDNSUserPass,
				pcProxy,
				pcProxyUser,
				pcProxyPass);
		}
*/
	}
	else if( g_ConfigParam.bEnableDDNS == FALSE )
	{
		KillAllProc(  PROG_DDNS );
		g_RunTimeState.iDDNSState = DO_DDNS_NO_UPDATE;
		wipeout( DDNS_STATUS );
	}

	SetKeepAliveMode(hConnection, FALSE);
	if (bIsChange) WriteFlashMemory(&g_ConfigParam);
	SendReDirectPage(hConnection);
	return 0;
}
