#ifndef _DHCP_H
#define _DHCP_H

#define DEFAULT_LEASETIME	864000	/* 10 days */
#define MIN_LEASETIME		120	/* 1 hour */
#define MAX_LEASETIME		86400*30 /* 30 days */

/* start dhcp client program (/bin/dhcpc). */
BOOL WRRunDHCPClient();

/* stop dhcp client program (/bin/dhcpc). */
BOOL WRStopDHCPClient();

/* do with the http request ".../Dhcp.htm". */
int get_dhcp(HTTPCONNECTION hConnection, void *pParam);

/* do with the http request "ConfigDhcp". */
int post_dhcp(HTTPCONNECTION hConnection, void *pParam);

/* Check if dhcp sevice is enabled. */
BOOL WRIsEnableDHCPServer( void );

/* Enable or disable dhcp sevice. */
BOOL WREnableDHCPServer(BOOL bIsEnable);

/* Get Dhcp service information, include ip address, release time & remain time. */
BOOL WRGetDHCPInfo(unsigned long *pulDHCPAddressFrom, unsigned long *pulDHCPAddressTo, 
	unsigned long *pulLeasedTime_InSec, unsigned long *pulRemainTime_InSec,
	unsigned long *pulDHCPDns1, unsigned long *pulDHCPDns2 );

/* Set dhcp address. */
BOOL WRSetDHCPAddressRange(unsigned long ulLowAddress, unsigned long ulHighAddress);

void dhcpd_update(unsigned long,unsigned long,unsigned long);
void dhcpd_install();

#endif
