#include "CommonDef.h"
#include "acl_rule.h"

char *doslist[]={"va_syn","va_udp","va_icmp","va_spoof","va_pingofdeath",
	"va_land","va_teardrop","va_srcroute",
	"va_tcpscan","va_smurf","va_winnuke" ,"va_portprobe","va_stealth","va_last" };

#define SYSCTL_IP_CONNTRACK_DOS	"/proc/sys/net/ipv4/ip_conntrack_dos"
#define SYSCTL_IP_FW_ENABLE	"/proc/sys/net/ipv4/fw_enable"
#define SYSCTL_ICMPRATE_LIMIT_MIB	"/proc/sys/net/ipv4/icmp_ratelimit"
#define SYSCTL_DROP_FLOODING_MIB	"/proc/sys/net/ipv4/netfilter/drop_flooding"

char *dossysctllist[]={
	"/proc/sys/net/ipv4/netfilter/synflood",
	"/proc/sys/net/ipv4/netfilter/udpflood",
	"/proc/sys/net/ipv4/netfilter/icmpflood",
	"/proc/sys/net/ipv4/netfilter/drop_ipspoof",
	"/proc/sys/net/ipv4/netfilter/drop_pingofdeath",
	"/proc/sys/net/ipv4/netfilter/drop_land",
	"/proc/sys/net/ipv4/netfilter/drop_teardrop",
	"/proc/sys/net/ipv4/netfilter/drop_ipsrcroute",
	"/proc/sys/net/ipv4/netfilter/drop_tcpscan",
	"/proc/sys/net/ipv4/netfilter/drop_smurf",
	"/proc/sys/net/ipv4/netfilter/drop_winnuke",
	"/proc/sys/net/ipv4/netfilter/portprobe",
	"/proc/sys/net/ipv4/netfilter/stealth"
};

int sysctlRead(  char *mib, unsigned long *value)
{
	FILE* fp;
	int x;
	
	fp = fopen(mib,"r");
	
	if(fp==NULL)
	{
		fprintf(stderr,"\nsysctl open error %s", mib );
		return -1;
	}
	
	fscanf(fp,"%d",&x);
	fclose(fp);

	if( value ) *value = x;	
	
	return x;
}

int sysctlWrite( char *mib, unsigned long value)
{
	FILE* fp;

	fp = fopen(mib,"w");
	
	if(fp==NULL)
	{
		fprintf(stderr,"\nsysctl open error %s", mib );
		return -1;
	}
	
	fprintf(fp,"%lu",value);
	fclose(fp);
	
	return 0;
}


void dos_install(void)
{
	int j;

	if( strncmp(WRGetProductName(),"brl-04gp", strlen("brl-04gp") ) != 0 )
		sysctlWrite(SYSCTL_DROP_FLOODING_MIB, 1 ); //alwasy enable for RX3141
	sysctlWrite(SYSCTL_IP_FW_ENABLE, g_ConfigParam.fw_rule );
	fwstate_check( g_ConfigParam.fw_rule );
	nat_install( g_ConfigParam.fw_nat );
	policy_install( g_ConfigParam.fw_rule );

	sysctlWrite( SYNFLOODLIMIT_MIB, g_ConfigParam.synflood_threshold );
	sysctlWrite( UDPFLOODLIMIT_MIB, g_ConfigParam.udpflood_threshold );
	sysctlWrite( ICMPFLOODLIMIT_MIB, g_ConfigParam.icmpflood_threshold );
	
	/* dos */
	for(j=0; j<DOS_LAST; j++)
	{
		sysctlWrite( dossysctllist[ j ] , g_ConfigParam.fw_dos[j]);
	}
	
}

void dos_default()
{
	int j=0;
	
	g_ConfigParam.fw_nat = 1;
	//g_ConfigParam.fw_deny = 0;
	g_ConfigParam.fw_rule = 1;
	g_ConfigParam.synflood_threshold = SYNFLOODTHRESH;
	g_ConfigParam.udpflood_threshold = UDPFLOODTHRESH;
	g_ConfigParam.icmpflood_threshold = ICMPFLOODTHRESH;

	for(j=0; j<DOS_LAST; j++)
		g_ConfigParam.fw_dos[j] = 1;

	if( strncmp(WRGetProductName(),"brl-04gp", strlen("brl-04gp") ) != 0 )
	{
		g_ConfigParam.fw_dos[ DOS_IPSPOOF ] = 0;
		g_ConfigParam.fw_dos[ DOS_SYN ] = 0;
		g_ConfigParam.fw_dos[ DOS_UDP ] = 0;
		g_ConfigParam.fw_dos[ DOS_ICMP ] = 0;
		g_ConfigParam.fw_dos[ DOS_STEALTH ] = 0;
	}
}


int WRWriteDoSArgument(HTTPCONNECTION hConnection, char *buf)
{
	int j=0,i=0;
	
	sysctlRead( SYNFLOODLIMIT_MIB, &g_ConfigParam.synflood_threshold );
	sysctlRead( UDPFLOODLIMIT_MIB, &g_ConfigParam.udpflood_threshold );
	sysctlRead( ICMPFLOODLIMIT_MIB, &g_ConfigParam.icmpflood_threshold );
	
	i+=sprintf(buf+i,"\nvar va_nat = '%d';",g_ConfigParam.fw_nat );
	//i+=sprintf(buf+i,"\nvar va_deny = '%d';",g_ConfigParam.fw_deny );
	i+=sprintf(buf+i,"\nvar va_rule = '%d';",g_ConfigParam.fw_rule );
	i+=snprintf(buf+i,sizeof(buf)-i,"\nvar va_synfloodthresh = '%lu';",g_ConfigParam.synflood_threshold );
	i+=snprintf(buf+i,sizeof(buf)-i,"\nvar va_udpfloodthresh = '%lu';",g_ConfigParam.udpflood_threshold );
	i+=snprintf(buf+i,sizeof(buf)-i,"\nvar va_icmpfloodthresh = '%lu';",g_ConfigParam.icmpflood_threshold );

	for(j=0; j<DOS_LAST; j++)
	{
		i+= sprintf(buf+i,"\nvar %s = '%d';",doslist[j],g_ConfigParam.fw_dos[j]);
	}

	return i;
}

int get_dos_conf(HTTPCONNECTION hConnection, void *pParam)
{
	char *pcFile;
	
	if (WRExternalAdmin(hConnection) == 0) return 0;
	if ((pcFile = GetRequestFilePath(hConnection)) == NULL) return 0;

	SendHtmlWithParam(hConnection, pcFile, WRWriteDoSArgument );

	return 0;
}

int post_dos_conf(HTTPCONNECTION hConnection, void *pParam)
{
	LIST *pList;
	int j;
	
	pList = (LIST *)pParam;

	g_ConfigParam.fw_nat = GetLong(pList, "va_nat");
	//g_ConfigParam.fw_deny = GetLong(pList, "va_deny");
	g_ConfigParam.fw_rule = GetLong(pList, "va_rule");
	g_ConfigParam.synflood_threshold= GetLong(pList, "va_synfloodthresh");
	g_ConfigParam.udpflood_threshold= GetLong(pList, "va_udpfloodthresh");
	g_ConfigParam.icmpflood_threshold= GetLong(pList, "va_icmpfloodthresh");
	
	sysctlWrite( SYNFLOODLIMIT_MIB, g_ConfigParam.synflood_threshold );
	sysctlWrite( UDPFLOODLIMIT_MIB, g_ConfigParam.udpflood_threshold );
	sysctlWrite( ICMPFLOODLIMIT_MIB, g_ConfigParam.icmpflood_threshold );
	sysctlWrite( SYSCTL_ICMPRATE_LIMIT_MIB, g_ConfigParam.icmpflood_threshold );
	
	for(j=0; j<DOS_LAST; j++)
	{
		g_ConfigParam.fw_dos[j] = GetLong(pList, doslist[j] );
	}
	
	dos_install();
	
	//WebLog(CL_PRIVILEGE_ADMIN, CL_SET_IPFILTER, NULL, hConnection);
	SetKeepAliveMode(hConnection, FALSE);
	WriteFlashMemory(&g_ConfigParam);
	SendReDirectPage(hConnection);

	return 0;
}
