#include "CommonDef.h"

#include <sys/time.h>

#ifdef XX

int send_signal_to_fw()
{
    FILE *fp = NULL;
    int pid, iRetVal = -1;
    const char *FwPidFile ="/var/run/fw.pid";

    fp = fopen(FwPidFile , "r");
    if(!fp)
    {
        printf("Failed to intimate system time change to Firewall : fopen failed \n");
        return -1;
    }
    iRetVal = fscanf(fp, "%d", &pid);
    if(iRetVal == EOF || iRetVal == 0)
    {
        printf("Failed to intimate system time change to Firewall : pid file empty\n");
        return -1;
    }
    fclose(fp);
    iRetVal = kill(pid, SIGUSR2);
    if(iRetVal == -1)
    {
        perror("Failed to intimate system time change to Firewall \n");
        return -1;
    }
    return 0;
}
#endif

int update_time_for_zone(char *tmpstr)
{
/*
    int hour = 0;
    int minute = 0;
    char ch;
    unsigned int diff_from_utc_in_sec = 0; 
    struct timeval currtv;
    struct timezone currtz;
*/
    FILE *fp = NULL;

/*
    sscanf(tmpstr,"GMT%c%d:%d",&ch, &hour,&minute);
    diff_from_utc_in_sec = minute * 60 + hour * 60 * 60;
    if (gettimeofday(&currtv, &currtz) < 0)
           return -1;

    if(ch == '+')
        currtv.tv_sec += diff_from_utc_in_sec;
    else
        currtv.tv_sec -= diff_from_utc_in_sec;
*/

    if( (fp = fopen(TIMEZONEFILE , "w"))!=NULL)
    {
	fwrite(tmpstr,strlen(tmpstr),1,fp);
	fclose(fp);
    }
    	
    return 0; //(settimeofday(&currtv, &currtz));
}

int set_time(fw_timezone *fw_tz)
{
	time_t tval;
	struct tm *lt;
	
	if((time(&tval)) == -1)
		return -1;
	
	lt = localtime(&tval);
	lt->tm_year = (fw_tz->va_year > 2000) ? (fw_tz->va_year-2000+100) : (fw_tz->va_year-1900);
	lt->tm_mon = fw_tz->va_mon-1;
	lt->tm_mday = fw_tz->va_mday;
	lt->tm_hour = fw_tz->va_hour;
	lt->tm_min = fw_tz->va_min;
	lt->tm_sec = fw_tz->va_sec;
	tval = mktime(lt);
	stime(&tval);

/*
	fprintf(stderr,"%d/%d/%d %d:%d:%d",
		lt->tm_year,
		lt->tm_mon,
		lt->tm_mday,
		lt->tm_hour,
		lt->tm_min,
		lt->tm_sec );
*/

	return 0;
}

int ntp_install()
{

#ifdef NTPDATE
	KillAllProc("ntpdate");
	KillAllProc("sntp");
#else
	KillAllProc("ntpclient");
#endif
	
	if( g_ConfigParam.tz.va_enable && 
		(
		strlen(g_ConfigParam.tz.va_sntp0) > 6 ||
		strlen(g_ConfigParam.tz.va_sntp1) > 6 ||
		strlen(g_ConfigParam.tz.va_sntp2) > 6 
		)
	  )
	{

#ifdef NTPDATE
		RunProgram(NULL,"/bin/sntp",
			g_ConfigParam.tz.va_sntp0,
			g_ConfigParam.tz.va_sntp1,
			g_ConfigParam.tz.va_sntp2,NULL);
#else
		RunProgram(NULL,"/bin/ntpclient",
			"-h",
			g_ConfigParam.tz.va_sntp0,
			"-h",
			g_ConfigParam.tz.va_sntp1,
			"-h",
			g_ConfigParam.tz.va_sntp2,NULL);
#endif
	}

	return 0;
}

int get_timezone(HTTPCONNECTION hConnection, void *pParam)
{
	time_t t;
	struct tm *tm;
	
	char *pcFile;

	if (WRExternalAdmin(hConnection) == 0) return 0;
	if ((pcFile = GetRequestFilePath(hConnection)) == NULL) return 0;

	time(&t);
	tm = gmtime(&t);
	SetKeepAliveMode(hConnection, FALSE);
	SendHtmlWithParam(hConnection, pcFile,
		g_ConfigParam.tz.va_enable,
		g_ConfigParam.tz.va_gmt,
		(int)tm->tm_mday,
		(int)tm->tm_mon+1,
		(int)tm->tm_year+1900,
		(int)tm->tm_hour,
		(int)tm->tm_min,
		(int)tm->tm_sec,
		g_ConfigParam.tz.va_sntp0,
		g_ConfigParam.tz.va_sntp1,
		g_ConfigParam.tz.va_sntp2
	);
	return 0;
}


int post_timezone(HTTPCONNECTION hConnection, void *pParam)
{
	LIST *pList;
	
	pList = (LIST *)pParam;

	g_ConfigParam.tz.va_enable   = GetLong(pList, "va_enable");
	g_ConfigParam.tz.va_mday  = GetLong(pList, "va_mday");
	g_ConfigParam.tz.va_mon   = GetLong(pList, "va_mon");
	g_ConfigParam.tz.va_year  = GetLong(pList, "va_year");
	g_ConfigParam.tz.va_hour  = GetLong(pList, "va_hour");
	g_ConfigParam.tz.va_min   = GetLong(pList, "va_min");
	g_ConfigParam.tz.va_sec   = GetLong(pList, "va_sec" );
	
	g_ConfigParam.tz.va_sec++; /* increase 1 seconds to avoid the need of reload after apply */
	
	snprintf( g_ConfigParam.tz.va_gmt, sizeof(g_ConfigParam.tz.va_gmt)  ,"%s", GetString(pList,"va_gmt"));
	snprintf( g_ConfigParam.tz.va_sntp0,sizeof(g_ConfigParam.tz.va_sntp0),"%s", GetString(pList,"va_sntp0"));
	snprintf( g_ConfigParam.tz.va_sntp1,sizeof(g_ConfigParam.tz.va_sntp1),"%s", GetString(pList,"va_sntp1"));
	snprintf( g_ConfigParam.tz.va_sntp2,sizeof(g_ConfigParam.tz.va_sntp2),"%s", GetString(pList,"va_sntp2"));

	set_time(&g_ConfigParam.tz);
	update_time_for_zone(&(g_ConfigParam.tz.va_gmt[0]) );
	ntp_install();
	
	SetKeepAliveMode(hConnection, FALSE);
	WriteFlashMemory(&g_ConfigParam);
	SendReDirectPage(hConnection);
	
	return 0;
}

void set_time_by_param(int va_year, int va_mon, int va_mday, int va_hour, int va_min, int va_sec )
{
	g_ConfigParam.tz.va_mday  = va_mday;
	g_ConfigParam.tz.va_mon   = va_mon;
	g_ConfigParam.tz.va_year  = va_year;
	g_ConfigParam.tz.va_hour  = va_hour;
	g_ConfigParam.tz.va_min   = va_min;
	g_ConfigParam.tz.va_sec   = va_sec;

	set_time(&g_ConfigParam.tz);
	update_time_for_zone(&(g_ConfigParam.tz.va_gmt[0]) );
}
