#ifndef C_STRING_H
#define C_STRING_H

#ifndef BOOL
#define BOOL int
#define TRUE 1
#define FALSE 0
#endif

typedef struct
{
	char *pcName;
	char *pcValue;
	long time;
} NAMEDSTRING_T;

char *MyStrncpy(char *pcDest, const char *pcSrc, int iLength);

/* pcStringcSeparatorΪָһLISTṹ˫ */
LIST *SplitString(const char *pcString, char cSeparator);

/* ͷSplitStringɵеַԴ */
void DeleteSplitString(LIST *pList);

/* õһȥǰհ׵ַҪfree */
char *GetTrimString(const char *pcString);

/* õһCת廯ַҪfree
** ab"cd, õab\"cd */
char *GetCStyleString(const char *pcString);

/* õһwebת廯ַҪfree
**   ab<cd, õab&lt;cd */
char *GetWebStyleString(const char *pcString);

/* õһȾwebת廯پC/javaת廯ַҪfree */
char *GetWebInCString(const char *pcStr);

/* ַתΪIPַ */
unsigned long String2IP(const char *pcString);
/* IPַתΪַ, pcStringOutռ>=16, pcStringOutַĳ */
int IP2String(unsigned long ulIP, char *pcStringOut);

/* ַתΪlong */
long String2Long(const char *pcString);
/* longתΪַ, pcStringOutռ>=32, pcStringOutַĳ */
int Long2String(long lVal, char *pcStringOut);

/* ַתΪBOOL */
BOOL String2Bool(const char *pcString);
/* BOOLתΪַ, pcStringOutռ>=6("true""false"), pcStringOutַĳ */
int Bool2String(BOOL bVal, char *pcStringOut);

/* ʮַתΪӦASCַ,"41"תΪA */
char Hex2Char(const char *str);
/* ASCַתΪʮַ, 2 */
int Char2Hex(char ch, char *pcRtHex);


/* һֵ */
LIST *CreateDict();

/* һֵ */
void DeleteDict(LIST *pList);

/* ֵɾһ */
BOOL DelDictParam(LIST *pList, const char *pcName);

/* һֵ(NAMEDSTRING_T, Name,Value)Ƿָ
** ,溯ķֵΪ:
	GetString()	""
	GetIP()		0
	GetIP4()	0
	GetInt32()	0
	GetBool()	0
*/
LISTNODE *IsExistParam(const LIST *pList, const char *pcName);

/* ĺpcNamelistȡֵ
** ÿڵԪΪNAMEDSTRING_T(Name,Value) */
const char *GetString(const LIST *pList, const char *pcName);
unsigned long GetIP(const LIST *pList, const char *pcName);
unsigned long GetIP4(const LIST *pList, const char *pcName);
long GetLong(const LIST *pList, const char *pcName);
BOOL GetBool(const LIST *pList, const char *pcName);

/* ĺlistpcNamepcValue */
LISTNODE *SetString(LIST *pList, const char *pcName, const char *pcValue);
LISTNODE *SetIP(LIST *pList, const char *pcName, unsigned long ulValue);
LISTNODE *SetLong(LIST *pList, const char *pcName, long lValue);
LISTNODE *SetBool(LIST *pList, const char *pcName, BOOL bValue);


/* Define XML structure */
typedef struct tagXML
{
	struct tagXML *pParXML;
	LISTNODE *pParXMLNode;

	char *pcName;
	LIST *plAttrib;
	LIST *plSubXML;
} XML;

XML *CreateXML(const char *pcName);
XML *CreateXMLText(const char *pcText);
void DeleteXML(XML *pXML);
XML *InsertXMLBefore(XML *pXML, XML *pInsert);
XML *InsertXMLAfter(XML *pXML, XML *pInsert);
XML *AppendXML(XML *pXML, XML *pSubXML);
XML *DetachXML(XML *pXML, XML *pSubXML);
inline XML *GetParentXML(XML *pXML);
void DumpXML(XML *pXML, void (*Dumper)(const char *, void *), void *pParam);

#endif
