/* Header file for iptables ipt_ROUTE target
 *
 * (C) 2002 by Cdric de Launois <delaunois@info.ucl.ac.be>
 *
 * This software is distributed under GNU GPL v2, 1991
 */
#ifndef _IPT_ROUTE_H_target
#define _IPT_ROUTE_H_target

#define IPT_ROUTE_IFNAMSIZ 16

struct ipt_route_target_info {
	char      oif[IPT_ROUTE_IFNAMSIZ];      /* Output Interface Name */
	char      iif[IPT_ROUTE_IFNAMSIZ];      /* Input Interface Name  */
	u_int32_t gw;                           /* IP address of gateway */
	u_int8_t  flags;
	u_int32_t ifindex;			/* new ifindex */
	
	/* nat info */
	u_int8_t  snattype;
	u_int8_t  dnattype;
	u_int32_t snatip;
	u_int32_t dnatip;
};

/* Values for "flags" field */
#define IPT_ROUTE_CONTINUE	0x01
#define IPT_ROUTE_SOURCE_BASED	0x02
#define IPT_ROUTE_LOAD_BALANCE	0x04
#define IPT_ROUTE_NAT_SET	0x08	/* set nat ip address for AUTONAT perform */
#define IPT_ROUTE_AUTO_ROUTE	0x10	/* for ftp data connection persistent */

/* Values for "snattype,dnattype" */
#define IPT_ROUTE_NAT_NONE	0x00
#define IPT_ROUTE_NAT_IP	0x01
#define IPT_ROUTE_NAT_AUTO	0x02


extern struct in_device * matchifip( unsigned long ip );

#endif /*_IPT_ROUTE_H_target*/


