#include <stdio.h>
#include <netinet/in.h>
#include <unistd.h> 
#include <signal.h>
#include "pppd.h"
#include "pathnames.h"
#include "inter.h"
#include "system.h"

#include <errno.h>

extern unsigned char pptp_flag;
char * _PATH_SYSOPTIONS=NULL;
char *CONFIG_FILE =NULL;
extern char gl_username[64];
extern char gl_password[64];

static inline _syscall1(void,set_out_ip,unsigned long *,args);
static inline _syscall1(void,set_local_ip,unsigned long *,args);
static inline _syscall1(void,set_pptp,unsigned char*,args);
struct ppp_info pppd_info;// ={"","",{"","",""},"","","",0,-1,0,0,0,"","", "","", {"",""},"","",""};

struct ppp_info * get_ppp_info()
{
	return &pppd_info;
}

void get_user_passwd(PPPDSTART *pStartParam)
{
	read_config(CONFIG_FILE);
	strlcpy(user,  pStartParam->StartParam.e.pcUserName, sizeof(user));     
	strlcpy(passwd, pStartParam->StartParam.e.pcUserPass, sizeof(passwd));		
	
	if((*gl_username)&&(*gl_password))
	{
	    	strcpy(pppd_info.StartParam.StartParam.e.pcUserName,gl_username);
    		strcpy(pppd_info.StartParam.StartParam.e.pcUserPass,gl_password);
	}
    
	write_config(CONFIG_FILE);
}

int read_config(char * config_file)
{
	static int pppd_flag=0;
	FILE *fp;

	if((fp=fopen(config_file,"rb"))==NULL)
	{
		printf("Open file %s failed\n",config_file);
		return 0;
  	}
  
	if(fread(&pppd_info,1,sizeof(struct ppp_info),fp))
  	{
  		fclose(fp);  		
  		return 1;
  	}
  	
  	printf("read file failed\n");
  	fclose(fp);
  	return 0;  
}
  
int write_config(char * config_file)
{	
	static  int pppd_flag=0;
	FILE *fp;
	int i;
  
	if((fp=fopen(config_file,"wb"))==NULL)
	{
	  	printf("Open write file %s failed\n",config_file);
	  	return 0;
	}
	if(fwrite(&pppd_info,1,sizeof(struct ppp_info),fp)>0)
  	{
  		fclose(fp);  		
  		return 1;
  	}  	
  	fclose(fp);
  	return 0;  
}

////////////////////////////////////////////////////
void  set_ppp_info_from_dial(long  loc_addr ,
		long rem_addr,long dns1addr,long dns2addr,
		long gateway_addr,long netmask) 
{
	int  ip;
	char num[32];    

	 read_config(CONFIG_FILE);
	 ip=loc_addr;	
	 slprintf(num, sizeof(num), "%d.%d.%d.%d", (ip  ) & 0xff,
		     (ip >> 8) & 0xff, (ip >> 16) & 0xff, (ip>>24) & 0xff);
	 strcpy(pppd_info.got_loc_addr,num );
	    /***************/ 
	 
	 ip=rem_addr;     
	 
	 slprintf(num, sizeof(num), "%d.%d.%d.%d", (ip) & 0xff,
		     (ip >> 8) & 0xff, (ip >> 16) & 0xff, (ip>>24) & 0xff);
	 strcpy(pppd_info.got_rem_addr,num );
	    /*********************/
	 ip=dns1addr; 	
	 slprintf(num, sizeof(num), "%d.%d.%d.%d", (ip ) & 0xff,
		     (ip >> 8) & 0xff, (ip >> 16) & 0xff, (ip>>24) & 0xff);
	 strcpy(pppd_info.got_dnsaddr[0],num );  
	 
	 ip=dns2addr; 	
	 slprintf(num, sizeof(num), "%d.%d.%d.%d", (ip ) & 0xff,
		     (ip >> 8) & 0xff, (ip >> 16) & 0xff, (ip>>24) & 0xff);
	 strcpy(pppd_info.got_dnsaddr[1],num );      
	    	
   	//printf("live_sec====%d\n",live_sec);
   	//printf("session_num====%d\n",session_num);
	//pppd_info.live_sec=live_sec;
	//pppd_info.session_num=session_num;

	ip=gateway_addr; 	
	slprintf(num, sizeof(num), "%d.%d.%d.%d", (ip ) & 0xff,
		     (ip >> 8) & 0xff, (ip >> 16) & 0xff, (ip>>24) & 0xff);
	strcpy(pppd_info.got_gateway,num ); 
	/********************/
	ip=netmask; 	
	slprintf(num, sizeof(num), "%d.%d.%d.%d", (ip ) & 0xff,
		     (ip >> 8) & 0xff, (ip >> 16) & 0xff, (ip>>24) & 0xff);
	strcpy(pppd_info.got_netmask,num ); 
	/********************/
	//pppd_info.status=status;

	write_config(CONFIG_FILE);
}

void clear_ppp_info(void)
{
	pid_t pid;
	PPPDSTART  param;

	read_config(CONFIG_FILE);
	pid=pppd_info.thttpd_pid;
	param=pppd_info.StartParam;
	memset((char *)(&pppd_info),0, sizeof( struct ppp_info));
	pppd_info.StartParam=param;
	pppd_info.thttpd_pid=pid;
	pppd_info.status = pppd_info.status&0xFFFFFF00;
	pppd_info.status = CONNECTION_OFF|pppd_info.status;
	
	if((*gl_username)&&(*gl_password))
	{
    		strcpy(pppd_info.StartParam.StartParam.e.pcUserName,gl_username);
    		strcpy(pppd_info.StartParam.StartParam.e.pcUserPass,gl_password);
	}
    
	write_config(CONFIG_FILE);
}


void set_pppd_status(long status)
{
	read_config(CONFIG_FILE);
	pppd_info.status = pppd_info.status & 0xFFFFFF00; //mcli
	pppd_info.status = status|pppd_info.status;
	
	if((*gl_username)&&(*gl_password))
	{
    		strcpy(pppd_info.StartParam.StartParam.e.pcUserName,gl_username);
    		strcpy(pppd_info.StartParam.StartParam.e.pcUserPass,gl_password);
	}
	write_config(CONFIG_FILE);	
}


void set_ppp_dial_info(PPPDSTART *pStartParam)
{
	//ok;
	pStartParam=pStartParam;
	return;
	
}

void set_ppp_idle_time(void) 
{
	read_config(CONFIG_FILE);
	idle_time_limit=pppd_info.StartParam.StartParam.e.DisConnectTime;
//	printf("set_ppp_idle_time idle_time_limit===%d\n",idle_time_limit);
	
	if((*gl_username)&&(*gl_password))
	{
    		strcpy(pppd_info.StartParam.StartParam.e.pcUserName,gl_username);
	    	strcpy(pppd_info.StartParam.StartParam.e.pcUserPass,gl_password);
	}
    
	write_config(CONFIG_FILE);
	//printf("pppd_info.StartParam.StartParam.e.DisConnectTime===%d\n",pppd_info.StartParam.StartParam.e.DisConnectTime);
}

#ifdef XX

//  start for checking parameter
void printf_ppp_info(PPPDSTART *pStartParam)
{
	printf("pcUserName %s\n",pStartParam->StartParam.e.pcUserName);    /* û */
    printf("pcUserPass %s\n",pStartParam->StartParam.e.pcUserPass );    /* û */
    printf("pcServiceName %s\n",pStartParam->StartParam.e.pcServiceName);    /* ISP */
    printf("session_num %d\n",pppd_info.session_num);
    
}
#endif

// wirte /etc/hosts for gethostbyname 
int  set_host_info(char *filename,unsigned int local_ip, char * local_name)
{
 
	FILE *fp;
	unsigned int ip=local_ip;
	char num[32];
	 
	fp = fopen(filename, "w+");
	if (fp == NULL) {
	      printf("   open   file %s:  failed\n", filename);
		  return 1;	
	} 
  	
  	slprintf(num, sizeof(num), "%d.%d.%d.%d", (ip ) & 0xff,
		     (ip >> 8) & 0xff, (ip >> 16) & 0xff, (ip>>24) & 0xff);
	strcat(num,"	");
	strcat(num,"winbond");

	if(fputs(num,fp)<0)
     	{
     		fclose(fp);
     	  	return 1;
     	}
     	
	fclose(fp); 
	return 0;	
}
// add for lsshi kernel syscall
void ppp_set_out_ip(unsigned int add)
{
	set_out_ip(&add);
}

void ppp_set_local_ip(unsigned int add)
{
	set_local_ip(&add);
}

void ppp_do_other()
{ 
	pid_t pid;
	int signal_num;

	read_config(CONFIG_FILE);
    
/*
	if(pppd_info.pWRSetRules)
	{
		if(pppd_info.pWRSetRules())
		{
			printf("ppp_do_other failed\n");
		}
		return;
	}
*/	
	pid=pppd_info.thttpd_pid;
	
 	if(pptp_flag==0)
	{
		signal_num=kill(pid,SIGWINCH); //notify http server we have done ok!
		//printf(" pppoe sent signal %u to pid %u\n", SIGWINCH, pid );
	}
	else
	{	
		set_pptp(&pptp_flag);
		signal_num=kill(pid,29);
	}

	/*
	if(signal_num==0){
		printf(" ppp_do_other: Signal Sucess!\n");			
	}
	else 
	*/
	if(signal_num==-1)
	{
     		printf( " ppp_do_other: Signal errno %d\n",errno);
	}
   
}
///////////////////////////////////////////////

int pppd_set_run(status)
{
	unsigned long flag_status;
	unsigned long flag;
	unsigned long mask;
	
	read_config(CONFIG_FILE);
	flag_status = pppd_info.status;
	
	if(status)
	{
	  flag =  flag_status | PPPD_FLAG_RUN ;
	} 
	else
	{
	  mask = ~PPPD_FLAG_RUN;
	  flag =  flag_status & mask;    	
	}	
	pppd_info.status = flag;
	
	if((*gl_username)&&(*gl_password))
	{
	    	strcpy(pppd_info.StartParam.StartParam.e.pcUserName,gl_username);
    		strcpy(pppd_info.StartParam.StartParam.e.pcUserPass,gl_password);
	}
    
	write_config(CONFIG_FILE);
	return 0;
}

void update_ppp_status(int sign)
{
   
    update_link_stats(0);
   
    write_config(CONFIG_FILE);
    memcpy(pppd_info.ser_mac, ser_mac, 6);//mcli add
    pppd_info.session_num=m_pppoe_id;//mcli add
    
    #if 0
    printf("#######PPP STATUS\n");
    
    printf("***live sec   :%d\n",pppd_info.live_sec);
    printf("***session id :%d\n",pppd_info.session_num);
    printf("***in bytes   :%d\n",pppd_info.bytes_in);
    printf("***out bytes  :%d\n",pppd_info.bytes_out);
    #endif 
    
    return;
}
///////////////////////////////////////////////////////
void ppp_do_exit()
{
	pid_t pid;
	int signal_num;
	
	read_config(CONFIG_FILE); 
	pid=pppd_info.thttpd_pid;
	pppd_set_run(PPPD_STOP_RUN);
	
}

void GetMACSID(struct MAC_SID *rMSinfo)
{
	int i;
	
	read_config(CONFIG_FILE);
	rMSinfo->session_num=pppd_info.session_num;
	//printf("pppd_info.ser_mac:");
	for(i=0;i<6;i++)
		printf("pppd_info.ser_mac[%d]=%x\n",i,pppd_info.ser_mac[i]);
		
	memcpy(rMSinfo->ser_mac, pppd_info.ser_mac, 6);
	
	return;
}
//////////////////////////////////////////////////////////////////
int ppp_try_set_demand()  
{
	unsigned long flag_status;
	unsigned long flag;
	read_config(CONFIG_FILE);
	flag_status = pppd_info.status;
	flag =  flag_status & PPPD_DEMAND;

	persist = 1;
	if(flag)
	{
		demand  = 1;
		//persist = 1;
		return 1;
	}
	return 0;
}
