#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <setjmp.h>
#include <errno.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#define PPP_BINARY	"pppd"
#define PPTP_RETRY_INTERVAL	10	/* second */

#ifndef IFNAMSIZ
#define IFNAMSIZ	16
#endif

pid_t pid;
int do_exit = 0;
int unit = 1;

void daemonize(void)
{
    pid_t rc;

    signal(SIGCHLD, SIG_IGN);
	
    if ( ( rc = vfork() ) < 0 ) 
    {
        exit(-1);
    } 
    // drop parent
    if ( rc > 0 ) exit(0);
    if ( setsid() < 0 ) exit(-1);
    
    // do it twice
    if ( ( rc = vfork() ) < 0 ) 
    {
        exit(-1);
    } 

    // drop parent
    if ( rc > 0 ) exit(0);
    
	// close stdin, stdout, stderror
	int fd = open("/dev/null", O_RDWR);
	if (fd != -1) {
		dup2(fd, 0);
		dup2(fd, 1);
		dup2(fd, 2);   
		if (fd > 2) close(fd);
	}

}
void launch_prog(int argc, char **argv) {
  char *new_argv[24]; /* XXX if not using GCC, hard code a limit here. */
  int i = 0, j;

  for (j=0; j<argc; j++)
    new_argv[i++] = argv[j];
  
  new_argv[i] = NULL;

  new_argv[0] = PPP_BINARY;
  
  execvp(new_argv[0], new_argv); /* excute a file */

}

void parse_pppoeunit(int argc, char **argv) {

	int j;

	for (j=0; j<argc-1; j++)
	{
		if( argv[j] && argv[j+1] && (strncmp(argv[j], "pppoe",5) == 0) )
		{
			unit = atoi(argv[j+1]);
		}

	}
}


void donothing(int i)
{
}
void sighandler(int signo)
{	
	do_exit =1;
	kill(pid,SIGTERM);
	sleep(1);
	//kill(pid,SIGKILL);
	exit(0);
}

/*
 * Create a file containing our process ID.
 */
static void
create_pidfile(pid)
    int pid;
{
    FILE *pidfile;
    char pidfilename[64];
	
    snprintf(pidfilename, sizeof(pidfilename), "/swap/pppoe-eth1.%d.pid",
	       unit );
    if ((pidfile = fopen(pidfilename, "w")) != NULL) {
	fprintf(pidfile, "%d\n", pid);
	(void) fclose(pidfile);
    } else {
	printf("Failed to create pid file %s\n", pidfilename);
	pidfilename[0] = 0;
    }
}


int
main(int argc, char **argv)
{
	int status;

  	daemonize();
	//make it to be new process group to avoid parent process be killed by kill(0,SIGTERM) from child process
	
	signal(SIGINT,  sighandler);
	signal(SIGTERM, sighandler);
	signal(SIGKILL, sighandler);
	signal(SIGPIPE, sighandler);
	signal(SIGHUP,  sighandler);
	signal(SIGUSR1, donothing); /* avoid child kill me */
	signal(SIGUSR2, donothing); /* avoid child kill me */
	//signal(SIGCHLD, SIG_IGN); we want to wait for it

	parse_pppoeunit( argc, argv );
	create_pidfile(getpid());

	if( argc > 1 && strcmp(argv[1],"0.0.0.0")==0 )
		return -1;
	
	for(;; )
	{
		switch( (pid=vfork()) )
		{
		case -1:
			exit(-1);
		case 0: /* child */
			launch_prog(argc, argv);
			printf("pppoecd fail to run pppd\n");fflush(stdout);
			exit(-1);
		default: /* parent */
			while( wait( &status ) != pid )
				;
			if( do_exit )
			{
				kill(pid,SIGTERM);
				kill(0,SIGTERM);
				exit(0);
			}
			sleep(PPTP_RETRY_INTERVAL);
			break;
		}
	}
	
	return 0;
}

