#include <asm/arch/flash.h>
#include <linux/slab.h>

#define INT int
#define UINT32 unsigned int
#define UCHAR unsigned char

#ifdef CONFIG_W90N740FLASH

/* W28J800TT */
INT BlockSize_W28J800TT(UINT32 address);
INT BlockSize_W28J800BT(UINT32 address);
INT BlockErase_W28J800TT(UINT32 address,UINT32 size);
INT BlockWrite_W28J800TT(UINT32 address, UCHAR * data, UINT32 size);
INT ReadPID_W28J800TT(UINT32 address, UCHAR *PID0, UCHAR *PID1);
INT BlockLock_W28J800TT(UINT32 address, UINT32 op);
/* W28J160TT */
INT BlockSize_W28J160TT(UINT32 address);
INT ReadPID_W28J160TT(UINT32 address, UCHAR *PID0, UCHAR *PID1);
/* W28J160BT */
INT BlockSize_W28J160BT(UINT32 address);
/* W28J320TT */
INT BlockSize_W28J320TT(UINT32 address);
INT ReadPID_W28J320TT(UINT32 address, UCHAR *PID0, UCHAR *PID1);
/* W28J320BT */
INT BlockSize_W28J320BT(UINT32 address);


/* W39L010 */
INT BlockSize_W39L010(UINT32 address);
INT BlockErase_W39L010(UINT32 address,UINT32 size);
INT BlockWrite_W39L010(UINT32 address, UCHAR * data, UINT32 size);
INT ReadPID_W39L010(UINT32 address, UCHAR *PID0, UCHAR *PID1);
INT BlockLock_W39L010(UINT32 address, UINT32 op);
/* W29EE011 */
INT BlockSize_W29EE011(UINT32 address);
INT BlockErase_W29EE011(UINT32 address,UINT32 size);
INT BlockWrite_W29EE011(UINT32 address, UCHAR * data, UINT32 size);
INT ReadPID_W29EE011(UINT32 address, UCHAR *PID0, UCHAR *PID1);
INT BlockLock_W29EE011(UINT32 address, UINT32 op);
/* AM29LV800BB */
INT BlockSize_AM29LV800BB(UINT32 address);
INT BlockErase_AM29LV800BB(UINT32 address,UINT32 size);
INT BlockWrite_AM29LV800BB(UINT32 address, UCHAR * data, UINT32 size);
INT ReadPID_AM29LV800BB(UINT32 address, UCHAR *PID0, UCHAR *PID1);
INT BlockLock_AM29LV800BB(UINT32 address, UINT32 op);
/* AM29LV800BB */
/* AM29LV800BT */
INT BlockSize_AM29LV800BT(UINT32 address);
/* AM29LV160BB */
INT ReadPID_AM29LV160DB(UINT32 address, UCHAR *PID0, UCHAR *PID1);
INT BlockSize_AM29LV160DB(UINT32 address);
/* AM29LV160BT */
INT BlockSize_AM29LV160DT(UINT32 address);
/* AM29LV320DB */
INT ReadPID_AM29LV320DB(UINT32 address, UCHAR *PID0, UCHAR *PID1);
INT BlockSize_AM29LV320DB(UINT32 address);
/* AM29LV320DT */
INT BlockSize_AM29LV320DT(UINT32 address);
/* Intel E28F640 */
INT BlockSize_E28F640(UINT32 address);
INT BlockErase_E28F640(UINT32 address,UINT32 size);
INT BlockWrite_E28F640(UINT32 address, UCHAR * data, UINT32 size);
INT ReadPID_E28F640(UINT32 address, UCHAR *PID0, UCHAR *PID1);
INT BlockLock_E28F640(UINT32 address, UINT32 op);
/* SST 39VF160 */
INT BlockSize_SST39VF160(UINT32 address);
INT ReadPID_SST39VF160(UINT32 address, UCHAR *PID0, UCHAR *PID1);
INT BlockErase_SST39VF160(UINT32 address,UINT32 size);
/* MX28F160C3B */
INT BlockErase_MX28F160C3B(UINT32 address,UINT32 size);
INT BlockWrite_MX28F160C3B(UINT32 address, UCHAR * data, UINT32 size);

flash_t flash[]={
{0xB0,0xEC,"W28J800TT",BlockSize_W28J800TT,BlockErase_W28J800TT,BlockWrite_W28J800TT,ReadPID_W28J800TT,BlockLock_W28J800TT},
{0xB0,0xED,"W28J800BT",BlockSize_W28J800BT,BlockErase_W28J800TT,BlockWrite_W28J800TT,ReadPID_W28J800TT,BlockLock_W28J800TT},
{0xB0,0xE8,"W28J160TT",BlockSize_W28J160TT,BlockErase_W28J800TT,BlockWrite_W28J800TT,ReadPID_W28J160TT,BlockLock_W28J800TT},
{0xB0,0xE9,"W28J160BT",BlockSize_W28J160BT,BlockErase_W28J800TT,BlockWrite_W28J800TT,ReadPID_W28J160TT,BlockLock_W28J800TT},
{0xB0,0xE2,"W28J320TT",BlockSize_W28J320TT,BlockErase_W28J800TT,BlockWrite_W28J800TT,ReadPID_W28J320TT,BlockLock_W28J800TT},
{0xB0,0xE3,"W28J320BT",BlockSize_W28J320BT,BlockErase_W28J800TT,BlockWrite_W28J800TT,ReadPID_W28J320TT,BlockLock_W28J800TT},
{0xDA,0x31,"W39L010", BlockSize_W39L010, BlockErase_W39L010, BlockWrite_W39L010, ReadPID_W39L010 ,BlockLock_W39L010 },
{0xDA,0xC1,"W29EE011",BlockSize_W29EE011,BlockErase_W29EE011,BlockWrite_W29EE011,ReadPID_W29EE011,BlockLock_W29EE011},
{0x01,0x5B,"AM29LV800BB",BlockSize_AM29LV800BB,BlockErase_AM29LV800BB,BlockWrite_AM29LV800BB,ReadPID_AM29LV800BB,BlockLock_AM29LV800BB},
{0x01,0xDA,"AM29LV800BT",BlockSize_AM29LV800BT,BlockErase_AM29LV800BB,BlockWrite_AM29LV800BB,ReadPID_AM29LV800BB,BlockLock_AM29LV800BB},
{0x01,0x49,"AM29LV160DB",BlockSize_AM29LV160DB,BlockErase_AM29LV800BB,BlockWrite_AM29LV800BB,ReadPID_AM29LV160DB,BlockLock_AM29LV800BB},
{0x01,0xC4,"AM29LV160DT",BlockSize_AM29LV160DT,BlockErase_AM29LV800BB,BlockWrite_AM29LV800BB,ReadPID_AM29LV160DB,BlockLock_AM29LV800BB},
{0x01,0xF9,"AM29LV320DB",BlockSize_AM29LV320DB,BlockErase_AM29LV800BB,BlockWrite_AM29LV800BB,ReadPID_AM29LV320DB,BlockLock_AM29LV800BB},
{0x01,0xF6,"AM29LV320DT",BlockSize_AM29LV320DT,BlockErase_AM29LV800BB,BlockWrite_AM29LV800BB,ReadPID_AM29LV320DB,BlockLock_AM29LV800BB},
{0xBF,0x82,"SST39VF160",BlockSize_SST39VF160,BlockErase_SST39VF160,BlockWrite_AM29LV800BB,ReadPID_SST39VF160,BlockLock_AM29LV800BB},
{0x89,0x17,"INTEL E28F640",BlockSize_E28F640,BlockErase_E28F640,BlockWrite_E28F640,ReadPID_E28F640,BlockLock_E28F640},
{0x89,0xC0,"28F800C3-T",BlockSize_W28J800TT,BlockErase_W28J800TT,BlockWrite_W28J800TT,ReadPID_W28J800TT,BlockLock_W28J800TT},
{0x89,0xC1,"28F800C3-B",BlockSize_W28J800BT,BlockErase_W28J800TT,BlockWrite_W28J800TT,ReadPID_W28J800TT,BlockLock_W28J800TT},
{0x89,0xC2,"28F160C3-T",BlockSize_W28J160TT,BlockErase_W28J800TT,BlockWrite_W28J800TT,ReadPID_W28J160TT,BlockLock_W28J800TT},
{0x89,0xC3,"28F160C3-B",BlockSize_W28J160BT,BlockErase_W28J800TT,BlockWrite_W28J800TT,ReadPID_W28J160TT,BlockLock_W28J800TT},
{0x89,0xC4,"28F320C3-T",BlockSize_W28J320TT,BlockErase_W28J800TT,BlockWrite_W28J800TT,ReadPID_W28J320TT,BlockLock_W28J800TT},
{0x89,0xC5,"28F320C3-B",BlockSize_W28J320BT,BlockErase_W28J800TT,BlockWrite_W28J800TT,ReadPID_W28J320TT,BlockLock_W28J800TT},
{0xAD,0x49,"HY29LV160",BlockSize_AM29LV160DB,BlockErase_AM29LV800BB,BlockWrite_AM29LV800BB,ReadPID_AM29LV160DB,BlockLock_AM29LV800BB},
{0xC2,0xC2,"MX28F160C3T",BlockSize_W28J160TT,BlockErase_MX28F160C3B,BlockWrite_MX28F160C3B,ReadPID_W28J160TT,BlockLock_W28J800TT},
{0xC2,0xC3,"MX28F160C3B",BlockSize_W28J160BT,BlockErase_MX28F160C3B,BlockWrite_MX28F160C3B,ReadPID_W28J160TT,BlockLock_W28J800TT},
{0xC2,0x49,"MX29LV160BT",BlockSize_AM29LV160DB,BlockErase_AM29LV800BB,BlockWrite_AM29LV800BB,ReadPID_AM29LV160DB,BlockLock_AM29LV800BB},
{0x04,0x49,"MBM29LV160BE",BlockSize_AM29LV160DB,BlockErase_AM29LV800BB,BlockWrite_AM29LV800BB,ReadPID_AM29LV160DB,BlockLock_AM29LV800BB},
{0x04,0xC4,"MBM29LV160TE",BlockSize_AM29LV160DT,BlockErase_AM29LV800BB,BlockWrite_AM29LV800BB,ReadPID_AM29LV160DB,BlockLock_AM29LV800BB},
//{0xDA,0x92,"W19B322MB",BlockSize_AM29LV320DB,BlockErase_AM29LV800BB,BlockWrite_AM29LV800BB,ReadPID_AM29LV320DB,BlockLock_AM29LV800BB},
//{0xDA,0x94,"W19B323MB",BlockSize_AM29LV320DB,BlockErase_AM29LV800BB,BlockWrite_AM29LV800BB,ReadPID_AM29LV320DB,BlockLock_AM29LV800BB},
//{0xDA,0x97,"W19B324MB",BlockSize_AM29LV320DB,BlockErase_AM29LV800BB,BlockWrite_AM29LV800BB,ReadPID_AM29LV320DB,BlockLock_AM29LV800BB},
//{0xDA,0x10,"W19B322MT",BlockSize_AM29LV320DT,BlockErase_AM29LV800BB,BlockWrite_AM29LV800BB,ReadPID_AM29LV320DB,BlockLock_AM29LV800BB},
//{0xDA,0x13,"W19B323MT",BlockSize_AM29LV320DT,BlockErase_AM29LV800BB,BlockWrite_AM29LV800BB,ReadPID_AM29LV320DB,BlockLock_AM29LV800BB},
//{0xDA,0x16,"W19B324MT",BlockSize_AM29LV320DT,BlockErase_AM29LV800BB,BlockWrite_AM29LV800BB,ReadPID_AM29LV320DB,BlockLock_AM29LV800BB},
{0xDA,0x2A,"W19L320SB",BlockSize_AM29LV320DB,BlockErase_AM29LV800BB,BlockWrite_AM29LV800BB,ReadPID_AM29LV320DB,BlockLock_AM29LV800BB},
{0xDA,0xBA,"W19L320ST",BlockSize_AM29LV320DT,BlockErase_AM29LV800BB,BlockWrite_AM29LV800BB,ReadPID_AM29LV320DB,BlockLock_AM29LV800BB},
/* you can add new flash type here and achieve the functions of R/W/Erase etc*/
{0}
};


int get_flash_type_num(void)
{
	return sizeof(flash)/sizeof(flash_t);	
}	

/* please assign your flash's size to _flash_size in your flash_t->ReadPID,
   for example
	INT ReadPID_XXX(...)
	{
		......
		_flash_size=0x100000;
	
		.......
		return 0;
	}
*/
#else
asmlinkage int sys_FindImage(UINT32 image_num, tfooter ** image_footer)
{
	return -ENOSYS;
}
asmlinkage int sys_DelImage(UINT32 image_num)
{
	return -ENOSYS;
}
asmlinkage int sys_CorruptCheck(tfooter * image_footer)
{
	printk("CorruptCheck not implement\n");
	return -ENOSYS;
}
asmlinkage int sys_ReadWinbondFlash(unsigned long pos, unsigned long length, char * buffer)
{
	printk("ReadWinbondFlash not implement\n");
	return -ENOSYS;
}
asmlinkage int sys_WriteWinbondFlash(unsigned long pos, unsigned long length, char * buffer)
{
	printk("WriteWinbondFlash not implement\n");
	return -ENOSYS;
}
asmlinkage int sys_WinbondFlashBlockSize(unsigned long pos)
{
	return -ENOSYS;
}
asmlinkage int sys_WinbondFlashTotalSize()
{
	return -ENOSYS;
}
asmlinkage int sys_WinbondFlashBase()
{
	return -ENOSYS;
}
#endif
