//2003-1-2 16:11
#include <linux/config.h>
#include <linux/module.h> 
#include <linux/init.h>
#include <linux/sched.h>
#include <linux/kernel.h>      
#include <linux/slab.h>		 
#include <linux/errno.h>
#include <linux/types.h>
#include <linux/interrupt.h>

#include <linux/in.h>
#include <linux/netdevice.h>
#include <linux/etherdevice.h>
#include <linux/ip.h>
#include <linux/tcp.h>
#include <linux/skbuff.h>
#include <net/neighbour.h>
#include <net/dst.h>
#include <net/sock.h>
#include <asm/irq.h>

#include "w740mac.h"
#include "w740nat.h"
#include  "natlib.h"
/*
ioctl 0x8968  SIOCGNATA
ioctl 0x8969  SIOCSNATA
*/

#define NATA_ENTRY_EMPTY   0xFFFF
#define NATA_ENTRY_MAX	   64


struct _NATA_Table  NATA_Table;

/************
For PPPoE MAC Address and Sid.
***************/
unsigned short int PPPoE_Test=0;
unsigned char RSMAC_PPPOE_TEST[6];


//PPP_IP 0x0021
/* NATA Requset struct from user */

#define type.entry req_entry

/* w740mac MAC from w740mac.c */
extern char w740_mac_address0[];
extern char w740_mac_address1[];
extern struct  net_device w740_netdevice[2];

void disable_entry(int i);

void SetMACAddr(unsigned long msw_reg,unsigned lsw_reg,unsigned char *addr)
{
	unsigned int msw,lsw;
	
 	msw =  	(addr[0] << 24) |
        	(addr[1] << 16) |
        	(addr[2] << 8) |
         	addr[3];
 	lsw = (addr[4] << 24) |
           (addr[5] << 16);
   
 	*(volatile unsigned long *)msw_reg=msw;
 	*(volatile unsigned long *)lsw_reg=lsw;
}

/******************
*Initialize  Nata Table and Nata hardware entry when begining
******************/

void NATA_Table_Init( void * table){
	struct _NATA_Table *pTable = (struct NATA_Table *)table;
	int i=0;	
	pTable->valid = 0; 	
	pTable->head=NULL;	
	pTable->reserve_list=NULL;
	pTable->empty_list=&pTable->table[0];
	pTable->size= NATA_ENTRY_MAX; //64			
	memset(&pTable->table,0,sizeof(NATA_ENTRY)*64);
	
	//initialize table entry list;
	for(i=0;i<NATA_ENTRY_MAX;i++){		
		pTable->table[i].next = &pTable->table[i+1];
		if(i!=0)
			pTable->table[i].prev = &pTable->table[i-1];		
		pTable->table[i].index=i;
		pTable->table[i].flag=NATA_ENTRY_FLAG_EMPTY;
	}		
	pTable->table[i-1].next=NULL;
	pTable->table[0].prev=NULL;	
}


int NATA_Stop ()
{
	NAT_Disable();
	NATA_Table.valid =0;
	del_timer(&NATA_Table.timer);
	return 0;
}

int NATA_Start()
{
	int i;
	NATA_ENTRY *pEntry=NULL;
	NATA_Table.valid = 1; //
	
	memcpy(NATA_Table.Lanmac,w740_mac_address0,ETH_ALEN);
	memcpy(NATA_Table.Wanmac,w740_mac_address1,ETH_ALEN);
	
	NAT_Enable();	
	NAT_HitCount_ClearAll();
	NAT_ProcCount_ClearAll();	
	NAT_HitCount_ClearAll();
	NAT_ProcCount_ClearAll();	
	NAT_Entry_ClearAll();		
	NAT_EXMAC_Config(&NATA_Table.Wanmac);
	NAT_INMAC_Config(&NATA_Table.Lanmac);	
	for(i=0;i<64;i++)
	{
		if(NATA_Table.table[i].flag==NATA_ENTRY_FLAG_HEAD)
				NATA_Table.table[i].time=jiffies;
	
	}  		
	add_timer(&NATA_Table.timer);
	return 0;
}

int NATA_Reset(struct _NATA_Table *pTable)
{
	NATA_Stop();
	NATA_Start();
	return 0;
}
/*
*  initialize WAN ip And WAN MAC address
*/
void Init_NATA_Entry(NATA_ENTRY * pNATA_Entry,struct _NATA_Table * pTable)
{
	if(pNATA_Entry==NULL) return ;
	memset(pNATA_Entry->RsMAC,0,6);
	memset(pNATA_Entry->LocMAC,0,6);	
	
}	
/*
add_PPPoE_rmmac(char * mac)
{
  int i;
  printk("MAC56 %x \n",mac);
  memcpy(NATA_Table.PPPoE_rmmac,mac,ETH_ALEN);
    for(i=0;i<8;i++)printk("PPPoe_rmmac %x ",*(mac+i));
}
*/	

/*
*  delete Entry from list;
*/
NATA_ENTRY * Del_From_Head(NATA_ENTRY ** head)
{
   NATA_ENTRY * prev,* first=*head;
   if(head==NULL)
   		return NULL;	
   		   
   	*head=first->next;
   	if(*head!=NULL)
   		(*head)->prev=NULL;
   	
   	first->flag=NATA_ENTRY_FLAG_NONE;
   	return first;
}
/*
*  Add entry for list
*/
void Add_To_Head(NATA_ENTRY **list,NATA_ENTRY * pEntry)
{
	pEntry->next=list;
	if(*list!=NULL)
		(*list)->prev=pEntry;
	*list=pEntry;		
}

//af_inet.c  inet_ioctl() 
int nata_ioctl(int cmd,void *arg)
{
	int ret=0;
	struct nata_req  req;
	int subcmd;
	struct WB_NATA_ENTRY *entry;
	int i;	
	copy_from_user(&req,arg,sizeof(struct nata_req));
	subcmd=req.cmd;		
	switch(subcmd)
	{
		case NATA_SET_PPPOE_HEADER:
			 {
			 	 int i;
			 	 NATA_Reset(&NATA_Table);
			 	 NATA_Table.PPPoE_SessionID=req.type1.pppoe_header.sid;
			 	 
			 	 NATA_Table.PPPoE_PPP_Protocol=0x0021;
			 	 NATA_Table.PPPoE_rmad=htonl(req.type1.pppoe_header.PPPoE_rmad);
			 	 
			 	 memcpy(NATA_Table.PPPoE_rmmac,req.type1.pppoe_header.remote_mac,6);
			 	 memcpy(RSMAC_PPPOE_TEST,req.type1.pppoe_header.remote_mac,6);
			 	 
			 	 PPPoE_Test=NATA_Table.PPPoE_SessionID;
			 	 
			 	 NATA_Table.start_pppoe=req.type1.pppoe_header.start_pppoe;
			 	 printk("$$$$$$$$ %d\n",NATA_Table.PPPoE_SessionID);
				 printk("$$$$$$$$ %d\n",ntohs(NATA_Table.PPPoE_SessionID));			 	 
			 	 for(i=0;i<6;i++)printk("%x:",*(RSMAC_PPPOE_TEST+i));
			 }	
			 printk("CB NATA_SET_PPPOE_HEADER\n");
			 break; 
		case NATA_START:
			 ret=NATA_Start();
			 printk("CB NATA_START\n");
			 break;
		case NATA_STOP :
			 
			 ret=NATA_Stop();
			 printk("CB NATA_STOP\n");
			 break;
		case NATA_RESET :		
			 ret=NATA_Reset(&NATA_Table);
			 printk("CB NATA_RESET\n");
			 break;	
		default:
			printk("NATA default\n");
			break;
	}	
	return 0;
}

extern void *arp_tbl;		
int NATA_Add_Entry(NATA_ENTRY *entry)
{

	 struct neighbour * neigh;
	 
	 struct net_device * dev;
	 char Lan_Habuf[ETH_ALEN];
	 char Wan_Habuf[ETH_ALEN];
	 struct _NATA_Table* pTable=&NATA_Table;
	 NATA_ENTRY *pNATA_Entry;
	 struct ip_conntrack *ct;
	 
	 if(pTable->size<=0)
	 		return -1; //no space	 	
	 if(!Is_NATA_Table_Start())return -1;
	 
	 dev=&w740_netdevice[LAN];
	 neigh= neigh_lookup(&arp_tbl, &entry->lsad, dev);
	 if(neigh==NULL) return -1;//unknown the host
	  memcpy(Lan_Habuf,neigh->ha,ETH_ALEN);	
	 //wan
	 dev=&w740_netdevice[WAN];
	if(!Is_NATA_Table_PPPoE()) { 
		printk("Not pppoe\n");
	 	neigh= neigh_lookup(&arp_tbl, &entry->rsad, dev);
	 	if(neigh==NULL) return -1;//unknown the host
	 	memcpy(Wan_Habuf,neigh->ha,ETH_ALEN);	
	 }
	 else
	 {
	  
	 	memcpy(Wan_Habuf,&NATA_Table.PPPoE_rmmac   ,6);
	 	{
	 		//int i;
	 		//for(i=0;i<6;i++)printk("%x::",*(NATA_Table.PPPoE_rmmac+i));
	 	}
	 }	
	 
	 
AddEntry:
	// pNATA_Entry=Del_From_Head(&pTable->empty_list);	 			 // printk("CC\n");
	{
		int i,en,min_time=1000;
		for(i=0;i<64;i++)
		{			
			if(min_time<pTable->table[i].time)
						en=i;
			if(pTable->table[i].flag==NATA_ENTRY_FLAG_EMPTY)
				{					
					pNATA_Entry=&pTable->table[i];
					break;
				}
	    }
	    if(i==64)
	    {
	    	if(jiffies <(min_time+HZ/10))
	    	   		return -1;
	    	else
	    	{	
	    	  disable_entry(en);
	    	  pNATA_Entry=&pTable->table[en];
	    	}	
	    }	
	}	
	 
	 pTable->size--;
	 printk("size %d\n", pTable->size);
	 
	 Init_NATA_Entry(pTable,pNATA_Entry);
	 ct=(struct ip_conntrack *)pNATA_Entry->ct;
	 ct->nata_index=pNATA_Entry->index;
	 
	 pNATA_Entry->lsad=entry->lsad;
	 			 
	 pNATA_Entry->lspn=entry->lspn;
	 pNATA_Entry->lspn=ntohs(entry->lspn);
	 pNATA_Entry->rsad=entry->rsad;

	 pNATA_Entry->rspn=entry->rspn;
	 pNATA_Entry->rspn=ntohs(entry->rspn);
	
	 pNATA_Entry->msad=entry->msad;
	 
	 pNATA_Entry->mspn=entry->mspn;
	 pNATA_Entry->mspn=ntohs(entry->mspn);
	 
	 
	 memcpy(pNATA_Entry->LocMAC,Lan_Habuf,ETH_ALEN);
	 memcpy(pNATA_Entry->RsMAC ,Wan_Habuf,6);	 
	 #if 0
	 {
	 	int i;
	 	printk("Loc MAC\n");
	 	for(i=0;i<6;i++)printk("%3x ",*(pNATA_Entry->LocMAC+i));
	 	printk("Rs MAC\n");
	 	for(i=0;i<6;i++)printk("%3x ",*(pNATA_Entry->RsMAC+i));
	 }
	 #endif
	 
	 NAT_LSMAC_Config(pNATA_Entry->index,pNATA_Entry->LocMAC);
	 NAT_RSMAC_Config(pNATA_Entry->index,pNATA_Entry->RsMAC);

	 NAT_MASAD_Config(pNATA_Entry->index,&pNATA_Entry->msad);
	 NAT_MASPN_Config(pNATA_Entry->index,&pNATA_Entry->mspn);
	 
	 NAT_LSAD_Config(pNATA_Entry->index,&pNATA_Entry->lsad);
	 NAT_LSPN_Config(pNATA_Entry->index,&pNATA_Entry->lspn);
	 
	 NAT_Entry_Config(pNATA_Entry->index,NATCFG_ExEn|NATCFG_AxCE \
	 |NATCFG_PxCE|NATCFG_AxRE|NATCFG_PxRE);
	 
	 pNATA_Entry->flag=NATA_ENTRY_FLAG_HEAD;
	 
	 pNATA_Entry->time=jiffies;	 
	// printk("CB NATA_ADD_ENTRY\n");
	 return 0;	 
}

int Is_NATA_Table_Start()
{
	return NATA_Table.valid;
}

int Is_NATA_Table_PPPoE()
{
	return NATA_Table.start_pppoe;	
}		

void disable_entry(int i)
{
	struct ip_conntrack *ct;
	if((i>64)||(i<0)) return ;
	ct=(struct ip_conntrack *)NATA_Table.table[i].ct;
	ct->is_cache=0;
	NATA_Table.table[i].ct=NULL;
	NATA_Table.table[i].flag=NATA_ENTRY_FLAG_EMPTY;
	NAT_Entry_Disable(i);
	printk("NATA %d entry Disalbe\n",i);
}	
void NATA_Entry_Timeout(unsigned long arg)
{
	NATA_ENTRY *pEntry;
	int i;
	//printk("^");
	for(i=0;i<64;i++)
	{
	 if(NATA_Table.table[i].ct!=NULL)
		{
			if(	(NATA_Table.table[i].time+1*HZ)<=jiffies)	
				{					
					printk("NATA timeout  :");					
					disable_entry(i);
					NATA_Table.size++;
				}		
			else
			{
				NATA_Table.table[i].time=jiffies;
				//ip_ct_refresh(NATA_Table.table[i].ct, 30*HZ);		
			}	
		}
	}
		
	NATA_Table.timer.expires =jiffies+1*HZ;
	add_timer(&NATA_Table.timer);
}
void nata_init()
{
	printk("Winbond NATA1 ver0.2\n");
	NATA_Table_Init(&NATA_Table);
	init_timer(&NATA_Table.timer);
	NATA_Table.timer.expires =jiffies+1*HZ;
	NATA_Table.timer.data = (unsigned long) NULL;
	NATA_Table.timer.function = &NATA_Entry_Timeout;
		
	NATA_Table.WanIp=0;
	NATA_Table.LanIp=0;
	NATA_Table.start_pppoe=0;	
	NATA_Start();	
}
module_init(nata_init);