
#include <linux/config.h>
#include <linux/module.h>

#include <linux/init.h>
#include <linux/sched.h>
#include <linux/kernel.h>      
#include <linux/slab.h>		 
#include <linux/errno.h>
#include <linux/types.h>
#include <linux/interrupt.h>

#include <linux/in.h>
#include <linux/netdevice.h>
#include <linux/etherdevice.h>
#include <linux/ip.h>
#include <linux/tcp.h>
#include <linux/skbuff.h>
#include <asm/irq.h>

#include <linux/delay.h>
#include "rtl8201.h"
#include "w740mac.h"
#include "w740nat.h"

int duplex_mode = 0;

void rtl8210_100full(void)
{
    // first software reset the RTL8201      
    //MiiStationWrite(RTL8201_CNTL_REG, RTL8201_ADDR, RTL8201_CNTL_RESET);
    //MiiStationWrite(RTL8201_CNTL_REG, RTL8201_ADDR, 0); /* disable auto negotiate */

    // force to 100M full duplex
    printk("Force 100M Full duplex...");
    MiiStationWrite(RTL8201_CNTL_REG, RTL8201_ADDR, RTL8201_CNTL_100_SPEED|RTL8201_CNTL_FULL_DUP);
}

void rtl8210_100half(void)
{
    // first software reset the RTL8201      
    //MiiStationWrite(RTL8201_CNTL_REG, RTL8201_ADDR, RTL8201_CNTL_RESET);
    //MiiStationWrite(RTL8201_CNTL_REG, RTL8201_ADDR, 0); /* disable auto negotiate */

    // force to 100M half duplex
    printk("Force 100M Half duplex...");
    MiiStationWrite(RTL8201_CNTL_REG, RTL8201_ADDR, RTL8201_CNTL_100_SPEED);
}

void rtl8210_10full(void)
{
    // first software reset the RTL8201      
    //MiiStationWrite(RTL8201_CNTL_REG, RTL8201_ADDR, RTL8201_CNTL_RESET);
    // force to 10M full duplex
    printk("Force 10M Full duplex...");
    MiiStationWrite(RTL8201_CNTL_REG, RTL8201_ADDR, RTL8201_CNTL_FULL_DUP); 

}
void rtl8210_10half(void)
{
    // first software reset the RTL8201      
    //MiiStationWrite(RTL8201_CNTL_REG, RTL8201_ADDR, RTL8201_CNTL_RESET);
    printk("Force 10M Half duplex...");
    MiiStationWrite(RTL8201_CNTL_REG, RTL8201_ADDR, 0); 

}

void rtl8201_PhyReset(void)
{
    unsigned Status;

    Status = MiiStationRead(RTL8201_CNTL_REG,RTL8201_ADDR);

    // first software reset the RTL8201
    if( (Status & RTL8201_CNTL_AN )== 0 )
    {
    	MiiStationWrite(RTL8201_CNTL_REG, RTL8201_ADDR, RTL8201_CNTL_RESET);
	// Now start an auto negotiation
	printk("Start auto negotiation...\n");
	MiiStationWrite(RTL8201_CNTL_REG, RTL8201_ADDR, 
		RTL8201_CNTL_AN+
		RTL8201_CNTL_RSTRT_AN);
    	printk("reset phy...\n");
    }

#ifdef XXX
    
    MiiStationWrite(RTL8201_CNTL_REG, RTL8201_ADDR, 0);

#if 1
    // initialize auto-negotiation capabilities
    MiiStationWrite(RTL8201_ANA_REG,RTL8201_ADDR, 
                    RTL8201_ANA_100TX_FULL+
                    RTL8201_ANA_100TX+
                    RTL8201_ANA_10T_FULL+
                    RTL8201_ANA_10T+
                    RTL8201_ANA_SEL_802_3);

    // Now start an auto negotiation
    printk("Start auto negotiation...\n");
    MiiStationWrite(RTL8201_CNTL_REG, RTL8201_ADDR, 
                    RTL8201_CNTL_AN+
                    RTL8201_CNTL_RSTRT_AN);
#elif 0
#warning force to 10M full duplex
    // initialize auto-negotiation capabilities
    MiiStationWrite(RTL8201_ANA_REG,RTL8201_ADDR, 
                    RTL8201_ANA_10T_FULL+
                    RTL8201_ANA_10T+
                    RTL8201_ANA_SEL_802_3);
    // force to 10M full duplex
    MiiStationWrite(RTL8201_CNTL_REG, RTL8201_ADDR,
                    RTL8201_CNTL_FULL_DUP);
#else
#warning force to 10M half duplex
    // initialize auto-negotiation capabilities
    MiiStationWrite(RTL8201_ANA_REG,RTL8201_ADDR, 
                    RTL8201_ANA_10T+
                    RTL8201_ANA_SEL_802_3);
    // force to 10M half duplex
    MiiStationWrite(RTL8201_CNTL_REG, RTL8201_ADDR,
                    0);
#endif

#endif /* XXX */

}


void rtl8201_PhySetDuplexMode(int mode )
{
	switch( mode )
	{
	case NATA_WAN_100_FULL_DUPLEX:
		rtl8210_100full();
		break;
	case NATA_WAN_100_HALF_DUPLEX:
		rtl8210_100half();
		break;
	case NATA_WAN_10_FULL_DUPLEX:
		rtl8210_10full();
		break;
	case NATA_WAN_10_HALF_DUPLEX:
		rtl8210_10half();
		break;
	default:
		rtl8201_PhyReset();
		break;
	}
}

unsigned rtl8201_PhyStatus(void)
{
    unsigned Status;
    unsigned count=0;
#ifdef IC_PLUS
    unsigned RdValue=0;
    unsigned succ;  
#endif

    // Wait for auto negotiation to get completed
    do
    {
        Status = MiiStationRead(RTL8201_STATUS_REG,RTL8201_ADDR);
        udelay(5000);
        count++;
    }
    while (!(Status&RTL8201_STATUS_AN_COMLETE) && count<500);
    //If it takes longer then 10 sec stop waiting

#if 0
    if( count >= 500 && (! (Status & RTL8201_STATUS_AN_COMLETE) ) )
    {
	Status = MiiStationRead(RTL8201_CNTL_REG,RTL8201_ADDR);    

    	if( (Status & RTL8201_CNTL_100_SPEED) && !(Status & RTL8201_CNTL_FULL_DUP) )
	{
		printk("force to full duplex\n");
		rtl8210_100full(); //force to FULLDUPLEX
		
		/* write to winbond CPU */
		w740_WriteReg(MCMDR,w740_ReadReg(MCMDR,1)| MCMDR_OPMOD,1);
		w740_WriteReg(MCMDR,w740_ReadReg(MCMDR,1)| MCMDR_FDUP,1);
	}
	//else printk("auto negotiable not completed\n");
    }
#endif

    Status = MiiStationRead(RTL8201_CNTL_REG,RTL8201_ADDR);    

    if( Status & RTL8201_CNTL_100_SPEED )
    {
    	printk("100M - ");
    	w740_WriteReg(MCMDR,w740_ReadReg(MCMDR,1)|MCMDR_OPMOD,1);
    }
    else
    {
    	printk("10M - ");
    	w740_WriteReg(MCMDR,w740_ReadReg(MCMDR,1)&(~MCMDR_OPMOD),1);
    }

    if( Status & RTL8201_CNTL_FULL_DUP )
    {
    	printk("Full duplex\n");
    	w740_WriteReg(MCMDR,w740_ReadReg(MCMDR,1)|MCMDR_FDUP,1);
    }
    else
    {
    	printk("Half duplex\n");
    	w740_WriteReg(MCMDR,w740_ReadReg(MCMDR,1)&(~MCMDR_FDUP),1);
    }

#ifdef IC_PLUS
    /* Fix IC PLUS 10half collision bug */
    RdValue = MiiStationReadOld(0, 0x1d, RTL8201_ADDR,&succ);
    RdValue |= 0x0100;
    MiiStationWriteOld(0, 0x1d, RTL8201_ADDR, RdValue,&succ);
#endif

    return 0;
}

