

/*
 * linux/deriver/net/w740mac.c
 * Ethernet driver for winbond w90n740
  */
//2002-12-25 10:59 nata  2003-1-22 9:20
//2003/4/28 01:43pm ICPlus
//2003/6/5 12:45?E//
#include <linux/config.h>
#include <linux/module.h>

#include <linux/init.h>
#include <linux/sched.h>
#include <linux/kernel.h>      
#include <linux/slab.h>		 
#include <linux/errno.h>
#include <linux/types.h>
#include <linux/interrupt.h>

#include <linux/in.h>
#include <linux/netdevice.h>
#include <linux/etherdevice.h>
#include <linux/ip.h>
#include <linux/tcp.h>
#include <linux/skbuff.h>
#include <asm/irq.h>
//#include "740_defs.h"

#define WINBOND_NATA

extern int debug_i;
#include "w740mac.h"

#ifdef WINBOND_NATA
#include "w740nat.h"
#endif  //WINBOND_NATA


#define MDCCR    		0x00300000  /* MDC clock rating */

#define RX_INTERRUPT   15 
#define TX_INTERRUPT   13

//#define TEST_REST
//#define  TEST_10HD 

#undef DEBUG
//#define DEBUG

//#define SWITCH_6052

#define PRE_EXIT  32

//#define HAVE_PHY
//#define IC_PLUS	/* disable by norton 2004/11/15 */


#define HACK	//lsshi add
unsigned long tx_queue_count = 0;

#define MAC0_FLASH_ADDR  ((char *) 0x7F010008)
#define MAC1_FLASH_ADDR  ((char *) 0x7F010014)

char w740_mac_address0[ETH_ALEN]={0x00,0x03,0x0A,0x0B,0x0C,0x0D};
char w740_mac_address1[ETH_ALEN]={0x00,0x03,0xAA,0xBB,0xCC,0xDD};


#define NON_ALIGN_BUG
#if 0
#define  Disable_MAC_Int \
	Disable_Int(EMCTXINT0);\
    	Disable_Int(EMCRXINT1);\
    	Disable_Int(EMCRXINT0);\
     	Disable_Int(EMCTXINT1);
#define Enable_MAC_Int \
	Enable_Int(EMCTXINT0);\
    	Enable_Int(EMCRXINT1);\
    	Enable_Int(EMCRXINT0);\
     	Enable_Int(EMCTXINT1);
#else
#define Disable_MAC_Int(x)   local_irq_save(x) 
#define Enable_MAC_Int(x)    local_irq_restore(x)

#endif     	
     	

/************DEBUG*****************/
#define TRACE_ERROR printk
#define printf printk

#ifdef	DEBUG
	#define TRACE(str, args...)	printk("W90N740 eth: " str, ## args)
	#define MAC_ASSERT(x)							 \
	do {									 \
		if (!(x))							 \
			printk("ASSERT: %s:%i(%s)\n",				 \
			       __FILE__, __LINE__, __FUNCTION__);		 \
	} while(0);
#else
	#define MAC_ASSERT(x)
	#define TRACE(str, args...)
#endif

//#define CHECK_DEBUG 
//#define printf printk
#ifdef CHECK_DEBUG
	#define printf printk
	#define THOUGH_HERE printf("come  cbhuang %s   %s  %d  \n",__FILE__,__FUNCTION__,__LINE__)
	int  check_flag(unsigned  long flag)
	{
		if(!flag)
		{
	   	 	printk("non cache flag error!!\n");	
	   	 	return -1;
	   	}
	   	return 0;
	}
#else
	#define check_flag(x) 0
	#define THOUGH_HERE   
#endif

/*****************************/
#define TXBD_BUFFER(priv,txbd) \
		(unsigned long)(&priv->tx_buf[txbd-&priv->tx_desc[0]])|NON_CACHE_FLAG+(unsigned long)PRE_EXIT
#define RXBD_BUFFER(priv,rxbd) \
		(unsigned long)(&priv->rx_buf[rxbd-&priv->rx_desc[0]])|NON_CACHE_FLAG+(unsigned long)PRE_EXIT
/* Global variables  used for MAC driver */
static unsigned long  	gMCMDR = MCMDR_SPCRC | MCMDR_EnMDC | MCMDR_ACP;//|MCMDR_LBK;


static unsigned long  	gMIEN = EnTXINTR | EnRXINTR | EnRXGD | EnTXCP |EnNCS |
		EnTxBErr | EnRxBErr | EnNATOK|EnNATErr|EnRDU | EnTDU;
/*
volatile static unsigned long gMIEN = EnTXINTR | EnRXINTR | EnRXGD | EnTXCP |
                        EnTxBErr | EnRxBErr | EnRDU | EnTDU |
                        EnLC | EnTXABT | EnNCS | EnEXDEF | EnTXEMP |
                        EnCRCE | EnRP | EnPTLE | EnALIE | EnCFR | EnRXOV |
                        EnNATErr | EnNATOK;
*/
#define RX_DESC_SIZE 32*2   
#define TX_DESC_SIZE RX_DESC_SIZE
#define CHECK_SIZE
#define PACKET_BUFFER_SIZE 1600
#define PACKET_SIZE   1560

#define RX_TIMEOUT    2
#define TX_TIMEOUT    1

struct  w740_priv
{
	struct net_device_stats stats;	
	unsigned long which;
	unsigned long rx_mode;
	unsigned long cur_tx_entry;
	unsigned long cur_rx_entry;

	long int tx_entry;
	long int tx_finish_entry;
	
	unsigned long rx_hang_time;

	unsigned long bInit;
	unsigned long rx_packets;
	unsigned long rx_bytes;	
	unsigned long rx_int;
	unsigned long rx_rdu;
	
	unsigned long tx_ptr;
	unsigned long tx_finish_ptr;
	unsigned long rx_ptr;
	int 	 long tx_stop;	
	int 	 long tx_try;
	
	unsigned long start_tx_ptr;
	unsigned long start_tx_buf;
	unsigned long start_rx_ptr;
	unsigned long start_rx_buf;
	
	unsigned long if_timer;
	struct timer_list timer;	
#ifdef HACK
	struct timer_list hack_timer;
#endif
	char mac_address[ETH_ALEN];
	unsigned long mcmdr;
	unsigned long mac_ncs;
	unsigned long mac_ncs_change;
	
	volatile RXBD   rx_desc[RX_DESC_SIZE]  __attribute__ ((aligned (4)));
	volatile TXBD   tx_desc[TX_DESC_SIZE]	__attribute__ ((aligned (4)));
	volatile char tx_buf[TX_DESC_SIZE][PACKET_BUFFER_SIZE]	__attribute__ ((aligned (32)));
	volatile char rx_buf[RX_DESC_SIZE][PACKET_BUFFER_SIZE]	__attribute__ ((aligned (32)));

};



static TXBD * get_txbd(struct net_device *dev );
static int   w740_init(struct net_device *dev);
static int   send_frame(struct net_device * ,unsigned char *,int);
static void  output_register_context(unsigned int );
static void  netdev_rx(struct net_device *dev);
static void  rx_interrupt(int irq, void *dev_id, struct pt_regs * regs);
static void  tx_interrupt(int irq, void *dev_id, struct pt_regs * regs);
#ifdef HACK
static void rx_hack_timeout(unsigned long arg);
#endif

static void w740_rx_timeout(unsigned long arg);
static void  w740_tx_timeout(struct net_device *dev);
static void send_txbd(struct net_device * dev,TXBD* txbd,unsigned char *data,int length,int bCopy);

#ifdef RTL8201_PHY

#include "rtl8201.c"

#else

int   MiiStationWrite(int num,unsigned long PhyInAddr,unsigned long PhyAddr,unsigned long PhyWrData,int * succ);
unsigned long MiiStationRead(int num, unsigned long PhyInAddr, unsigned long PhyAddr,int *succ);

#endif

void ResetMAC(struct net_device * dev);
int 	 do_nata(struct net_device *dev,RXBD * rxbd );	
struct net_device w740_netdevice[2]=
{
	{init:w740_init},
	{init:w740_init}
};

void w740_WriteCam(int which,int x, unsigned char *pval)
{
	
	unsigned int msw,lsw;
	
	
 	msw =  	(pval[0] << 24) |
        	(pval[1] << 16) |
        	(pval[2] << 8) |
         	pval[3];

 	lsw = (pval[4] << 24) |
           (pval[5] << 16);
    
 	w740_WriteCam1(which,0,lsw,msw);
}

int  ResetPhyChip(int num)
{
#ifdef SWITCH_6052

    {
	unsigned long debug;
        unsigned long i;

	if(num == 0) {
	  TRACE_ERROR("setting lan side vlan table\r\n");
	  for(i = 8; i < 0xf; i ++) {
	    debug = MiiStationRead(0, 0x04, (0x1000 |(i << 8)) );
	    MiiStationWrite(0, 0x04, (0x1000 | (i << 8)), debug | 0x3);  // enable all ports
	  }
	  MiiStationWrite(0, 0x00, 0x1100, ENABLE_AN | RESTART_AN);
	  MiiStationWrite(0, 0x00, 0x1200, ENABLE_AN | RESTART_AN);
	  MiiStationWrite(0, 0x00, 0x1300, ENABLE_AN | RESTART_AN);
	  MiiStationWrite(0, 0x00, 0x1400, ENABLE_AN | RESTART_AN);

	  /* Set port 1~5 to use database 0, and in the same VLAM */
	  MiiStationWrite(0, 0x06, 0x1900, 0x003c);     //port 1 for LAN

	  MiiStationWrite(0, 0x06, 0x1a00, 0x003a);     //port 2
	  MiiStationWrite(0, 0x06, 0x1b00, 0x0036);     //port 3
	  MiiStationWrite(0, 0x06, 0x1c00, 0x002e);     //port 4
	  MiiStationWrite(0, 0x06, 0x1d00, 0x001e);     //port 5 connect to CPU MAC 0

	  /* set MAC 0 to 100 full */
	  w740_WriteReg(MCMDR,w740_ReadReg(MCMDR,0)|MCMDR_OPMOD|MCMDR_FDUP,0);
	} else {
	  TRACE_ERROR("setting wan side vlan table\r\n");
	  for(i = 8; i < 0xf; i ++) {
	    debug = MiiStationRead(0, 0x04, (0x1000 |(i << 8)) );
	    MiiStationWrite(0, 0x04, (0x1000 | (i << 8)), debug | 0x3);  // enable all ports
	  }
	  MiiStationWrite(0, 0x00, 0x1000, ENABLE_AN | RESTART_AN);
	  /* Set port 0,6 to use database 1, and in the same VLAM */
	    /* Use MDC0 and MDIO0 to configure 6052 */
	  MiiStationWrite(0, 0x06, 0x1800, 0x1040);     //port 0 for WAN
	  MiiStationWrite(0, 0x06, 0x1e00, 0x1001);     //port 6 connect to CPU port 1

	  /* set MAC 1 to 100 full */
	 w740_WriteReg(MCMDR,w740_ReadReg(MCMDR,1)|MCMDR_OPMOD|MCMDR_FDUP,1);

	}
	return 0;

    }
#endif /* SWITCH_6052 */

#ifdef IC_PLUS

    unsigned long RdValue,i;
	
    MiiStationWrite(num, PHY_ANA_REG, PHYAD, DR100_TX_FULL|DR100_TX_HALF|\
		      DR10_TX_FULL|DR10_TX_HALF|IEEE_802_3_CSMA_CD,&succ);
		      
    MiiStationWrite(0, PHY_CNTL_REG, PHYAD, ENABLE_AN | RESET_PHY|RESTART_AN,&succ);
   
    MiiStationWrite(0, 0x16, PHYAD, 0x8420,&succ);
    RdValue = MiiStationRead(num, 0x12, PHYAD,&succ);
    MiiStationWrite(0, 0x12, PHYAD, RdValue | 0x80,&succ); // enable MII registers
  
    if(num == 1) {    

    	for(i=0;i<256*1024;i++)
	{
		printk("no %d link auto negotiate\n",i);
		RdValue = MiiStationRead(num, PHY_STATUS_REG, PHYAD,&succ) ;
		if((RdValue & AN_COMPLETE) != 0)
		{
		 	
			break;
		}
		  
	}
		
	/* printk("i=%d  %x \n",i,i);	*/
   	if(i>=256*1024)
    	{
		printk("Auto-negotiate fail1 ? set to full duplex mode? \n");
		//printkk("come  cbhuang %s   %s  %d  \n",__FILE__,__FUNCTION__,__LINE__);
		w740_WriteReg(MCMDR,w740_ReadReg(MCMDR,1)| MCMDR_OPMOD,1);
		w740_WriteReg(MCMDR,w740_ReadReg(MCMDR,1)| MCMDR_FDUP,1);
				
		return 1;
	}
    }

 	/*   printk("Rdvalue %x\n",RdValue); */
    if( num == 1) {
	    
		
	    RdValue = MiiStationRead(num, PHY_CNTL_REG, PHYAD,&succ) ;
	    
	    /*    printk("Rdvalue %x\n",RdValue); */
	    if(RdValue==1)
	    {
	    	printk("Auto-negotiate fail2 ?\n");
	    	//printk("2003/5/9 11:06 w740mac.\n");
	    	//while(1);	
	    }	
	    if (RdValue & DR_100MB) {			/* 100MB */
		printk("100MB - ");
	   	w740_WriteReg(MCMDR,w740_ReadReg(MCMDR,1)|MCMDR_OPMOD,1);	
		// MCMDR_1 |= MCMDR_OPMOD;
	      
	    } else {
		printk("10MB - ");
		w740_WriteReg(MCMDR,w740_ReadReg(MCMDR,1)&(~MCMDR_OPMOD),1);	
		// MCMDR_1 &= ~MCMDR_OPMOD;
	    }
	    if (RdValue & PHY_FULLDUPLEX) {	/* Full Duplex */
	      
		printk("Full Duplex\n");
		w740_WriteReg(MCMDR,w740_ReadReg(MCMDR,1)|MCMDR_FDUP,1);	  
		// MCMDR_1 |= MCMDR_FDUP;
	    } else { 
		printk("Half Duplex\n");
		w740_WriteReg(MCMDR,w740_ReadReg(MCMDR,1)&(~MCMDR_FDUP),1);	        
		// MCMDR_1 &= ~MCMDR_FDUP;
	    } 
	    /* Fix IC PLUS 10half collision bug */
	    RdValue = MiiStationRead(num, 0x1d, PHYAD,&succ); 
	    RdValue |= 0x0100;
	    MiiStationWrite(num, 0x1d, PHYAD, RdValue,&succ);
	
	    
    } 
    else 
    {
	    w740_WriteReg(MCMDR,w740_ReadReg(MCMDR,num)|MCMDR_OPMOD,num);	
	    w740_WriteReg(MCMDR,w740_ReadReg(MCMDR,num)|MCMDR_FDUP,num);		  
    }
    
    return 0;
	
#endif	/* IC_PLUS */
  
#ifdef HAVE_PHY

 	unsigned long RdValue;
 	int which=num;
 	volatile int loop=1000*100000;
 	
	TRACE_ERROR("\nWait for auto-negotiation complete...");

#ifdef TEST_10HD   
    if(num==1)
    	MiiStationWrite(which, PHY_ANA_REG, PHYAD, DR10_TX_HALF|IEEE_802_3_CSMA_CD);    	
#endif     
   
    	if(MiiStationWrite(which, PHY_CNTL_REG, PHYAD, ENABLE_AN | RESTART_AN, &succ )==1)
 	{
 		return 1;
	}

 	while (1) 	/* wait for auto-negotiation complete */
   	{

		RdValue = MiiStationRead(which, PHY_STATUS_REG, PHYAD, &succ ) ;

    		#if 0		
		if(RdValue==(unsigned long)1)
    		{
			printk("ResetPhyChip failed 1\n");
			return 1;
		}
    		#endif		  
    		
		if ((RdValue & AN_COMPLETE) != 0)
		{
			break;
		}
		loop--;
		if(loop==0)
		{
			return 1;
		}	 
   	
	}//while  
	
	TRACE_ERROR("OK\n");

 	/* read the result of auto-negotiation */
 	RdValue = MiiStationRead(which, PHY_CNTL_REG, PHYAD, &succ ) ;

	printk("which=%d\n RdValue=%x\n",which,(unsigned int)RdValue);
 	if(RdValue==(unsigned long)1)
 	{
 		printk("auto nego fail? \n");
 		return 1;
 	}
 	if ((RdValue & DR_100MB)!=0) 	/* 100MB */
   	{
		TRACE_ERROR("100MB - ");
		w740_WriteReg(MCMDR,w740_ReadReg(MCMDR,which)|MCMDR_OPMOD,which);	
   	}
  	else 
   	{    	
		w740_WriteReg(MCMDR,w740_ReadReg(MCMDR,which)&(~MCMDR_OPMOD),which);
		TRACE_ERROR("10MB - ");	
   	}
 	if ((RdValue & PHY_FULLDUPLEX) != 0) 	/* Full Duplex */
   	{
		TRACE_ERROR("Full Duplex\n");
		w740_WriteReg(MCMDR,w740_ReadReg(MCMDR,which)|MCMDR_FDUP,which);	
   	}
  	else 
   	{ 
		TRACE_ERROR("Half Duplex\n");
		w740_WriteReg(MCMDR,w740_ReadReg(MCMDR,which)&(~MCMDR_FDUP),which);
   	}      
   	return 0;
  
#endif  /* HAVE PHY */


#ifdef RTL8201_PHY

/*
	unsigned long RdValue,i;
	
	MiiStationWriteOld(num, PHY_ANA_REG, RTL8201_ADDR, DR100_TX_FULL|DR100_TX_HALF|\
		      DR10_TX_FULL|DR10_TX_HALF|IEEE_802_3_CSMA_CD,&succ);
		      
	MiiStationWriteOld(0, PHY_CNTL_REG, RTL8201_ADDR, ENABLE_AN | RESET_PHY|RESTART_AN,&succ);
   
	MiiStationWriteOld(0, 0x16, RTL8201_ADDR, 0x8420,&succ);
	RdValue = MiiStationReadOld(num, 0x12, RTL8201_ADDR, &succ);
	MiiStationWriteOld(0, 0x12, RTL8201_ADDR, RdValue | 0x80,&succ); // enable MII registers
*/
	if( num == 1 ) /* WAN port */
	{
		rtl8201_PhySetDuplexMode(duplex_mode); //rtl8201_PhyReset();
		rtl8201_PhyStatus();
			
	}
	else /* LAN port */
	{
		w740_WriteReg(MCMDR,w740_ReadReg(MCMDR,num)|MCMDR_OPMOD,num);	
		w740_WriteReg(MCMDR,w740_ReadReg(MCMDR,num)|MCMDR_FDUP,num);
	}

	return 0;
#endif


}


#ifdef RTL8201_PHY

int  MiiStationWrite(unsigned long PhyInAddr,unsigned long PhyAddr,unsigned long PhyWrData )
{
   int which = 1;
   
   w740_WriteReg(MIID,PhyWrData,which);
   w740_WriteReg(MIIDA,PhyInAddr|PhyAddr|PHYBUSY|PHYWR|MDCCR,which);
   while((w740_ReadReg(MIIDA,which) &PHYBUSY));

   return 0;
}

unsigned long MiiStationRead(unsigned long PhyInAddr, unsigned long PhyAddr)
{
    unsigned long PhyRdData ;
    int which = 1;

    w740_WriteReg(MIIDA, PhyInAddr | PhyAddr | PHYBUSY | MDCCR,which);
    while( (w740_ReadReg(MIIDA,which)& PHYBUSY));

    PhyRdData = w740_ReadReg(MIID,which) ;

    return PhyRdData ;
}
#endif

#ifdef RTL8201_PHY
int  MiiStationWriteOld(int num,unsigned long PhyInAddr,unsigned long PhyAddr,unsigned long PhyWrData,int * succ )
#else
int  MiiStationWrite(int num,unsigned long PhyInAddr,unsigned long PhyAddr,unsigned long PhyWrData,int * succ )
#endif
{
    int which;

#ifdef IC_PLUS
    num = 0;
#endif	

#ifdef RTL8201_PHY
    num = 0;
#endif
   
#ifdef SWITCH_6052 
    //if(num==1) return 0;
    num = 0;
#endif

	
   which=num;
   w740_WriteReg(MIID,PhyWrData,which);   
   w740_WriteReg(MIIDA,PhyInAddr|PhyAddr|PHYBUSY|PHYWR|MDCCR,which);
   while((w740_ReadReg(MIIDA,which) &PHYBUSY));
  /*
   {
     loop=loop-1;	
     if(loop<=0)
     {
  	printk("station failed %d \n",loop); 
        *succ=0;
        return 0;
     }
   }
   */
   *succ=1;
   return 0;
}

#ifdef RTL8201_PHY
unsigned long MiiStationReadOld(int num, unsigned long PhyInAddr, unsigned long PhyAddr,int * succ)
#else
unsigned long MiiStationRead(int num, unsigned long PhyInAddr, unsigned long PhyAddr,int * succ)
#endif
{
 	unsigned long PhyRdData ;
 	int which=num;
// 	volatile int loop=1024*128;
 
#ifdef SWITCH_6052 
	if(which==1) return 0;
#endif

#ifdef  IC_PLUS
	num = 0;
#endif	

#ifdef RTL8201_PHY
	num = 0;
#endif
	which=num;		

    
    w740_WriteReg(MIIDA, PhyInAddr | PhyAddr | PHYBUSY | MDCCR,which);
    while( (w740_ReadReg(MIIDA,which)& PHYBUSY));
   /*
    {
    	loop=loop-1;
    	
    	if(loop<=0)
    	{
    		*succ=0;
 	   printk("failed %d \n",loop);		
    	   return 0;	
    	}
    }
    */
   
    *succ=1;
    PhyRdData = w740_ReadReg(MIID,which) ;
    return PhyRdData ;
}

//#endif 

/************************************************************************
* FUNCTION                                                             
*        w740_set_mac_address
*                                                                      
* DESCRIPTION                                                          
*        Set MAC Address For Device By Writing CAM Entry 0,  
*                                                                      
* INPUTS                                                               
*       dev :The MAC which address require to modified
*		addr:New Address 
*                                                                      
* OUTPUTS                                                              
*		Always sucess    
*************************************************************************/ 
static int w740_set_mac_address(struct net_device *dev, void *addr)
{ 
	struct w740_priv * priv=(struct w740_priv *)dev->priv;
	
	if(netif_running(dev))
		return -EBUSY;

	memcpy(dev->dev_addr,addr+2,6);
	if(priv->which)
		memcpy(w740_mac_address1,dev->dev_addr,8);
	else
    		memcpy(w740_mac_address0,dev->dev_addr,8);
		
	return 0;
}

/************************************************************************
* FUNCTION                                                             
*        init_rxtx_rings
*                                                                      
* DESCRIPTION                                                          
*		Initialize the Tx ring and Rx ring.
*                                                                      
* INPUTS                                                               
*       dev :Which Ring is initialized including Tx and Rx Ring.
*                                                                      
* OUTPUTS                                                              
*		None
*************************************************************************/ 
static void init_rxtx_rings(struct net_device *dev)
{
	int i;
	struct w740_priv * w740_priv=(struct w740_priv * )dev->priv;

	w740_priv->start_tx_ptr =(unsigned long)&w740_priv->tx_desc[0]|NON_CACHE_FLAG;	
	w740_priv->start_tx_buf =(unsigned long)&w740_priv->tx_buf[0] | NON_CACHE_FLAG;
	
	w740_priv->start_rx_ptr =(unsigned long)&w740_priv->rx_desc[0]|NON_CACHE_FLAG;
	w740_priv->start_rx_buf =((unsigned long)(&w740_priv->rx_buf[0]) |NON_CACHE_FLAG) + (unsigned long)PRE_EXIT;
	
	for ( i = 0 ; i < TX_DESC_SIZE ; i++ )
	{
	   	w740_priv->tx_desc[i].SL=0;
	   	w740_priv->tx_desc[i].mode=0;
		w740_priv->tx_desc[i].buffer=((unsigned char*)((unsigned long)&w740_priv->tx_buf[i]|NON_CACHE_FLAG)) + (unsigned long)PRE_EXIT;	
		w740_priv->tx_desc[i].next=(unsigned long)((unsigned long)&w740_priv->tx_desc[i+1]|NON_CACHE_FLAG);

#ifdef WINBOND_NATA    
		w740_priv->tx_desc[i].org_buffer=w740_priv->tx_desc[i].buffer;
#endif    
				
	}
	w740_priv->tx_desc[i-1].next=(unsigned long)(&w740_priv->tx_desc[0])|NON_CACHE_FLAG;	
   
	for( i =0 ; i < RX_DESC_SIZE ; i++)
	{    
		w740_priv->rx_desc[i].SL=0;
		w740_priv->rx_desc[i].SL|=RXfOwnership_DMA;		  
		w740_priv->rx_desc[i].buffer=(unsigned char*)((unsigned long)&w740_priv->rx_buf[i]|NON_CACHE_FLAG);	
		w740_priv->rx_desc[i].next=(unsigned long)&w740_priv->rx_desc[i+1]|NON_CACHE_FLAG;
#if 0
#ifdef WINBOND_NATA    
    w740_priv->rx_desc[i].org_buffer=w740_priv->rx_desc[i].buffer;
#endif
#endif    
	}	
	w740_priv->rx_desc[i-1].next=(unsigned long)&w740_priv->rx_desc[0]|NON_CACHE_FLAG;	
}

/************************************************************************
* FUNCTION                                                             
*       w740_open
*                                                                      
* DESCRIPTION                                                          
*		Set Register ,Register ISR ,The MAC began to Receive Package.
*                                                                      
* INPUTS                                                               
*       dev :Pointer to MAC That is Opened.
*                                                                      
* OUTPUTS                                                              
*		Sucess if Return 0		
*************************************************************************/ 
static int   w740_open(struct net_device *dev)
{
  	struct w740_priv * priv;
  	int    which ;

  	priv=(struct w740_priv *)dev->priv;
  	which= priv->which; 
  	  	
  	init_rxtx_rings(dev);
  	priv->rx_ptr=priv->start_rx_ptr ;
  	priv->tx_ptr=priv->start_tx_ptr ;
  	priv->tx_finish_ptr=priv->tx_ptr;
  	
  	w740_WriteReg(FIFOTHD,0x10100,which);
  	w740_WriteReg(FIFOTHD,w740_ReadReg(FIFOTHD,which)|FIFOTHD_Blength|FIFOTHD_TxBurst,which);//12-05
  	
  	w740_WriteReg(RXDLSA,priv->start_rx_ptr,which);
  	w740_WriteReg(TXDLSA,priv->start_tx_ptr,which);
  	w740_WriteReg(DMARFC,PACKET_SIZE,which);
  	
  	w740_WriteCam(priv->which,0,dev->dev_addr);
	w740_WriteReg(CAMEN,w740_ReadReg(CAMEN,priv->which) | 1,priv->which);
  
  	w740_WriteReg(CAMCMR,CAMCMR_ECMP|CAMCMR_ABP|CAMCMR_AMP,which);
  	
  	w740_WriteReg(MCMDR,1<<19,which);

#ifdef XX_TEST
#ifndef SWITCH_6052	
	if(1==MiiStationWrite(which,PHY_CNTL_REG,0x0100,RESET_PHY,&succ))
		printk("come  cbhuang %s   %s  %d  \n",__FILE__,__FUNCTION__,__LINE__);;
#endif	
#endif
    
	priv->mac_ncs_change=0;
	priv->mac_ncs=1;
	if(ResetPhyChip(which)==1)
	{	
		TRACE_ERROR("ResetPhyChip Failed NO ncs \n");
		priv->mac_ncs=1;
	}else
		priv->mac_ncs=0;
    	
    TRACE("**** which %d \n", which);
    if(request_irq(TX_INTERRUPT+which,&tx_interrupt,SA_INTERRUPT,"",dev))
    {
    	TRACE_ERROR(KERN_ERR "W90N740 : register irq tx failed\n");
    	return -EAGAIN;
    }
         
    if(request_irq(RX_INTERRUPT+which,&rx_interrupt,SA_INTERRUPT,"",dev))
    {
    	TRACE_ERROR(KERN_ERR "w90N740 : register irq rx failed\n");
    	return -EAGAIN;
    }
 
    if(which==0){   	
    	AIC_SCR_EMCTX0 = 0x41;    	
    	AIC_SCR_EMCRX0 = 0x41;    
    	Enable_Int(EMCTXINT0);
    	Enable_Int(EMCRXINT0);    	    	
   	w740_WriteReg(MCMDR,w740_ReadReg(MCMDR,which)|MCMDR_LAN,which); 	
   		
    }
    else
    {
    	AIC_SCR_EMCTX1 = 0x41;
    	AIC_SCR_EMCRX1 = 0x41;
    	Enable_Int(EMCTXINT1);
    	Enable_Int(EMCRXINT1);  
#ifdef WINBOND_NATA

	NATA_Start();
#endif		  	    	
    } 
    
    /* Configure the MAC control registers. */
    	w740_WriteReg(MIEN,gMIEN,which);
    	w740_WriteReg(MCMDR,w740_ReadReg(MCMDR,which)|gMCMDR,which);
	{
		unsigned long val=w740_ReadReg(MCMDR,which);
		w740_WriteReg(MCMDR,val|MCMDR_RXON,which);
	}
	priv->mcmdr=w740_ReadReg(MCMDR,which);
   
	priv->bInit=1; 
	priv->rx_packets=0;
	priv->rx_bytes=0;	
	priv->rx_hang_time=jiffies;
	init_timer(&priv->timer);

#ifdef HACK

	init_timer(&priv->hack_timer);
	priv->hack_timer.data = (unsigned long) dev;
	priv->hack_timer.function = rx_hack_timeout;
	
#endif
	priv->timer.expires =jiffies+RX_TIMEOUT*HZ;
	priv->timer.data = (unsigned long) dev;
	priv->timer.function = w740_rx_timeout;	/* timer handler */
	add_timer(&priv->timer);
	priv->if_timer=1;
	priv->rx_int=jiffies;
	netif_start_queue(dev);
	
	return 0;
}
 

static int   w740_close(struct net_device *dev)
{
	struct w740_priv *priv=(struct w740_priv *)dev->priv;
	int which=priv->which;
	unsigned long int i=100*1000;
	priv->bInit=0; 
	
	priv->if_timer=0;
	while(i==0)i=i-1;
	del_timer(&priv->timer);
	netif_stop_queue(dev);
	//w740_WriteReg(MCMDR,0,which);
	free_irq(RX_INTERRUPT+which,dev);
	free_irq(TX_INTERRUPT+which,dev);	
	
	return 0;
}

/* Get the current statistics.	This may be called with the card open or
   closed. */
 
static struct net_device_stats * w740_get_stats(struct net_device *dev)    
{
	struct w740_priv *priv = (struct w740_priv *)dev->priv;
	
	return &priv->stats;
}

static void w740_tx_timeout(struct net_device *dev)
{
   struct w740_priv * priv=(struct w740_priv *)dev->priv;
//   unsigned int rxfsm=w740_ReadReg(RXFSM,priv->which);
   unsigned int status=w740_ReadReg(MISTA,priv->which);   //get  interrupt status;
//   unsigned int txfsm=w740_ReadReg(TXFSM,priv->which);
   int which=priv->which;
   unsigned long flags; 		

    TRACE_ERROR(" MAC %d w740_timeout MISTA %x\n",(int)priv->which,status);

    //printk("come  cbhuang %s   %s  %d  \n",__FILE__,__FUNCTION__,__LINE__);  
    Disable_MAC_Int(flags);
    
    ResetMAC(dev);	 
    priv->rx_hang_time=jiffies;
    priv->tx_entry=priv->tx_finish_entry;
    del_timer(&priv->timer);
    priv->timer.expires = jiffies +RX_TIMEOUT*HZ;
    add_timer(&priv->timer);
    netif_wake_queue(dev);
    
    Enable_MAC_Int(flags);
    
    w740_WriteReg(TSDR ,0,which);
    w740_WriteReg(RSDR ,0,which);
 
}

#ifdef HACK
static void rx_hack_timeout(unsigned long arg)
{
	struct net_device * dev =(struct net_device *)arg;
	struct w740_priv *  priv=(struct w740_priv *)dev->priv;
	
	del_timer(&priv->hack_timer);
	
	printk("D ");
	enable_irq(EMCRXINT0);
}
#endif

static void w740_rx_timeout(unsigned long arg)
{
    struct net_device * dev =(struct net_device *)arg;
    struct w740_priv *  priv=(struct w740_priv *)dev->priv;
    int which=priv->which;
    unsigned int rxfsm=w740_ReadReg(RXFSM,priv->which);
//    unsigned  long status=w740_ReadReg(MISTA,priv->which);
    unsigned long flags;
   
/******RX Hang Bug ver1   ******/
     
    if((rxfsm&0xFFFF0000)==0x08040000)	
	 if(priv->if_timer==0)return;
       
    if((priv->rx_hang_time+RX_TIMEOUT*HZ)<jiffies)
    {
	if((w740_ReadReg(RXFSM,priv->which)&0xFFFF0000)==0x08040000)	
   	{
	    	//printk("Rx hang !\n");
	        Disable_MAC_Int(flags);
	    	ResetMAC(dev);
	    	priv->rx_hang_time=jiffies;
	    	Enable_MAC_Int(flags);
	    	w740_WriteReg(TSDR ,0,which);
   		w740_WriteReg(RSDR ,0,which); 
	}	
    }
/********NCS Detect**********/
//2003-6-11 10:35

if(which==1){
  unsigned long RdValue;    
  int curr_ncs=1;

#ifdef RTL8201_PHY
  RdValue = MiiStationRead( RTL8201_STATUS_REG,RTL8201_ADDR);
#else
  RdValue = MiiStationRead(which, PHY_STATUS_REG, PHYAD,&succ);
#endif
  
  if(RdValue&0x4)
  	curr_ncs=0;
  	
  if((curr_ncs==0)&&(priv->mac_ncs==1))
  	priv->mac_ncs_change=1;
  priv->mac_ncs=curr_ncs;
  	
  if(priv->mac_ncs_change)
  {
	Disable_MAC_Int(flags);
        ResetPhyChip(which);
        priv->mac_ncs_change=0;
        priv->mac_ncs=0;	
	Enable_MAC_Int(flags);
	w740_WriteReg(TSDR ,0,which);
	w740_WriteReg(RSDR ,0,which);
  }//do change	
	
}//which

    priv->timer.expires = jiffies +RX_TIMEOUT*HZ;
    add_timer(&priv->timer);
    netif_wake_queue(dev);
 
}

static int w740_start_xmit(struct sk_buff *skb, struct net_device *dev)
{
  
    if((send_frame(dev,skb->data,skb->len))==0)    
    {
    	dev_kfree_skb(skb);
    	TRACE("w740_start_xmit ok\n");
    	return 0;
    }
    return -1;	
}

/* The typical workload of the driver:
   Handle the network interface interrupts. */

static void tx_interrupt(int irq, void *dev_id, struct pt_regs * regs)
{
    struct net_device *dev = (struct net_device *)dev_id;
    volatile struct w740_priv *priv = (struct w740_priv *)dev->priv;
    volatile unsigned long status,cur_ptr;  
    int which=priv->which;
    volatile TXBD  *txbd;
  
    status=w740_ReadReg(MISTA,which);   //get  interrupt status;
    w740_WriteReg(MISTA,status&0xFFFF0000,which);  //clear interrupt

    TRACE(" tx_interrupt irq %d MISTA %x \n",irq,(unsigned int)status);
       
    if (status & MISTA_TxBErr)
    {
    	TRACE_ERROR(" Tx MISTA_TxBErr\n");
    	netdev_rx(dev);    //start doing
    	ResetMAC(dev);
    	return;
    }
   
    cur_ptr=w740_ReadReg(CTXDSA,which);
    TRACE("priv->tx_ptr %x  cur_ptr =%x\n",(unsigned int)priv->tx_ptr,(unsigned int)w740_ReadReg(CTXDSA,which));
    if((priv->tx_entry - priv->tx_finish_entry)>=TX_DESC_SIZE)
	printk("tx_interrupt1: come  cbhuang %s   %s  %d  %ld  \n",__FILE__,__FUNCTION__,__LINE__,priv->tx_entry - priv->tx_finish_entry);
  
    while((priv->tx_entry-priv->tx_finish_entry)>1)
    {
    	txbd =(TXBD *)priv->tx_finish_ptr; 
 			
    	if(check_flag((unsigned long)txbd&NON_CACHE_FLAG))
    		printk("tx_interrupt2: come  cbhuang %s   %s  %d  \n",__FILE__,__FUNCTION__,__LINE__);

    	if (txbd->mode & TXfOwnership_DMA)
    	{
    		break;
    	} 

    	if(priv->tx_finish_ptr ==cur_ptr)
    	{
    		break;
    	}
    		   
	if(txbd->SL &TXDS_TXCP)
	{
	    	priv->stats.tx_packets++;
	    	
	}	
	else
	{
		priv->stats.tx_errors++;	
		if (txbd->mode & TXfOwnership_DMA	)
			printk("ERR!!!!!!!!!!!!!!!!\n");
		// TRACE_ERROR("tx interupt  error status %x MISTA %x  SL %x\n",(unsigned int)txbd->SL&0xFFFF0000,w740_ReadReg(MISTA,which),txbd->SL);
        }
        
       // if(((priv->tx_finish_entry+1)%10000)==0)
	// 	printk("*"); 
    	  	
        txbd->SL=0; 
        txbd->mode=0;
         /*Note cbhuang */
#ifdef WINBOND_NATA 
	txbd->buffer=txbd->org_buffer;//restore buffer address
#endif
       
	if (netif_queue_stopped(dev))	
	{	
		netif_wake_queue(dev);
	}
	priv->tx_finish_ptr=txbd->next;
	if(check_flag((unsigned long)priv->tx_finish_ptr&NON_CACHE_FLAG))
		THOUGH_HERE;
	/* Note cbhuang*/
		
	priv->tx_finish_entry++;
	w740_WriteReg(TSDR ,0,which);

	tx_queue_count++;
	
    }
	
	if(check_flag(priv->tx_entry - priv->tx_finish_entry)>0)
	{	
		printk("%ld   %ld\n",priv->tx_entry , priv->tx_finish_entry);
		THOUGH_HERE;
	}
	
	TRACE("After %d tx_interrupt status %x  \n",which,(unsigned int)status);
}

static void rx_interrupt(int irq, void *dev_id, struct pt_regs * regs)
{
	
    struct net_device *dev = (struct net_device *)dev_id;
    struct w740_priv  *priv = (struct w740_priv *) dev->priv;
    unsigned long status;
    int which=priv->which;
    static unsigned long tmp1=0,oldtime=0;
	
    priv->rx_hang_time=jiffies;
    status=w740_ReadReg(MISTA,which);   //get  interrupt status;    
    w740_WriteReg(MISTA,status&0xFFFF,which); //clear interrupt
    TRACE("* %d rx_interrupt MISTA %x \n",irq,(unsigned int)status);
    
    if(status & (MISTA_RxBErr))
    	printk("MISTA_RxBErr %lx\n",status);
   
    priv->cur_rx_entry++;
    
    if(status & (MISTA_RxBErr))
    {
    	printk("come  cbhuang %s   %s  %d  \n",__FILE__,__FUNCTION__,__LINE__);
    	TRACE_ERROR("W90N740 MAC MISTA_RxBErr\n");
        netdev_rx(dev);    //start doing
        ResetMAC(dev);
        return ;
    }

    if((status & (MISTA_RDU)))
    {
    	TRACE("W90N740(* MAC I Have Not Any Descript Needed\n");
	netdev_rx(dev);    //start doing
	ResetMAC(dev);
	w740_WriteReg(MISTA,status&0xFFFF,which); //clear interrupt
	w740_WriteReg(RSDR,0,which);       
	return ;
    }
    
    
    if(status & (MISTA_RXOV))
    {
    	printk("NIC %d rx overflow   %lx\n",which,status);
	ResetMAC(dev);	//norton
 	// netdev_rx(dev);    //start doing
  	//ResetMAC(dev);
 	// w740_WriteReg(RSDR,0,which);
	//  return ;
    }

    netdev_rx(dev);
  
    w740_WriteReg(RSDR,0,which);
    
#ifdef HACK /* norton patch for NO TX if RX too fast ! */

    if( which == LAN )
    {
    	tmp1++;
    	//tx_queue_count++;	//how many packets are waiting for tx 
	if( (jiffies-oldtime)>1*HZ ) 
	{
		/* RX3141 can forward packet when RX rate <20000 pps */
		if( tmp1 > 5000 && tx_queue_count < 20 )
		{
 			priv->hack_timer.expires =jiffies+1;
			disable_irq(EMCRXINT0);	//let CPU have time to process received packet ?
			add_timer(&priv->hack_timer); //enable RX IRQ
		}
		tmp1 = 0;
		tx_queue_count = 0;
		oldtime = jiffies;
	}
    }
#else /* winbond patch for NO TX if RX too fast ! */

    if(which==0)
    {
    	if(tmp1==0)
    	{
    		oldtime=jiffies;
    	}
    	
    	tmp1++;
    	
    	if(tmp1>10000 )
    	{
    		tmp1=0;
    		if((jiffies-oldtime)<=(1*HZ))
    		{
    			priv->hack_timer.expires =jiffies+1;
			disable_irq(EMCRXINT0);	//let CPU have time to process received packet ?
			add_timer(&priv->hack_timer); //enable RX IRQ
    		}
    	}

    }
#endif

    TRACE("After %d *rx_interrupt status %x  \n",which,(unsigned int)status);
}

void ResetMAC(struct net_device * dev)
{
	
	struct w740_priv * priv=(struct w740_priv *)dev->priv;
  	int    which=priv->which ;

	//printk("come  cbhuang %s   %s  %d  \n",__FILE__,__FUNCTION__,__LINE__);
	//printk("+");
	
	w740_WriteReg(FIFOTHD,0x10100,which); 
	w740_WriteReg(FIFOTHD,w740_ReadReg(FIFOTHD,which)|FIFOTHD_Blength|FIFOTHD_TxBurst,which);//12-05
   
	init_rxtx_rings(dev);
  	priv->rx_ptr=priv->start_rx_ptr ;
  	priv->tx_ptr=priv->start_tx_ptr ;
  	
  	//11-21
  	priv->tx_finish_ptr=priv->tx_ptr;
    
  	w740_WriteReg(RXDLSA,priv->start_rx_ptr,which);
  	w740_WriteReg(TXDLSA,priv->start_tx_ptr,which);
  	w740_WriteReg(DMARFC,PACKET_SIZE,which);
  	
  	w740_WriteCam(priv->which,0,dev->dev_addr);
	w740_WriteReg(CAMEN,w740_ReadReg(CAMEN,priv->which) | 1,priv->which);    
  	w740_WriteReg(CAMCMR,CAMCMR_ECMP|CAMCMR_ABP|CAMCMR_AMP,which);
   
    	/* Configure the MAC control registers. */
        w740_WriteReg(MIEN,gMIEN,which);    	
	w740_WriteReg(MCMDR,priv->mcmdr,priv->which);
	priv->rx_hang_time=jiffies;  
    	
	{
    		unsigned long val=w740_ReadReg(MCMDR,which);
    		w740_WriteReg(MCMDR,MCMDR_RXON|val,which);
	}
    
}
/* We have a good packet(s), get it/them out of the buffers. */
static void   netdev_rx(struct net_device *dev)
{
	struct w740_priv * priv = (struct w740_priv *)dev->priv;
	volatile RXBD *rxbd;
	volatile RXBD *rxbd1;
	
	unsigned long length;
	unsigned long status;
	int loop =0;
	
	
	rxbd=(RXBD *)priv->rx_ptr ;
	if(check_flag((unsigned long)rxbd&NON_CACHE_FLAG))
		THOUGH_HERE; 
		
    do
    {
    	if(++loop==(RX_DESC_SIZE-2))
    		break;
    	
    	//if(((priv->stats.rx_packets++)%10000)==0)
		//	printk(".");
	priv->stats.rx_packets++ ;

	if (rxbd->SL & RXfOwnership_DMA)
		break;
	if(rxbd->SL & RXfOwnership_NAT)
		printk("NAT  %s   %s  %d  \n",__FILE__,__FUNCTION__,__LINE__);
				
	if(!(rxbd->SL&RXfOwnership_CPU))
		break;

	if((w740_ReadReg(CRXDSA,priv->which)==(unsigned long)rxbd))
    	{
    	   	rxbd1=(RXBD *)rxbd->next;
    	   	if( rxbd1->SL&RXfOwnership_DMA)
    	   	{
    	   		printk("ERRRRRR!!! %s   %s  %d  \n",__FILE__,__FUNCTION__,__LINE__);	
    	   	}
    	   	else
    	   		break;
    	}
     	
    	length = rxbd->SL & 0xFFFF;
    	status = (rxbd->SL & 0x3FFF0000);
    	
	if(status & RXDS_RXGD)
	{
		unsigned char  * data;
		struct sk_buff * skb;
		int nata = 0;
		
#ifdef WINBOND_NATA
		if(status & (RXDS_NATFSH|RXDS_Hit))
		{
			if(check_flag((unsigned int)rxbd&NON_CACHE_FLAG))
				THOUGH_HERE;			 		
				
			nata = do_nata(dev,(RXBD *)rxbd);
			
			if( nata == 0 )
				goto DONE;
				
			else if( nata == -1 )
			{
				rxbd->SL =RXfOwnership_DMA;		
				rxbd->info = 0;

				priv->rx_ptr=(unsigned long)rxbd->next;
				rxbd=(RXBD *)priv->rx_ptr;	
				if(check_flag((unsigned long)rxbd&NON_CACHE_FLAG))
					THOUGH_HERE; 	
				dev->last_rx = jiffies;
				w740_WriteReg(RSDR,0,priv->which);
					break;
			}
			/* else ... incorrect matched, pass it to upper layer */
			printk("\nRXDB match but pass to upper layer");
		}
#endif	 

		data = (unsigned char *) rxbd->buffer;
		
		skb = dev_alloc_skb(length+2);  //Get Skb Buffer;
		if(!skb) {
			TRACE_ERROR("W90N740: I Have Not Got Memory In Fun %s\n",__FUNCTION__);
			priv->stats.rx_dropped++;
			return;
		}

		skb->dev = dev;
		skb_reserve(skb, 2);   //For IP Align 4-byte
		skb_put(skb, length);
		eth_copy_and_sum(skb, data, length, 0);  //copy
		skb->protocol = eth_type_trans(skb, dev); 
		priv->stats.rx_packets++;
		priv->stats.rx_bytes += length;
		netif_rx(skb);    // Enqueue for Up Layer
		TRACE("dev->last_rx ;\n");
		
	}
	else
	{		
		TRACE_ERROR("Rx error status %x \n",(unsigned int)status);
		priv->stats.rx_errors++;
		if(status & RXDS_RP )
		{
			TRACE_ERROR("W90N740 MAC: Receive Runt Packet Drop it!\n");
			priv->stats.rx_length_errors++;
		}
		if(status & RXDS_CRCE )
		{
			TRACE_ERROR("W90N740 MAC Receive CRC  Packet Drop It! \n");
			priv->stats.rx_crc_errors ++;
		}
		if(status & RXDS_ALIE )
		{ 
			TRACE_ERROR("W90N740 MAC Receive Aligment Packet Dropt It!\n");
			priv->stats.rx_frame_errors++;
		}			
		if(status &  RXDS_PTLE)
		{
			TRACE_ERROR("W90N740 MAC Receive Too Long  Packet Dropt It!\n");
			priv->stats.rx_over_errors++;
		}
	}
DONE:
	rxbd->SL =RXfOwnership_DMA;		
	rxbd->info = 0;

	priv->rx_ptr=(unsigned long)rxbd->next;
	rxbd=(RXBD *)priv->rx_ptr;	
	if(check_flag((unsigned long)rxbd&NON_CACHE_FLAG))
		THOUGH_HERE; 	
	dev->last_rx = jiffies;
	w740_WriteReg(RSDR,0,priv->which);
    }while(1);
}

static void w740_set_multicast_list(struct net_device *dev)
{
	
	struct w740_priv *priv = (struct w740_priv *)dev->priv;		 			 
	unsigned long rx_mode;	
	int which=priv->which;
//	char buf[4];
	
//	atomic_read(which);
	 
	if(dev->flags&IFF_PROMISC)
	{
		rx_mode = CAMCMR_AUP|CAMCMR_AMP|CAMCMR_ABP|CAMCMR_ECMP;
		TRACE("W90N740 : Set Prommisc Flag \n");
		
	}
	else if((dev->flags&IFF_ALLMULTI)||dev->mc_list)
	{		
			rx_mode=CAMCMR_AMP|CAMCMR_ABP|CAMCMR_ECMP;
	} 
	else 
	{
		     rx_mode = CAMCMR_ECMP|CAMCMR_ABP;
		     TRACE("W90N740 :Set Compare Flag\n");
	}
	priv->rx_mode=rx_mode;
	w740_WriteReg(CAMCMR,rx_mode,which);
	
}
#define SIODEVSTARTNATA 0x6677
#define SIODEVSTARTNATA 0x6688

static int w740_do_ioctl(struct net_device *dev,struct ifreq *ifr,int cmd)
{
	struct w740_priv *priv=dev->priv;
	int which = priv->which;
	
	printk("W90N740 IOCTL:\n");	
	switch(cmd)
	{
#if 0		
		case  SIOCSIFHWADDR:
			if(dev->flags&IFF_PROMISC)
				return -1;
				
			memcpy(dev->dev_addr,&ifr->ifr_hwaddr,ETH_ALEN);
			printk("\nSet MaC Address  ^ %u:%u:%u:%u:%u:%u\n",\
			
			
			if(which)
				memcpy(w740_mac_address1,dev->dev_addr,ETH_ALEN);
    			else
    				memcpy(w740_mac_address0,dev->dev_addr,ETH_ALEN);
    		    
			w740_set_mac_address(dev,dev->dev_addr);  
			
			break; 
#endif
			//#define SIOCDEVPRIVATE	0x89F0	/* to 89FF */
			//linux/sockios.h   16;
			#define SIOCW740MACDEGUG SIOCDEVPRIVATE+1
		
		case  SIOCW740MACDEGUG :  //For Debug;
			  output_register_context(which);
			  break;	

		default:
			return -EOPNOTSUPP;
	}
	
	return 0;
}

void output_register_context(unsigned int which)
{
	printk("		** W90N740 EMC Register %d **\n",which);
 #if 0	
 	printk("MCMDR: %x ",w740_ReadReg(MCMDR,which));
 	printk("MISTA: %x ",w740_ReadReg(MISTA,which)); 	
 	printk("CRXDSA:%x ", w740_ReadReg(CRXDSA,which));
 	printk("CTXDSA:%x \n",w740_ReadReg(CTXDSA,which)); 
 #endif
}

#ifdef WINBOND_NATA 
extern struct _NATA_Table NATA_Table;
extern void NAT_Entry_Disable(int);
NATA_ENTRY * get_entry(int which, RXBD* rxbd)
{
	int num=(rxbd->info&0x3F00)>>8;	
	
	if(NATA_Table.table[num].lsad == 0 
		|| NATA_Table.table[num].lsad == 0 )
	{
		printk("\ndisabled entry but match!\n");
	}

	if(NATA_Table.table[num].ct!=0)
	{
#define NO_NATA_ENTRY_MATCH_PKT	1

#ifndef NO_NATA_ENTRY_MATCH_PKT
		NATA_ENTRY *pEntry=NULL;
		struct iphdr *iph=NULL;
		struct tcphdr *th=NULL;

		pEntry = &NATA_Table.table[num];
		/* if(outbound) rsad == dstip 
		    else if( inbound) rsad == srcip 
		    */
		if( which ==  WAN )//from wan
		{
			if( iph->saddr != pEntry->rsad )
			{
				printk("WAN: iph->saddr=%u.%u.%u.%u , pEntry->rsad=%u.%u.%u.%u \n",
					NIPQUAD(iph->saddr), NIPQUAD(pEntry->rsad));
				return NULL;
			}
			th = (struct tcphdr *)iph + iph->ihl;
			if( th->source != pEntry->rspn )
			{
				printk("th->source=%u pEntry->rspn=%u\n", th->source, pEntry->rspn );
				return NULL;
			}
		}
		else
		{
			if( iph->daddr != pEntry->rsad )
			{
				printk("LAN: iph->daddr=%u.%u.%u.%u , pEntry->rsad=%u.%u.%u.%u \n",
					NIPQUAD(iph->daddr), NIPQUAD(pEntry->rsad));
				return NULL;
			}
			th = (struct tcphdr *)iph + iph->ihl;
			if( th->dest != pEntry->rspn )
			{
				printk("th->dest=%u pEntry->rspn=%u\n", th->dest, pEntry->rspn );
				return NULL;
			}

		}
#endif
		return &NATA_Table.table[num];
	}
	printk("NATCFG %lx\n ",*(unsigned long*)(0xfff00000+0x6100+num*4));

	disable_entry(num);

	return &NATA_Table.table[num];
}

//lsshi add 2003-7-2 17:24

unsigned int pppoe_send_time=0;
unsigned int pppoe_recv_time=0;

///
//fastpath implementation
int   do_nata(struct net_device *dev,RXBD * rxbd )
{
	
	struct w740_priv *priv=(struct w740_priv *)dev->priv;
	int  length=rxbd->SL&0xFFFF;
	int which=priv->which;
	unsigned char * buffer=NULL;
	unsigned char * org_buffer=NULL;
	unsigned char  most = 0 ,least = 0;
	struct net_device * which_dev=NULL;
	char  *data = NULL;
	TXBD  *txbd;
	int index = 0xff;
	
	NATA_ENTRY * entry=get_entry(which, rxbd);
  
	if(entry==NULL)
	{
		TRACE_ERROR("get entry failed entry info %x \n",(unsigned int)rxbd->info);
		return -1;
	}
#ifdef ACCELERATE_SESSION1_ONLY

#else
	if(NATA_Table.start_pppoe)
	{
		index = entry->session;
		if( index <  0 || index > PPPOE_MAX_SESSION )
		{
			printk("do_nata: incorrect session\n");
			return -1;
		}
	}
#endif

	org_buffer=(unsigned char *)rxbd->buffer;	
	if(which==LAN)
	{	
		buffer=(unsigned char*)rxbd->buffer;

#ifdef ACCELERATE_SESSION1_ONLY
		if(NATA_Table.start_pppoe)
			buffer = (unsigned char *)(rxbd->buffer-PPPOE_HEADER_LEN);
		memcpy(buffer,entry->RsMAC,MAC_LEN); //copy destination
		memcpy(buffer+MAC_LEN,&w740_mac_address1,MAC_LEN);//copy  source
#endif
		
		if(NATA_Table.start_pppoe && *(buffer+12) == 0x08 && *(buffer+13) == 0x00 ) /* only process IP packet */
		{
			buffer = (unsigned char *)(rxbd->buffer-PPPOE_HEADER_LEN);
			
			pppoe_send_time=jiffies; //lsshi add 2003-7-2 17:24
			
#ifdef ACCELERATE_SESSION1_ONLY
			memcpy(buffer,NATA_Table.PPPoE_rmmac,6);
			*(buffer+12)=0x88;
			*(buffer+13)=0x64;
			*(buffer+14)=0x11;
			*(buffer+15)=0x00;
			
			most=NATA_Table.PPPoE_SessionID>>8;
			least=NATA_Table.PPPoE_SessionID&0xFF;
			*(buffer+16)= most;
			*(buffer+17)= least;
				
			most=(length-12)>>8;
			least=(length-12) & 0xff;
			*(buffer+18)=most;
			*(buffer+19)=least;
			
			NATA_Table.PPPoE_PPP_Protocol=0x0021;	
			most=NATA_Table.PPPoE_PPP_Protocol >> 8;
			least=NATA_Table.PPPoE_PPP_Protocol & 0xFF;
						
			*(buffer+20)=most;
			*(buffer+21)=least;
			rxbd->SL&=0xFFFF0000;
			rxbd->SL|=length+PPPOE_HEADER_LEN;
			length=length+PPPOE_HEADER_LEN;
#else
			
			/*
			printk("peer rmac=%02x:%02x:%02x:%02x:%02x:%02x\n",
				NATA_Table.PPPoE_rmmac[index][0],
				NATA_Table.PPPoE_rmmac[index][1],
				NATA_Table.PPPoE_rmmac[index][2],
				NATA_Table.PPPoE_rmmac[index][3],
				NATA_Table.PPPoE_rmmac[index][4],
				NATA_Table.PPPoE_rmmac[index][5] );
			*/
			memcpy(buffer, NATA_Table.PPPoE_rmmac[index], 6);
			memcpy(buffer+MAC_LEN, w740_mac_address1, MAC_LEN);//copy  source
			
			*(buffer+12)=0x88;
			*(buffer+13)=0x64;
			*(buffer+14)=0x11;
			*(buffer+15)=0x00;
			
			most = NATA_Table.PPPoE_SessionID[index] >> 8;
			least=NATA_Table.PPPoE_SessionID[index] & 0xFF;
			*(buffer+16)= most;
			*(buffer+17)= least;
				
			most=(length-12)>>8;
			least=(length-12) & 0xff;
			*(buffer+18)=most;
			*(buffer+19)=least;
			
			NATA_Table.PPPoE_PPP_Protocol=0x0021;	
			most=NATA_Table.PPPoE_PPP_Protocol >> 8;
			least=NATA_Table.PPPoE_PPP_Protocol & 0xFF;
						
			*(buffer+20)=most;
			*(buffer+21)=least;
			rxbd->SL&=0xFFFF0000;
			rxbd->SL|=length+PPPOE_HEADER_LEN;
			length=length+PPPOE_HEADER_LEN;

#endif
 		}

#ifdef ACCELERATE_SESSION1_ONLY

#else
 		else
 		{
			memcpy(buffer,entry->RsMAC,MAC_LEN); //copy destination
			memcpy(buffer+MAC_LEN, w740_mac_address1, MAC_LEN);//copy  source
 		}
#endif
		rxbd->buffer=(unsigned char*)buffer;
		which_dev=&w740_netdevice[WAN];//cbhuang 2003-1-9 9:27		
	}
	else //wan
	{	
		buffer=(unsigned char *)rxbd->buffer;
		if(NATA_Table.start_pppoe&&(rxbd->info&NATI_PPPoE) && *(buffer+12) == 0x88 && *(buffer+13) == 0x64 )
		{
			buffer = (unsigned char *)(rxbd->buffer+PPPOE_HEADER_LEN);
			pppoe_recv_time=jiffies;	//lsshi add 2003-7-2 17:24
			
			*(buffer+12)=0x08;
			*(buffer+13)=0x00;
			rxbd->SL&=0xFFFF0000;
			rxbd->SL|=(length-PPPOE_HEADER_LEN);
			length=length-PPPOE_HEADER_LEN;
		}
		memcpy(buffer,entry->LocMAC,MAC_LEN); //copy destination
		memcpy(buffer+MAC_LEN,&w740_mac_address0,MAC_LEN);//copy  source

		if( entry->ct)
		{
			if( NATA_Table.table[entry->index].proto == NATA_UDP )
			{
				entry->ct->status = IPS_ASSURED_BIT;
			}
		}

		rxbd->buffer=(unsigned char *)buffer;
		which_dev=&w740_netdevice[LAN];

	}
	 
	entry->time=jiffies;	/* refresh last match time */
	//if(entry->ct) ip_ct_refresh(entry->ct) ;  /* this may cause high overhead */

	if(rxbd->info&NATI_TCP_RST){
		//printk("rst ");
		if( entry->tcp_times > 0 )
			ip_ct_refresh(entry->ct, IPT_TCP_RST_TIMEOUT*HZ ); /* norton */
		entry->tcp_times=0;
	}
	 
	if(rxbd->info&NATI_TCP_FIN){
	 	//printk("fin\n");
	 	if(NATA_Table.table[entry->index].ct!=0)
	 	{
			if((entry->tcp_times)>0)
			   entry->tcp_times--;

			if( entry->tcp_times > 0 )
				ip_ct_refresh(entry->ct, IPT_TCP_CLOSE_TIMEOUT*HZ ); /* norton */
		}
	    
	    	if(rxbd->info&NATI_TCP_SYN){
	    	
	 		printk("RST: NATI_TCP_SYN\n");
	 	
	 		if(NATA_Table.table[entry->index].ct!=0)
	 		{
				entry->tcp_times=2;
				//if((entry->tcp_times)>0)	/* norton */
				//	entry->tcp_times--;
			}
		}
	    
	    //else
	    //	printk("(*: %d come  cbhuang %s   %s  %d  \n",entry->tcp_times,__FILE__,__FUNCTION__,__LINE__);
	    	
	}
	
	#ifdef NON_ALIGN_BUG
	
		priv=(struct w740_priv *)which_dev->priv;
		data=(char *)rxbd->buffer;
		if(check_flag((unsigned int)rxbd->buffer&NON_CACHE_FLAG))
			THOUGH_HERE;
		if(check_flag((unsigned int)data&NON_CACHE_FLAG))
			THOUGH_HERE;
		
		length=rxbd->SL&0xFFFF;
		//txbd->buffer=rxbd->buffer; //change
	
	#if 1
		while(1)
		{
			priv->tx_try++;
			if((txbd=get_txbd(which_dev))!=(TXBD *)-1)
			{	
			    priv->tx_try=0;
			    break;			    
			}

			 if(priv->tx_try>50) //if(priv->tx_try>50)
			{
			 	priv->tx_try=0;
			 	//printk("!:!\n");
			 	rxbd->buffer=org_buffer; //lsshi add 2004-10-13 16:32
			 	return -1;
			}	
		}
	#else

		if((txbd=get_txbd(which_dev))==(TXBD *)-1)
		{	
			   return -1;
		}
	#endif
			
		if(txbd==(TXBD *)-1)
		{
			THOUGH_HERE;
		}		
		rxbd->buffer=txbd->buffer; //exchange buffer
		txbd->buffer=data;
		txbd->org_buffer=org_buffer;//restore buffer address	 
		send_txbd(which_dev,txbd,data,length,1);

	#else	
		if(send_frame(which_dev,(unsigned char * ) rxbd->buffer,length)==0)
			return -1;
	#endif	
	
	return 0;
}
#endif

static TXBD * get_txbd(struct net_device *dev )
{
    struct w740_priv * priv= ( struct w740_priv *)dev->priv; 
    int which;
    volatile TXBD *txbd;
    which=priv->which;
   
    txbd=( TXBD *)priv->tx_ptr;    
   
#if 0   
    if(++priv->tx_stop==100) 
    {
    	unsigned long status;
    	w740_WriteReg(TSDR ,0,which);
    	status=w740_ReadReg(MISTA,which);
    	if(status&MISTA_TDU){
    		priv->tx_stop=0;
    		netif_wake_queue(dev);
    		if(priv->tx_ptr!=w740_ReadReg(CTXDSA,which))
    		{
    			printk("error!!!\n");	
    			ResetMAC(dev);
        		w740_WriteReg(RSDR,0,which);
    		}
    	}	
    	
    }
#endif
    
    if((priv->tx_entry-priv->tx_finish_entry)>=(TX_DESC_SIZE-3))
    {
    	netif_stop_queue(dev);
    	//w740_WriteReg(MCMDR,w740_ReadReg(MCMDR,which) | MCMDR_TXON, which);
    	w740_WriteReg(TSDR ,0,which);
    	return (TXBD *) -1;    	
    }	
    	
    if((txbd->mode & TXfOwnership_DMA)) //tx descriptor full
    {    
    	//netif_stop_queue(dev);    	
    	//w740_WriteReg(MCMDR,w740_ReadReg(MCMDR,which) | MCMDR_TXON, which);
    	w740_WriteReg(TSDR ,0,which);
    	return (TXBD *) -1;    	
    }
    
    	
#if 0    
    if(priv->tx_finish_ptr==(unsigned long)txbd->next )//tx full
       	netif_stop_queue(dev); 
#endif
     if(check_flag((unsigned long)txbd->buffer&NON_CACHE_FLAG))
     {
     	THOUGH_HERE;
     }	
     
     
     return (TXBD *)txbd;  	
}

static void send_txbd(struct net_device * dev,TXBD* txbd,unsigned char *data,int length,int bCopy)
{
    volatile struct w740_priv * priv= ( struct w740_priv *)dev->priv;    
    int which=priv->which; 

    data=(unsigned char*)((unsigned long)data|NON_CACHE_FLAG);
    txbd->buffer=(unsigned char*)((unsigned long)(txbd->buffer)|NON_CACHE_FLAG);
    if(check_flag((unsigned long)txbd&NON_CACHE_FLAG))
    	THOUGH_HERE;;

    if(check_flag((unsigned long)&txbd->mode&NON_CACHE_FLAG))
    {
    	if(check_flag((unsigned long)txbd->buffer&NON_CACHE_FLAG))
    	{
		THOUGH_HERE;;	
		printk("txbd buffer %x data %x length %d \n",txbd->buffer,data,length);

    		return;
    	}
    }
	
    txbd->mode=(PaddingMode | CRCMode | MACTxIntEn);      
    if(length>1514) 
    {
    	TRACE(" Send Data %d Bytes ,Please  Recheck Again\n",length);
    	length=1514;
    }    
    txbd->SL=length&0xFFFF;
	
#ifdef WINBOND_NATA
	#ifdef NON_ALIGN_BUG
		if(bCopy)
			txbd->buffer=(unsigned char *)data;
		else
			memcpy((void *)txbd->buffer,data,length);
	#else
		 memcpy((void *)txbd->buffer,data,length);
	#endif
#else		
	memcpy((void *)txbd->buffer,data,length);    
#endif
	txbd->mode|= TXfOwnership_DMA;

	
    TRACE("TX use %d \n",(unsigned int)(priv->tx_ptr-priv->tx_finish_ptr)/16);
    priv->tx_entry++;
    txbd=(TXBD *)txbd->next;	 	
    priv->tx_ptr=(unsigned long )txbd; 
    
    if(check_flag((unsigned long)priv->tx_ptr&NON_CACHE_FLAG))
    	THOUGH_HERE;;  

#if 1   
    if((txbd->mode & TXfOwnership_DMA)||priv->tx_ptr==priv->tx_finish_ptr)
    {
    	netif_stop_queue(dev);
    }
#endif
  
    //if(!w740_ReadReg(MCMDR,which)&MCMDR_TXON)
    w740_WriteReg(MCMDR,w740_ReadReg(MCMDR,which) | MCMDR_TXON, which);
    w740_WriteReg(TSDR ,0,which);
    dev->trans_start = jiffies;
    
}
	
int send_frame(struct net_device *dev ,unsigned char *data,int length)
{
   
   volatile struct w740_priv * priv= ( struct w740_priv *)dev->priv;    
   int which=priv->which; 
   TXBD *txbd;
   unsigned long flags;
   Disable_MAC_Int(flags);
   
   if((txbd=get_txbd(dev))==(TXBD *)-1)
   {
	Enable_MAC_Int(flags);
	return -1;
   }	
   
   send_txbd(dev,txbd,data,length,0);
	
   Enable_MAC_Int(flags);
	
   w740_WriteReg(TSDR ,0,which);
   w740_WriteReg(RSDR ,0,which);
 
   return 0;
}


static int w740_init(struct net_device *dev)
{
	static int which1=0;
	struct w740_priv *priv;
	
	ether_setup(dev);
	dev->open=w740_open;
	dev->stop=w740_close;
	dev->do_ioctl=w740_do_ioctl;
	dev->hard_start_xmit=w740_start_xmit;
	dev->tx_timeout=w740_tx_timeout;
	dev->get_stats=w740_get_stats;
	
	dev->watchdog_timeo =TX_TIMEOUT*HZ;
	dev->irq=13+which1;
	dev->set_multicast_list=w740_set_multicast_list;
	dev->set_mac_address=w740_set_mac_address;
	dev->priv = kmalloc(sizeof(struct w740_priv),GFP_KERNEL);
#ifdef IC_PLUS	
	memcpy(w740_mac_address0,MAC0_FLASH_ADDR,ETH_ALEN);
	memcpy(w740_mac_address1,MAC1_FLASH_ADDR,ETH_ALEN);
#endif

#ifdef RTL8201_PHY

	memcpy(w740_mac_address0,MAC0_FLASH_ADDR,ETH_ALEN);
	memcpy(w740_mac_address1,MAC1_FLASH_ADDR,ETH_ALEN);
#endif	
	
	
	if(dev->priv == NULL)
		return -ENOMEM;
	memset(dev->priv, 0, sizeof(struct w740_priv));
	
	if(which1)
		memcpy(dev->dev_addr,w740_mac_address1,ETH_ALEN);
	else
    		memcpy(dev->dev_addr,w740_mac_address0,ETH_ALEN);

	priv=(struct w740_priv *)dev->priv;
	priv->which=which1;
       
	TRACE("%s initial ok!\n",dev->name);	   	
	which1=1;
	return 0;
	
}

int  init_module(void)
{
	int ret;
	memset( w740_netdevice[0].name ,0 ,IFNAMSIZ);
	ret=register_netdev(&w740_netdevice[0]);
	if(ret!=0)
	{
		TRACE_ERROR("Regiter EMC 0 W90N740 FAILED\n");
		return  -ENODEV;
	}
	
	memset( w740_netdevice[1].name ,0 ,IFNAMSIZ);
	ret=register_netdev(&w740_netdevice[1]);
	if(ret!=0)
	{
		TRACE_ERROR("Regiter EMC 1 W90N740 FAILED\n");
		return  -ENODEV;
	}
	
	printk("Regiter EMC 1 W90N740 ok\n");
	return 0;
}

void cleanup_module(void)
{        
	unregister_netdev(&w740_netdevice[0]);
	unregister_netdev(&w740_netdevice[1]);
}

module_init(init_module);
module_exit(cleanup_module);
