//2003-1-2 16:11
#include <linux/config.h>
#include <linux/module.h> 
#include <linux/init.h>
#include <linux/sched.h>
#include <linux/kernel.h>      
#include <linux/slab.h>		 
#include <linux/errno.h>
#include <linux/types.h>
#include <linux/interrupt.h>

#include <linux/in.h>
#include <linux/netdevice.h>
#include <linux/etherdevice.h>
#include <linux/ip.h>
#include <linux/tcp.h>
#include <linux/skbuff.h>
#include <net/neighbour.h>
#include <net/dst.h>
#include <net/sock.h>
#include <asm/irq.h>

#include "w740mac.h"
#include "w740nat.h"
#include  "natlib.h"

#include <net/route.h>

//lsshi add 2003-6-23 10:00
#if 0
#define DEBUGP printk
#else
#define DEBUGP(format, args...)
#endif

typedef struct _UPnP_CT
{
	unsigned short Proto;
	unsigned int ExtIP;
	unsigned short ExtPort;
	
}UPnP_CT;

#include <linux/netfilter_ipv4/ip_conntrack.h>

extern void ip_ct_refresh(struct ip_conntrack *ct, unsigned long extra_jiffies);
extern void ip_ct_refresh_close(struct ip_conntrack *ct, unsigned long extra_jiffies);
extern int is_ip_conntrack_closing(struct ip_conntrack *ct);

extern atomic_t ip_conntrack_count;
/////

/*
ioctl 0x8968  SIOCGNATA
ioctl 0x8969  SIOCSNATA
*/
int debug_i;
#define NATA_ENTRY_EMPTY   0xFFFF
#define NATA_ENTRY_MAX	   64
#define MONTH (HZ*3600*24*30)

#if 0
#define  Disable_MAC_Int \
		Disable_Int(EMCTXINT0);\
    	Disable_Int(EMCRXINT1);\
    	Disable_Int(EMCRXINT0);\
     	Disable_Int(EMCTXINT1);
#define Enable_MAC_Int \
		Enable_Int(EMCTXINT0);\
    	Enable_Int(EMCRXINT1);\
    	Enable_Int(EMCRXINT0);\
     	Enable_Int(EMCTXINT1);
#else
#define Disable_MAC_Int(x)   local_irq_save(x) 
#define Enable_MAC_Int(x)   local_irq_restore(x)

#endif     	
     	

struct _NATA_Table  NATA_Table;

//#define DEBUG
#ifdef	DEBUG
	#define TRACE(str, args...)	printk("W90N740 ETH: " str, ## args)
#else
	#define TRACE(str, args...)
#endif

/*-- norton */
extern int duplex_mode;

/* norton-- */


/* w740mac MAC from w740mac.c */
extern char w740_mac_address0[];
extern char w740_mac_address1[];
extern struct  net_device w740_netdevice[2];
extern int ip_ct_sudden_death(struct ip_conntrack *ct);				

void disable_entry(int i);
int Is_NATA_Table_Start(void);
int Is_NATA_Table_PPPoE(void);
static void NATA_Entry_Timeout(unsigned long arg);
#define printf printk

static void dump_ip(unsigned long ip)
{
#if 0 //lsshi del 2003-6-9 11:04
    unsigned char ipn[4];  
    ipn[0]=(unsigned char)(ip&0xFF);
    ipn[1]=(unsigned char)((ip>>8)&0xFF);
    ipn[2]=(unsigned char)((ip>>16)&0xFF);
    ipn[3]=(unsigned char)((ip>>24)&0xFF);
    printk(" %d.%d.%d.%d ",ipn[0],ipn[1],ipn[2],ipn[3]);
#endif
}
/******************
*Initialize  Nata Table and Nata hardware entry when begining
******************/

static void NATA_Table_Init( void * table){
	struct _NATA_Table *pTable = (struct _NATA_Table *)table;
	int i=0;	
	pTable->valid = 0; 	
	pTable->size= NATA_ENTRY_MAX; //64			
	memset(&pTable->table,0,sizeof(NATA_ENTRY)*64);
	
	//initialize table entry list;
	for(i=0;i<NATA_ENTRY_MAX;i++){		
		pTable->table[i].index=i;
		pTable->table[i].ct=0;
		//pTable->table[i].flag=NATA_ENTRY_FLAG_EMPTY;
		pTable->table[i].tcp_times=0;
		pTable->table[i].proto=0;
	}		
}

int NATA_Stop ()
{
	NAT_Disable();
	NATA_Table.valid =0;
	del_timer(&NATA_Table.timer);

	return 0;
}

int NATA_Start()
{
	int i;

	//NATA_ENTRY *pEntry=NULL;
	NATA_Table.valid = 1; 
	
	memcpy(NATA_Table.Lanmac,w740_mac_address0,ETH_ALEN);
	memcpy(NATA_Table.Wanmac,w740_mac_address1,ETH_ALEN);
	
	NAT_Enable();
	NAT_HitCount_ClearAll();
	NAT_ProcCount_ClearAll();
	NAT_HitCount_ClearAll();
	NAT_ProcCount_ClearAll();
	NAT_Entry_ClearAll();
	NAT_EXMAC_Config(&NATA_Table.Wanmac[0]);
	NAT_INMAC_Config(&NATA_Table.Lanmac[0]);

	for(i=0;i<64;i++)
	{
//		if(NATA_Table.table[i].flag==NATA_ENTRY_FLAG_HEAD)
			NATA_Table.table[i].time=jiffies;
	
	}
	add_timer(&NATA_Table.timer);

	return 0;
}

int NATA_Reset(struct _NATA_Table *pTable)
{
	NATA_Stop();
	NATA_Start();

	return 0;
}

int NATA_SetMAC( int index, const char *mac)
{
	printf("mac=%02X:%02X:%02X:%02X:%02X:%02X\n",
		mac[0], mac[1], mac[2], mac[3], mac[4], mac[5] );
		
	if( index == 0 )
	{
		//memcpy(MAC0_FLASH_ADDR,mac, MAC_LEN);
	}
	else if( index == 1 )
	{
		//memcpy(MAC1_FLASH_ADDR,mac, MAC_LEN);
	}
	else return -1;

	return 0;
}

/* -- norton */
int NATA_SetDuplex( int mode )
{
	duplex_mode = mode;
	ResetPhyChip(1); /* reset wan port */
		
	return 0;
}
/* norton -- */

//af_inet.c  inet_ioctl() 
int nata_ioctl(int cmd,void *arg)
{
	int ret=0;
	struct nata_req  req;
	int subcmd;

	copy_from_user(&req,arg,sizeof(struct nata_req));
	subcmd=req.cmd;		
	switch(subcmd)
	{
		case NATA_SET_PPPOE_HEADER:
			{
			 	int index = 0xff;
			 	
			 	NATA_Reset(&NATA_Table);

#ifdef ACCELERATE_SESSION1_ONLY
			 	NATA_Table.PPPoE_SessionID=req.type1.pppoe_header.sid;
			 	NATA_Table.PPPoE_PPP_Protocol=0x0021;
			 	NATA_Table.PPPoE_rmad=htonl(req.type1.pppoe_header.PPPoE_rmad);
			 	memcpy(NATA_Table.PPPoE_rmmac,req.type1.pppoe_header.remote_mac,6);
			 	NATA_Table.start_pppoe=req.type1.pppoe_header.start_pppoe;

			 	TRACE("PPPoE Set PPPoE Header\n");
			 	TRACE("SessionID:%d\n",NATA_Table.PPPoE_SessionID);
			 	TRACE("start_pppoe %d\n",NATA_Table.start_pppoe);
			 	TRACE("PPPoE_rmad ");dump_ip( NATA_Table.PPPoE_rmad);
#else
				NATA_Table.start_pppoe = req.type1.pppoe_header.start_pppoe;

				index = req.type1.pppoe_header.session;
				
				if( index >= 0 && index < PPPOE_MAX_SESSION )
				{
					printk("session=%d id=%04x\n", index, req.type1.pppoe_header.sid );
					NATA_Table.PPPoE_SessionID[index] = req.type1.pppoe_header.sid;
					NATA_Table.PPPoE_PPP_Protocol = 0x0021;
					NATA_Table.PPPoE_rmad = htonl(req.type1.pppoe_header.PPPoE_rmad);
					memcpy(NATA_Table.PPPoE_rmmac[index],req.type1.pppoe_header.remote_mac,6);
					printf("config pppoe rmac[%d] = %2x:%2x:%2x:%2x:%2x:%2x\n", index,
						NATA_Table.PPPoE_rmmac[index][0],
						NATA_Table.PPPoE_rmmac[index][1],
						NATA_Table.PPPoE_rmmac[index][2],
						NATA_Table.PPPoE_rmmac[index][3],
						NATA_Table.PPPoE_rmmac[index][4],
						NATA_Table.PPPoE_rmmac[index][5] );
				}

#endif

			}
			break; 
		case NATA_START:
			 ret=NATA_Start();
			 break;
		case NATA_STOP :
			 ret=NATA_Stop();
			 break;
		case NATA_RESET :		
			 ret=NATA_Reset(&NATA_Table);			 
			 break;	
		case NATA_SET_MAC0 :
			ret = NATA_SetMAC(0, req.type1.mac );
			break;
		case NATA_SET_MAC1 :
			ret = NATA_SetMAC(1, req.type1.mac );
			break;
		/*-- norton  2005/08/05 */
		case NATA_SET_WAN_DUPLEX:
			ret = NATA_SetDuplex( req.type1.duplex );
			break;
		/* norton -- */
		default:
			printk("NATA default\n");
			break;
	}	
	return 0;
}

extern struct neigh_table arp_tbl;	
int NATA_Add_Entry(NATA_ENTRY *entry)
{

	 struct neighbour * neigh;
	 struct net_device * dev;
	 char Lan_Habuf[ETH_ALEN];
	 char Wan_Habuf[ETH_ALEN];
	 struct _NATA_Table* pTable=&NATA_Table;
	 NATA_ENTRY *pNATA_Entry=NULL;
	 struct ip_conntrack *ct;
	 unsigned long flags; 
	 int i;

	 /*Check */
	 if(pTable->size<=0)
	 {		
	 	//TRACE("Add entry faild:No Entry Size %d \n",pTable->size);
	 	// printk("$");
	 	return -1; //no space	 	
	 }

	 if(!Is_NATA_Table_Start())
	 {
	 	TRACE("Add entry faild :Table stop\n");
	 	return -1;
	 }

	 /*lookup LAN eth address  */
	 dev=&w740_netdevice[LAN];
	 neigh= neigh_lookup(&arp_tbl, &entry->lsad, dev);
	 if(neigh==NULL)
	 {
		struct dst_entry *locdst =NULL;
		struct rtable *rt =NULL;
		struct rt_key key = { 
			dst:entry->lsad,
			src:0,
			oif:dev->ifindex, 
			tos:0
		};

		DEBUGP("ip_route_output_key(): %u.%u.%u.%u\n", NIPQUAD(entry->lsad));
		/* Trying to route the packet using the standard routing table. */
		if ( ip_route_output_key(&rt, &key)==0) {
			
			/* Success if no oif specified or if the oif correspond to the 
			 * one desired */
			locdst = &rt->u.dst;
			/*
			dst_release(skb->dst);
			skb->dst = &rt->u.dst;
			*/
			if((locdst)){
				struct rtable * rt=(struct rtable*)(locdst);

				neigh= neigh_lookup(&arp_tbl, &rt->rt_gateway, dev);
				if(neigh!=NULL)
				{
					memcpy(Lan_Habuf,neigh->ha,ETH_ALEN);
				}
				else
					DEBUGP("lookup LAN gatway %u.%u.%u.%u failed ! \n",NIPQUAD(rt->rt_gateway));
				//dst_release(locdst);
			}
			ip_rt_put(rt);
			
		}
#if 0
	 	//ct=(struct ip_conntrack *)entry->ct;
	 	// TRACE("Entry local:"); dump_ip(entry->lsad);
	 	printk("NATA_Add_Entry:neigh_lookup: %u.%u.%u.%u failed, use LocMac ",NIPQUAD(entry->lsad) );
		memcpy(Lan_Habuf,entry->LocMAC,ETH_ALEN);
	 	
		printk(": %x:%x:%x:%x:%x:%x\n",Lan_Habuf[0],Lan_Habuf[1],\
	 	  	Lan_Habuf[2],Lan_Habuf[3],Lan_Habuf[4],Lan_Habuf[5]);
#endif

		if( neigh == NULL )
		{
			DEBUGP("Add entry faild:lookup LAN %u.%u.%u.%u failed ! \n",NIPQUAD(entry->lsad));
			return -1;//unknown the host, use cpu forwarding
		}

	 }
	 else
	 	memcpy(Lan_Habuf,neigh->ha,ETH_ALEN);	


	 /* lookup WAN eth address */
	 dev=&w740_netdevice[WAN];
	 if(!Is_NATA_Table_PPPoE()) {  
	 	
	 	neigh= neigh_lookup(&arp_tbl, &entry->rsad, dev);
	 	
	 	if(neigh==NULL)
	 	{ 
	 	   struct sk_buff* skb=entry->skb;
	 	  
	 	   if((skb->dst)){
	 	  		struct rtable * rt=(struct rtable*)(skb->dst);
	 	  		
	 	  		neigh= neigh_lookup(&arp_tbl, &rt->rt_gateway, dev);
	 	  		if(neigh!=NULL)
	 	  		{
	 	  			memcpy(Wan_Habuf,neigh->ha,ETH_ALEN);
	 	  		}			 
	 	  		else
	 	  		{
					DEBUGP("Add1 entry faild:lookup ETH1  WAN adress failed\n");	
		 	   		return -1;//unknown the host
	 	  		}	
	 	  			
	 	  		
		   }			
		   else
		   {
			struct dst_entry *locdst =NULL;
			struct rtable *rt =NULL;
			struct rt_key key = { 
				dst:entry->rsad,
				src:0,
				oif:dev->ifindex, 
				tos:0
			};

			DEBUGP("ip_route_output_key(): %u.%u.%u.%u\n", NIPQUAD(entry->rsad));
			/* Trying to route the packet using the standard routing table. */
			if ( ip_route_output_key(&rt, &key)==0) {
				
				/* Success if no oif specified or if the oif correspond to the 
				 * one desired */
				locdst = &rt->u.dst;
				/*
				dst_release(skb->dst);
				skb->dst = &rt->u.dst;
				*/
				if((locdst)){
					struct rtable * rt=(struct rtable*)(locdst);

					neigh= neigh_lookup(&arp_tbl, &rt->rt_gateway, dev);
					if(neigh!=NULL)
					{
						memcpy(Wan_Habuf,neigh->ha,ETH_ALEN);
					}
					else
						DEBUGP("lookup WAN gatway %u.%u.%u.%u failed ! \n",NIPQUAD(rt->rt_gateway));
					//dst_release(locdst);
				}
				ip_rt_put(rt);
				
			}
			else
			{
				DEBUGP("Add entry faild:lookup ETH1  WAN adress failed\n");	
				return -1;//unknown the host
			}
		   }
		 	
		}	
	 	else //eight
	 		memcpy(Wan_Habuf,neigh->ha,ETH_ALEN);		 
	 	
	 } //lan 
	 else	 /*PPPoE ISP Dial eth*/
	 {

#ifdef ACCELERATE_SESSION1_ONLY
		memcpy(Wan_Habuf,&NATA_Table.PPPoE_rmmac,6);
#else
		if( entry->session > 0 && entry->session < PPPOE_MAX_SESSION )
			memcpy(Wan_Habuf, &NATA_Table.PPPoE_rmmac[entry->session] ,ETH_ALEN);
#endif

	 }

	Disable_MAC_Int(flags);	 
	/* Lookup EMPTY Entry   */
	for(i=0;i<NATA_ENTRY_MAX;i++)
	{	/* found it*/
		pNATA_Entry=&pTable->table[i];
	 	if(pNATA_Entry->ct!=0)
	 	{
			if((pNATA_Entry->lsad==entry->lsad)&&(pNATA_Entry->lspn==ntohs(entry->lspn)))
			{
				TRACE("ct=%x  lsad:%x lspn:%x\n",ct,entry->lsad,entry->lspn);
				TRACE("Add entry Failed:Find old entry \n");
			 	Enable_MAC_Int(flags);	
				return -1;
			}
		}
		else
			break;
	}
	
	if(i==NATA_ENTRY_MAX)
	{
		TRACE("Add entry faild:No Entry Size %d \n",pTable->size);
		Enable_MAC_Int(flags);
		return -1;
	} 
    
	pNATA_Entry->tcp_times=entry->tcp_times;	 
	
	pNATA_Entry->ct=entry->ct;
	ct=(struct ip_conntrack *)pNATA_Entry->ct;
	ct->nata_index=pNATA_Entry->index;
        	 
	pNATA_Entry->proto=entry->proto;
	
	ct->is_cache=1;
	pTable->size--;
	{
		static unsigned int nata_add_time=0; 
		if(!(++nata_add_time%100))
			printk("NATA Table Size %d  Total add times: %d \n",pTable->size,nata_add_time);
	} 
	/*One month timeout if at table   */
	// ct->timeout.expires = jiffies + MONTH;//lsshi del 2003-5-21 17:02

	Enable_MAC_Int(flags);	  	 
	 //add_timer(&ct->timeout);

	 /*local */
	 //printk("ct=%x\n",ct);
	 pNATA_Entry->lsad=entry->lsad;
	 pNATA_Entry->lspn=entry->lspn;
	 pNATA_Entry->lspn=ntohs(entry->lspn);
	 TRACE("Entry %d local:", pNATA_Entry->index);	 dump_ip(pNATA_Entry->lsad);
	 TRACE(" port :%d \n",pNATA_Entry->lspn);
	 
	 /*remote*/
	 pNATA_Entry->rsad=entry->rsad;
	 pNATA_Entry->rspn=entry->rspn;
	 pNATA_Entry->rspn=ntohs(entry->rspn);
	 TRACE("remote :");dump_ip(pNATA_Entry->rsad);
	 TRACE(" port:%d \n",pNATA_Entry->rspn);
	
	 /*masquade*/
	 pNATA_Entry->msad=entry->msad;	 
	 pNATA_Entry->mspn=entry->mspn;
	 pNATA_Entry->mspn=ntohs(entry->mspn);
	 TRACE("masquade :");dump_ip(pNATA_Entry->msad);
	 TRACE("port :%d \n",(pNATA_Entry->mspn));
	 /*MAC Address */
	 memcpy(pNATA_Entry->LocMAC,Lan_Habuf,ETH_ALEN);
	 memcpy(pNATA_Entry->RsMAC ,Wan_Habuf,6);	 
	 
	 /*Write Entry register content   */
	 NAT_LSMAC_Config(pNATA_Entry->index,pNATA_Entry->LocMAC);
	 NAT_RSMAC_Config(pNATA_Entry->index,pNATA_Entry->RsMAC);

	 NAT_MASAD_Config(pNATA_Entry->index,(unsigned char *)&pNATA_Entry->msad);
	 NAT_MASPN_Config(pNATA_Entry->index,(unsigned short int *)&pNATA_Entry->mspn);
	 
	 NAT_LSAD_Config(pNATA_Entry->index,(unsigned char *)(&pNATA_Entry->lsad));
	 NAT_LSPN_Config(pNATA_Entry->index,(unsigned short int *)(&pNATA_Entry->lspn));
 
	 /*Write Entry register config  */
#define NATCFG_NAT  (NATCFG_ExEn|NATCFG_AxCE|NATCFG_PxCE|NATCFG_AxRE|NATCFG_PxRE)
	 NAT_Entry_Config(pNATA_Entry->index,NATCFG_NAT);
	  
	 
//	 pNATA_Entry->flag=NATA_ENTRY_FLAG_HEAD;	 
	 pNATA_Entry->time=jiffies;	

#ifdef ACCELERATE_SESSION1_ONLY

#else
	pNATA_Entry->session = entry->session;
#endif

	 return 0;	 
}

int Is_NATA_Table_Start()
{
	return NATA_Table.valid;
}

int Is_NATA_Table_PPPoE()
{

	return NATA_Table.start_pppoe;	
}		

//static inline _syscall1(void,UPnP_Disable_CT,unsigned long *,args);


asmlinkage void sys_UPnP_Disable_CT(unsigned long *args)
{
	unsigned long a[1];
	UPnP_CT* upnp_ct;
	UPnP_CT	  k_ct;
	
	unsigned long flags;
	int i=0;
	

	copy_from_user(a, args,4);
	upnp_ct=(UPnP_CT*)a[0];
	copy_from_user(&k_ct, upnp_ct,sizeof(UPnP_CT));
	
	Disable_MAC_Int(flags);
	
	for(i=0;i<NATA_ENTRY_MAX;i++)
	{
		if(NATA_Table.table[i].ct != 0)
		{
			if(( NATA_Table.table[i].proto==k_ct.Proto)&&
				(NATA_Table.table[i].msad==k_ct.ExtIP)&&
				(NATA_Table.table[i].mspn==k_ct.ExtPort))
		 	{
		 		printk("Found UPnP ct to be deleted !\n");
		 		((struct ip_conntrack *)NATA_Table.table[i].ct)->is_cache=0; //test ! should disable it otherwise kernel stateful state will not call NATA_AddEntry() again 
		 		disable_entry(i);
		 		NATA_Table.size++;
				//ip_ct_refresh(NATA_Table.table[i].ct,30*HZ); /* SIP connection, video audio connection */
				NATA_Table.table[i].ct=0;
		 	}
		}
	}//for end
	
	Enable_MAC_Int(flags);
	return ;
	
	
}

void disable_entry(int i)
{
//	struct ip_conntrack *ct;
//	unsigned long flags;
	if((i>NATA_ENTRY_MAX)||(i<0)) return ;
	
//	NATA_Table.table[i].flag=NATA_ENTRY_FLAG_EMPTY;
	NATA_Table.table[i].proto=0;
	NATA_Table.table[i].tcp_times=0;
	NATA_Table.table[i].lsad=0;
	NATA_Table.table[i].lspn=0;
	NAT_Entry_Disable(i);
	//printk("NATA %d entry Disalbe\n",i);
}

static void NATA_Entry_Timeout(unsigned long arg)
{
	int i;
	unsigned long flags; 
	static unsigned long iterator = 0;
	
	for(i=0;i<NATA_ENTRY_MAX;i++)
	{
		Disable_MAC_Int(flags);	 		
		 if(NATA_Table.table[i].ct != 0)
		 { 
		 	if( NATA_Table.table[i].proto==NATA_TCP)
			{
				if((NATA_Table.table[i].time+TCP_TIMEOUT*HZ)<=jiffies)
			  	{
//#ifdef XX	/* why we should do this */
					//if we don't do that, some session will have 3600 sec timeout even if in TIMEWAIT state
					if( (NATA_Table.table[i].tcp_times<2) ||
						is_ip_conntrack_closing( NATA_Table.table[i].ct ) )	/* not added by ip_nat_core.c */
					{
						ip_ct_refresh_close(NATA_Table.table[i].ct,60*HZ); //original is 3*HZ  test??
					}

//#endif					 
					((struct ip_conntrack *)NATA_Table.table[i].ct)->is_cache=0;
					disable_entry(i);
					NATA_Table.size++;
					NATA_Table.table[i].ct=0;
				}
				else
				{
					/* do ip_ct_refresh each 2*4 secs */

					if( ((iterator & 0x7) == 4 ) && (jiffies - NATA_Table.table[i].time) <(5*HZ) )
					{
						if( NATA_Table.table[i].tcp_times == 2 &&
							is_ip_conntrack_closing( NATA_Table.table[i].ct ) ==0 ) /* reset life time only when connection is not in closing */
							ip_ct_refresh(NATA_Table.table[i].ct, IPT_TCP_TIMEOUT*HZ);
					}
					
				}
				   
			}
			else
			{
				if( (NATA_Table.table[i].time+UDP_TIMEOUT*HZ)<=jiffies)//lsshi modify 2003-5-21 18:03
				{
					((struct ip_conntrack *)NATA_Table.table[i].ct)->is_cache=0;
					disable_entry(i);
					NATA_Table.size++;
					NATA_Table.table[i].ct=0;
				}
				else 
				{
					/* do ip_ct_refresh each 2*4 sec */
					
					if( ((iterator & 0x7) == 4 ) && (jiffies - NATA_Table.table[i].time) <(5*HZ) )
					{
						if( NATA_Table.table[i].rspn == DNS_PORT )
							ip_ct_refresh(NATA_Table.table[i].ct, IPT_DNS_TIMEOUT*HZ);
						else
							ip_ct_refresh(NATA_Table.table[i].ct, IPT_UDP_TIMEOUT*HZ);
					}

				}
			}
		}

		Enable_MAC_Int(flags);	
	}

	iterator++;
	if( iterator > 1000 )
		iterator = 0;

	del_timer(&NATA_Table.timer);
	NATA_Table.timer.expires =jiffies+2*HZ;
	add_timer(&NATA_Table.timer);
   
}

void nata_init(void);

void nata_init()
{
	printk("Winbond NATA v0.9\n");
	NATA_Table_Init(&NATA_Table);
	init_timer(&NATA_Table.timer);
	NATA_Table.timer.expires =jiffies+2*HZ;
	NATA_Table.timer.data = (unsigned long) NULL;
	NATA_Table.timer.function = &NATA_Entry_Timeout;
		
	NATA_Table.WanIp=0;
	NATA_Table.LanIp=0;
	NATA_Table.start_pppoe=0;	
	NATA_Start();	
}

module_init(nata_init);

