#ifndef __USB_PRISM_WIRELESS_H__
#define __USB_PRISM_WIRELESS_H__
#include <linux/config.h>
#include <linux/version.h>
#include <linux/module.h>
#include <linux/init.h>
#include <linux/fs.h>
#include <linux/vmalloc.h>
#include <linux/slab.h>
#include <linux/proc_fs.h>
#include <linux/ctype.h>
#include <linux/pagemap.h>
#include <asm/io.h>
#include <asm/semaphore.h>
#include <asm/processor.h>
#include <linux/wrapper.h>

#include <linux/netdevice.h>
#include <linux/etherdevice.h>
#include <linux/if_arp.h>
#include <linux/ip.h>
#include <linux/tcp.h>
#include <linux/in.h>
#include <linux/skbuff.h>
#include <linux/wireless.h>

#include <linux/usb.h>
#if defined (__i386__)
	#include <asm/cpufeature.h>
#endif

//#define info(format, arg...) printk( ": " format "\n" , ## arg)
#define KDEBUG(format, arg...) printk("%d:" format "\n", __LINE__, ## arg);
#define UPDEBUG
/*vendor ID and product ID */
//#define PRISM_VENDOR 0x9aa
//#define PRISM_PRODUCT 0x3642
#define PRISM_VENDOR 0x83a
#define PRISM_PRODUCT 0x3501

struct usb_prism {
	struct net_device ndev;
	/* Device structure */
	struct usb_device *dev;
	struct urb irq;
	unsigned char iface;
	wait_queue_head_t wq;	/* Processes waiting */
	struct semaphore lock;	/* params lock for this camera */
};


static void * uprism_probe(struct usb_device *dev, unsigned int ifnum, const struct usb_device_id *id);
static void uprism_disconnect(struct usb_device *dev, void *ptr);

#endif
