/* FTP extension for IP connection tracking. */
#include <linux/module.h>
#include <linux/netfilter.h>
#include <linux/ip.h>
#include <linux/ctype.h>
#include <net/checksum.h>
#include <net/udp.h>
#include <net/tcp.h>
#include <linux/netfilter_ipv4/lockhelp.h>
#include <linux/netfilter_ipv4/ip_conntrack_helper.h>




DECLARE_LOCK(ip_http_host_lock);
//struct module *ip_conntrack_ftp = THIS_MODULE;
struct module *ip_conntrack_http_host = THIS_MODULE;

#define MAX_PORTS 1
static int ports[MAX_PORTS];
static int ports_c;


#define MAX_URL	100
#define MAX_COUNT 20

#if 1
#define DEBUGP printk
#else
#define DEBUGP(format, args...)
#endif

static char compare_flag;
static char valid_count;

extern struct http_list search[20];
extern char compare_flag;
extern char valid_count;









void strlwr(char *source_str)
{
	
	
	while(*source_str)
	{
		if((*source_str>='A')&&(*source_str<='Z'))
			*source_str=*source_str+32;
				
		source_str++;
	}
	

	return;
}

/* Return 1 for match, 0 for accept, -1 for partial. */
static int find_pattern(const char *data,const char *pattern )
{
	
	int i,j;
	int dns_len;
	int p_len;
	char* p;
	char* temp_pattern;
	
	//DEBUGP("Http find_pattern `%s': dlen = %u\n", pattern, dlen);
	char* temp;
	
	
	///Find the Host: ...
	
	
	
	
	
	///////////////////////////
	
	
	
	if(*(data+2)!=0x01)
	{
		printk("Not valid DNS lookup...\n");
		if(compare_flag==0)
			return 0;
		else
			return 1;
	}
			
	//printk("*(data+2)===%x\n",*(data+2));
	
	//for(i=0;i<10;i++)
	//	printk("data[%d]===%x\n",i,data[i]);
	
	p_len=strlen(pattern);
	
	if(p_len==0)
	{
		printk("Zero length \n");
		if(compare_flag==0)
			return 0;
		else
			return 1;
	}
		
	dns_len=strlen(data+13);
	
	if(dns_len==0)
	{
		
		if(compare_flag==0)
			return 0;
		else
			return 1;
	}
		
	
	
	
	
	temp=kmalloc(dns_len+1,GFP_KERNEL);
	
	if(temp==0)
	{
		printk("kmalloc error pppppppppppppppp\n");
		return 0;
	}
	
	memcpy(temp,data+13,dns_len);
		
	temp[dns_len]='\0';
	
	//convert temp to low case
	
//	printk("DNS url 1=== %s,%d\n",temp,dns_len);
	
	strlwr(temp);
	
	
	
	j=0;
	
	while(j<dns_len)
	{
		
	if(((temp)[j]>=0x01)&&(temp)[j]<=0x20)
	{		
			(temp)[j]=0x2e;
			j++;
	}
		else
			j++;
		
		
	}
	
	
	
	//printk("pattern ===%s\n",pattern);
	
	printk("DNS url === %s,%d\n",temp,dns_len);
	
	if((pattern[0]=='*')&&(pattern[p_len-1]=='*'))
	{
		p=pattern+1;
		
		temp_pattern=kmalloc(p_len,GFP_KERNEL);
	
		if(temp_pattern==0)
		{
			printk("kmalloc temp_pattern error\n");
			return 0;
		}
	
		memset(temp_pattern,0,p_len);
		
		strncpy(temp_pattern,p,p_len-2);
		
		//printk("temp_pattern=%s\n",temp_pattern);
		//printk("temp =%s\n",temp);
		
		if(strstr(temp,temp_pattern)==0) {
		
			printk("No wide card match \n");
			kfree(temp);
			kfree(temp_pattern);
			return 0;
			
		}
		
	}
	else
	{
		
	if (strcmp(temp, pattern) != 0) {
	
		printk("No match \n");
		kfree(temp);
		return 0;
	}
	
	}
	
	

	kfree(temp);
	
	return 1;
}

/* FIXME: This should be in userspace.  Later. */
static int filter_help(const struct iphdr *iph, size_t len,
		struct ip_conntrack *ct,
		enum ip_conntrack_info ctinfo)
{
	
	struct tcphdr *tcph = (void *)iph + iph->ihl * 4;
	const char *data = (const char *)tcph + tcph->doff * 4;
	unsigned int tcplen = len - iph->ihl * 4;
	unsigned int datalen = tcplen - tcph->doff * 4;
	
	
	int dir = CTINFO2DIR(ctinfo);

	unsigned int i;
	int found = 0;

#ifdef CONFIG_IP_NF_ALG	
	
	if(Check_Filter_IP(ct,dir)<0)
	{
	//	printk("Http NF_DROP \n");
		return NF_DROP;
	}
	
#endif
	
     LOCK_BH(&ip_http_host_lock);
     
     //printk("IN UDP Help ...\n");
	
	if (IP_CT_DIR_ORIGINAL != dir) {
		
		UNLOCK_BH(&ip_http_host_lock);
		return NF_ACCEPT;
		
		
	}
	
	if(valid_count==0)
	{
		UNLOCK_BH(&ip_http_host_lock);
		return NF_ACCEPT;
	}
	

	/* Not whole UDP header */
	if (tcplen < sizeof(struct tcphdr)) {
		printk("Not whole TCP headeru\n");
		UNLOCK_BH(&ip_http_host_lock);
		return NF_ACCEPT;
	}
	
	
//////////////////////////////////////////////////////////////////	
	printk("Before find_pattern \n");

	

	for (i = 0; i < valid_count; i++) {
		

		found = find_pattern(data,search[i].url);
				     
		if (found) break;
	}
	
	
	if(compare_flag==0)
	{
		printk("In block status...\n");
		
		if (found == 1) {
			printk("We found something ...... \n");
			UNLOCK_BH(&ip_http_host_lock);
			return NF_DROP;
		} 
		else if (found == 0) /* No match */
		{
			printk("We found nothing ...... \n");
			
			UNLOCK_BH(&ip_http_host_lock);
			return NF_ACCEPT;
		}
	}
	else
	{
		printk("In allow status...\n");
		if (found == 1) {
			printk("allow We found something ...... \n");
			UNLOCK_BH(&ip_http_host_lock);
			return NF_ACCEPT;
		} 
		else if (found == 0) /* No match */
		{
			printk("allow We found nothing ...... \n");
			
			UNLOCK_BH(&ip_http_host_lock);
			return NF_DROP;
		}
		
	}
	
	

	
}

static struct ip_conntrack_helper http_host;

/* Not __exit: called from init() */
static void fini(void)
{
	int i;
	for (i = 0; (i < MAX_PORTS) && ports[i]; i++) {
		DEBUGP("ip_ct_ftp: unregistering helper for port %d\n",
				ports[i]);
		ip_conntrack_helper_unregister(&http);
	}
}

static int __init init(void)
{
	int i, ret;
	
	printk("In  URL Filter conntrack init \n");

	if (ports[0] == 0)
	{
		ports[0] = 80;
	}
		

	for (i = 0; (i < MAX_PORTS) && ports[i]; i++) {
		memset(&http, 0, sizeof(struct ip_conntrack_helper));
		
		http_host.tuple.src.u.udp.port = htons(ports[i]);
		http_host.tuple.dst.protonum = IPPROTO_TCP;
		http_host.mask.src.u.udp.port = 0xFFFF;
		http_host.mask.dst.protonum = 0xFFFF;
		http_host.max_expected = 0;//lsshi add
		http_host.timeout = 0;
		http_host.flags = IP_CT_HELPER_F_REUSE_EXPECT;
		http_host.me = ip_conntrack_http;
		http_host.help = filter_help;
		
		
		
		DEBUGP("ip_ct_http_host: registering helper for port %d\n", 
				ports[i]);
		ret = ip_conntrack_helper_register(&http_host);

		if (ret) {
			fini();
			return ret;
		}
		ports_c++;
	}
	
	compare_flag=0;
	valid_count=0;
	
	//strcpy(search[0].url,"www.yahoo.com");
	
	return 0;
}




module_init(init);
module_exit(fini);
